#include <iostream>
#include <vector>
#include <string>
using namespace std;

bool ask(int l, int r)
{
	cout << "? " << l << " " << r << endl;
	string s;
	cin >> s;
	return s == "Yes";
}

int main()
{
	int n;
	cin >> n;
	string ans(n, '(');
	ans.back() = ')';
	
	vector<int> pos = { 1 };
	for (int i = 2; i < n; ++i)
	{
		if (pos.empty() || !ask(pos.back(), i))
		{
			pos.push_back(i);
		}
		else
		{
			pos.pop_back();
			ans[i - 1] = ')';
		}
	}

	cout << "! " << ans << endl;
}