#include <bits/stdc++.h>

#define endl "\n"

using namespace std;

const int INF = (int) 1e9 + 3;

map<int, pair<int, int>> all;

int get_size(const pair<int, pair<int, int>> &tuple) {
    return tuple.second.first - tuple.first;
}

bool is_okey(int le, int ri, int v) {
    map<int, pair<int, int>> curr(all.lower_bound(le), all.lower_bound(ri));
    if (curr.size() == 1) {
        return curr.begin()->second.second == v;
    }
    auto it = curr.begin();
    while (it != curr.end()) {
        if (it->second.second != v) {
            ++it;
            continue;
        }
        auto pit = curr.end();
        if (it != curr.begin()) {
            pit = --it;
            ++it;
        }
        auto nit = curr.end();
        if (++it != curr.end()) {
            nit = it;
        }
        --it;

        if (pit != curr.end()) {
            if (get_size(*it) > get_size(*pit) or pit->second.second == v) {
                int l = pit->first, r = it->second.first;
                curr.erase(curr.erase(pit));
                it = curr.insert({l, {r, v}}).first;
                nit = ++it;
                --it;
                if (nit != curr.end()) {
                    if (get_size(*it) > get_size(*nit) or nit->second.second == v) {
                        int l = it->first, r = nit->second.first;
                        curr.erase(curr.erase(it));
                        it = curr.insert({l, {r, v}}).first;
                    }
                }
            } else {
                if (nit != curr.end()) {
                    if (get_size(*it) > get_size(*nit) or nit->second.second == v) {
                        int l = it->first, r = nit->second.first;
                        curr.erase(curr.erase(it));
                        it = curr.insert({l, {r, v}}).first;
                        pit = --it;
                        ++it;
                        if (get_size(*it) > get_size(*pit) or pit->second.second == v) {
                            int l = pit->first, r = it->second.first;
                            curr.erase(curr.erase(pit));
                            it = curr.insert({l, {r, v}}).first;
                        }
                    } else {
                        ++it;
                    }
                } else {
                    ++it;
                }
            }
        } else {
            if (nit != curr.end()) {
                if (get_size(*it) > get_size(*nit) or nit->second.second == v) {
                    int l = it->first, r = nit->second.first;
                    curr.erase(curr.erase(it));
                    it = curr.insert({l, {r, v}}).first;
                } else {
                    ++it;
                }
            } else {
                ++it;
            }
        }
    }

    return curr.size() == 1 and curr.begin()->second.second == v;
}

void solve() {
    int q;
    cin >> q;
    for (int _ = 0; _ < q; ++_) {
        string s, t;
        cin >> s >> t;
        if (s.size() != t.size()) {
            cout << "No" << endl;
            continue;
        }

        int l = 0, v = s[0];
        for (int r = 0; r < s.size(); ++r) {
            if (s[r] != v) {
                all.insert({l, {r, v}});
                l = r;
                v = v == '+' ? '-' : '+';
            }
        }
        all.insert({l, {(int) s.size(), v}});
        all.insert({(int) s.size(), {(int) s.size(), v}});

        l = 0, v = t[0];
        bool is_bad = false;
        for (int r = 0; r < t.size(); ++r) {
            if (t[r] != v) {
                if (not(all.count(l) and all.count(r))) {
                    is_bad = true;
                    break;
                }
                if (not is_okey(l, r, v)) {
                    is_bad = true;
                    break;
                }
                l = r;
                v = v == '+' ? '-' : '+';
            }
        }
        if (not is_okey(l, (int) t.size(), v)) {
            is_bad = true;
        }

        cout << (is_bad ? "No" : "Yes") << endl;


        all.clear();
    }
}

int main() {
#ifdef MINE
    freopen("../input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}