#include <bits/stdc++.h>
using namespace std;

const int MAXN = 1000005;

char s[MAXN], t[MAXN];

int sign(char c) {
    if (c == '+') return 1;
    return -1;
}

bool check(vector<pair<int, int>> &bls_s, int type) {
    vector<pair<int, int>> st;
    for (int i = 0; i < bls_s.size(); i++) {
        if (st.empty()) {
            st.push_back(bls_s[i]);
            continue;
        }
        if (st.back().second == bls_s[i].second) {
            st.back().first += bls_s[i].first;
            if (bls_s[i].second == type) {
                int sz = st.back().first;
                st.pop_back();
                while (!st.empty() && sz > st.back().first) {
                    sz += st.back().first;
                    st.pop_back();
                    if (!st.empty()) {
                        sz += st.back().first;
                        st.pop_back();
                    }
                }
                st.push_back({sz, type});
            }
            continue;
        }
        if (bls_s[i].second == type) {
            int sz = bls_s[i].first;
            while (!st.empty() && sz > st.back().first) {
                sz += st.back().first;
                st.pop_back();
                if (!st.empty()) {
                    sz += st.back().first;
                    st.pop_back();
                }
            }
            st.push_back({sz, type});
        } else {
            if (bls_s[i].first >= st.back().first) {
                st.push_back(bls_s[i]);
            } else {
                int sz = st.back().first + bls_s[i].first;
                st.pop_back();
                while (!st.empty() && sz > st.back().first) {
                    sz += st.back().first;
                    st.pop_back();
                    if (!st.empty()) {
                        sz += st.back().first;
                        st.pop_back();
                    }
                }
                st.push_back({sz, type});
            }
        }
    }

    bool ok = true;
    for (auto p : st) {
        if (p.second == -type) {
            ok = false;
            break;
        }
    }

    return ok;
}

int main() {
    int q;
    scanf("%d", &q);

    for (int ii = 0; ii < q; ii++) {
        scanf("%s", s);
        scanf("%s", t);

        int n = strlen(s), m = strlen(t);
        if (n != m) {
            cout << "No\n";
            continue;
        }

        vector<pair<int, int>> bls_t;
        for (int i = 0; i < n; i++) {
            if (!bls_t.empty() && bls_t.back().second == sign(t[i])) {
                bls_t.back().first++;
            } else {
                bls_t.push_back({1, sign(t[i])});
            }
        }

        vector<pair<int, int>> bls_s;
        for (int i = 0; i < n; i++) {
            if (!bls_s.empty() && bls_s.back().second == sign(s[i])) {
                bls_s.back().first++;
            } else {
                bls_s.push_back({1, sign(s[i])});
            }
        }

        bool br = false;

        vector<int> frst, lst, want, cnf;

        int it = 0;
        for (int i = 0; i < bls_t.size(); i++) {
            int curlen = 0;
            vector<pair<int, int>> bls;
            while (curlen < bls_t[i].first && it < bls_s.size()) {
                bls.push_back(bls_s[it++]);
                curlen += bls.back().first;
            }

            if (curlen != bls_t[i].first) {
                cout << "No\n";
                br = true;
                break;
            }

            if (!check(bls, bls_t[i].second)) {
                cout << "No\n";
                br = true;
                break;
            }

            frst.push_back(bls[0].second);
            lst.push_back(bls.back().second);
            want.push_back(bls_t[i].second);
            cnf.push_back(0);
        }

        if (br) {
            continue;
        }

        set<pair<int, int>> st;
        for (int i = 0; i < want.size(); i++) {
            int confls = 0;
            if (i > 0 && want[i] == lst[i - 1]) {
                confls++;
            }
            if (i + 1 < want.size() && want[i] == frst[i + 1]) {
                confls++;
            }

            cnf[i] = confls;
            st.insert({cnf[i], i});
        }

        while (!st.empty()) {
            auto p = *st.begin();
            st.erase(st.begin());
            if (p.first != 0) {
                cout << "No\n";
                br = true;
                break;
            }

            int ind = p.second;
            frst[ind] = lst[ind] = want[ind];

            if (ind > 0) {
                int ind1 = ind - 1;
                if (st.count({cnf[ind1], ind1})) {
                    st.erase({cnf[ind1], ind1});
                    int confls = 0;
                    if (ind1 > 0 && want[ind1] == lst[ind1 - 1]) {
                        confls++;
                    }
                    if (ind1 + 1 < want.size() && want[ind1] == frst[ind1 + 1]) {
                        confls++;
                    }

                    cnf[ind1] = confls;
                    st.insert({cnf[ind1], ind1});
                }
            }
            if (ind + 1 < want.size()) {
                int ind1 = ind + 1;
                if (st.count({cnf[ind1], ind1})) {
                    st.erase({cnf[ind1], ind1});
                    int confls = 0;
                    if (ind1 > 0 && want[ind1] == lst[ind1 - 1]) {
                        confls++;
                    }
                    if (ind1 + 1 < want.size() && want[ind1] == frst[ind1 + 1]) {
                        confls++;
                    }

                    cnf[ind1] = confls;
                    st.insert({cnf[ind1], ind1});
                }
            }
        }

        if (br) {
            continue;
        } else {
            cout << "Yes\n";
        }
    }

    return 0;
}