#include <bits/stdc++.h>
#define ll long long
using namespace std;

const int K = 31;
int n;
bool a[1000000][K];
bool can[1000000][K];
int upp[K], downn[K];

inline bool equ (bool x1, bool x2) {
    return (x1 && x2) || ((!x1) && (!x2));
}

inline void perehod (int i, int bit, int one) {
    if (i < 0 || i >= n-1 || equ(a[i][bit], a[i+1][bit])) return;
    if (!a[i][bit]) upp[bit]+=one;
    if (a[i][bit]) downn[bit]+=one;
    //cerr << i << " " << bit << " " << one << " " << upp[bit] << " " << downn[bit] << " " << a[i][bit] << " " << a[i+1][bit] << "\n";
}

inline void set_can (int i, int bit, bool val) {
    if (can[i][bit] == val) return;
    else can[i][bit] = val;
    if (val) perehod(i, bit, -1);
    else perehod(i, bit, 1);
}

inline void set_a (int i, int bit, bool val) {
    if (a[i][bit] == val) return;
    if (!can[i][bit]) perehod(i, bit, -1);
    if (i != 0 && !can[i-1][bit]) perehod(i-1, bit, -1);
    a[i][bit] = val;
    if (!can[i][bit]) perehod(i, bit, 1);
    if (i != 0 && !can[i-1][bit]) perehod(i-1, bit, 1);
}

inline void refresh_can (int i, int bit) {
    if (bit == K-1) return;
    if (can[i][bit+1] || (i+1 < n && a[i][bit+1] != a[i+1][bit+1])) set_can(i, bit, true);
    else set_can(i, bit, false);
}

inline ll get_out() {
    ll out = 0;
    for (int bit = 0; bit < K; bit++) {
        if (upp[bit] && downn[bit]) return -1;
        if (!downn[bit]) continue;
        out += (ll)(1<<bit);
    }
    return out;
}

int main() {
    //freopen("input.txt", "r", stdin);

    scanf("%d", &n);
    memset(a, 0, sizeof a);
    memset(can, 0, sizeof can);
    memset(downn, 0, sizeof downn);
    memset(upp, 0, sizeof upp);

    for (int i = 0; i < n; i++) {
        int ai;
        scanf("%d", &ai);
        for (int bit = 0; bit < K; bit++) {
            if (ai&(1<<bit)) {
                set_a(i, bit, true);
            }
        }
    }

    for (int bit = K-1; bit >= 0; bit--) {
        for (int i = 0; i < n-1; i++) {
            refresh_can(i, bit);
        }
    }

    //cerr << "kek";
    cout << get_out() << "\n";
    int q; cin >> q;



    for (int zi = 0; zi < q; zi++) {
        int vi, ai; scanf("%d %d", &vi, &ai); vi--;

        for (int bit = K-1; bit >= 0; bit--) {
            bool new_val = false;
            if (ai&(1<<bit)) new_val = true;

            set_a(vi, bit, new_val);
            refresh_can(vi, bit);
            refresh_can(vi-1, bit);
            /*if (bit > 3) continue;
            for (int i = 0; i < 3; i++) cerr << upp[i] << " " << downn[i] << "; ";
            cerr << "\n";*/
        }

        printf("%lld\n", get_out());
    }
}
