//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>
#define ll long long
using namespace std;

const ll INF = 1e18;
int n;

int main() {
    //freopen("input.txt", "r", stdin);
    cin >> n;
    vector <ll> dpf_l(n);
    vector <ll> dpf_r(n);
    vector <ll> dpb_l(n);
    vector <ll> dpb_r(n);
    vector <ll> t(n);
    vector <ll> l(n);
    vector <ll> r(n);

    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }

    for (int i = 0; i < n-1; i++) {
        cin >> l[i] >> r[i];
    }

    dpf_l[n-1] = 0;
    dpf_r[n-1] = INF;
    for (int i = n-2; i >= 0; i--) {
        ll lj = dpf_l[i+1], rj = dpf_r[i+1];
        if(max(lj, l[i]) > min(rj, r[i])) {
            dpf_l[i] = dpf_r[i]+1;
            continue;
        }
        else if (l[i] < lj) {
            dpf_l[i] = lj;
        }
        else {
            dpf_l[i] = l[i]-t[i];
        }
        dpf_r[i] = min(rj, r[i]);
        dpf_l[i] = max(dpf_l[i], 0ll);
    }

    dpb_l[0] = 0;
    dpb_r[0] = INF;
    for (int i = 1; i < n; i++) {//!dpb
        ll lj = dpb_l[i-1], rj = dpb_r[i-1];
        if(max(lj, l[i-1]) > min(rj, r[i-1])) {
            dpb_l[i] = dpb_r[i]+1;
            continue;
        }
        else if (l[i-1] < lj) {
            dpb_l[i] = lj;
            //cerr << i << " + " << dpb_l[i] << "\n";
        }
        else {
            dpb_l[i] = l[i-1] - t[i];
            //cerr << i << " - " << dpb_l[i] << "\n";
        }
        dpb_r[i] = min(rj, r[i-1]);
        dpb_l[i] = max(dpb_l[i], 0ll);
    }

    for (int i = 0; i < n; i++) {
        ll outl = max(dpb_l[i], dpf_l[i]), outr = min(dpb_r[i], dpf_r[i]);
        //cout << dpf_l[i] << " " << dpf_r[i] << " " << dpb_l[i] << " " << dpb_r[i] << "\n";
        if (outl <= outr) cout << outl << "\n";
        else cout << "-1\n";
    }
}
