#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>
#include <vector>
#include <set>
#include <fstream>
#include <string>
#include <map>

using namespace std;

const int MAX = (int)1e6 + 13;

int n, q;

int a[MAX];

int old_bit(int x, int y) {
	int ans = -1;
	for (int i = 0; i < 30; i++) {
		if ((x & (1 << i)) != (y & (1 << i)))
			ans = i;
	}
	return ans;
}

int zn(int x) {
	if (x > 0)
		return 1;
	else
		return -1;
}

int bit[2][31];

pair<int, int> last[MAX];

void count() {
	for (int i = 1; i < n; i++) {
		int x = a[i], y = a[i + 1];
		int b = old_bit(x, y);
		int need = (x > y);
		bit[need][b]++;
		last[i] = make_pair(b, need);
	}
}

int solve() {
	for (int i = 0; i < 31; i++) {
		if (bit[0][i] > 0 && bit[1][i] > 0)
			return -1;
	}

	int ans = 0;

	for (int i = 0; i < 31; i++) {
		if (bit[1][i] > 0)
			ans += (1 << i);
	}

	return ans;
}

void update(int pos, int val) {
	if (pos > 1) {
		bit[last[pos - 1].second][last[pos - 1].first]--;
		a[pos] = val;
		int x = a[pos - 1], y = a[pos];
		int b = old_bit(x, y);
		int need = (x > y);
		bit[need][b]++;
		last[pos - 1] = make_pair(b, need);
	}
	if (pos < n) {
		bit[last[pos].second][last[pos].first]--;
		a[pos] = val;
		int x = a[pos], y = a[pos + 1];
		int b = old_bit(x, y);
		int need = (x > y);
		bit[need][b]++;
		last[pos] = make_pair(b, need);
	}
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(0);
	//ifstream cin("tests.txt");
	
	cin >> n;
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}

	count();

	cout << solve() << endl;

	cin >> q;

	for (int i = 1; i <= q; i++) {
		int pos, val;
		cin >> pos >> val;
		update(pos, val);
		cout << solve() << endl;
	}

	return 0;
}

