#define _CRT_SECURE_NO_DEPRECATE

#include<string>
#include<cstring>
#include<vector>
#include<algorithm>
#include<cmath>
#include<iostream>
#include<cstdlib>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

void solve();
#define mp(x, y) make_pair(x, y)
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}



ll a, n;

const int inf = (1ll << 31ll) - 1ll;
void solve1() {
	ll x, y, z;
	cin >> x >> y >> z;
	ll L = 0;
	ll R = 0;
	ll k = 0;
	ll c = 0;
	ll ans = 0;
	while (true) {
		++k;
		L += x;
		R += y;
		c += z;
		if (R >= a) {
			ans = max(max(0, (R - y - abs(R - a) + 1ll)) * 1000000000ll - (c), ans);
			break;
		}
		else
			ans = max(L * 1000000000ll - c, ans);
	}
	cout << ans << endl;
	exit(0);
}

int dp[1001];
void solve2() {
	fill(dp, dp + 1001, inf);
	dp[0] = 0;
	while (n--) {
		int x, y, z;
		cin >> x >> y >> z;
		for (int i = 0; i <= a; ++i)
			if (dp[i] != inf && i + x <= a)dp[i + x] = min(dp[i] + z, dp[i + y]);
	}
	ll ans = 0;
	for (int i = 0; i <= a; ++i) {
		if (dp[i] != inf)ans = max(1000000000ll * i - dp[i], ans);
	}
	cout << ans << endl;
}

void solve() {
	cin >> n >> a;
	if (n == 1)solve1();
	if (n > 1)solve2();
}