#include <cstdio>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <bitset>

using namespace std;

struct pt {
    int x, y;
};

bool cw(pt a, pt b, pt c) {
    return ((b.x - a.x) * (c.y - a.y) - (c.x - a.x) * (b.y - a.y)) < 0;
}

bool isin(pt a, pt b, pt c, pt t) {
    if(cw(a, b, c) == cw(a, b, t) && cw(a, b, c) == cw(a, t, c))
        if(cw(b, c, a) == cw(b, c, t) && cw(b, c, a) == cw(b, t, a))
            return true;
    return false;
}

vector <pt> ret;
int n;

void find_ans() {
    string nowans;
    for(int i = 0; i < n; i++) for(int j = i + 1; j < n; j++) for(int k = j + 1; k < n; k++) {
        cout << "? 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
        cin >> nowans;
        if(nowans == "Yes") {
            bool ok = true;
            for(int l = 0; l < n; l++) {
                if(l != i && l != j && l != k && isin(ret[i], ret[j], ret[k], ret[l])) ok = false;
            }
            if(ok) {
                cout << "! 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
                return;
            }
        }
    }
    cout << 1 / 0;
}

int main()
{
    cin >> n;
    ret.resize(n);
    for(int i = 0; i < n; i++)
        cin >> ret[i].x >> ret[i].y;

    //go
    int q;
    cin >> q;
    for(int iter = 0; iter < q; iter++) {
        find_ans();
    }

    return 0;
}
