#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>
#define SZ(v) (int)v.size()
#define X first
#define Y second
#define p(x,y) pair<x,y>
using namespace std;
typedef long long ll;
void solve();
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
}
const int N = 5005;
const long long INF = (1LL << 61);
const long long inf = 1e9;
int n, l[N], r[N], t[N];
bool dp1[N][N];
bool dp2[N][N];

void solve() {
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> t[i];
	for (int i = 1; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	for (int T = 0; T < N; T++)
		dp1[n][T] = dp2[1][T] = 1;
	for (int i = n - 1; i >= 1; i--) {
		for (int T = 0; T < N; T++) {
			if (T < l[i] && T + t[i] >= l[i])
				dp1[i][T] |= dp1[i + 1][l[i]];
			else if (l[i] <= T && T <= r[i])
				dp1[i][T] |= dp1[i + 1][T];
		}
	}
	for (int i = 2; i <= n; i++) {
		for (int T = 0; T < N; T++) {
			if (T < l[i - 1] && T + t[i] >= l[i - 1])
				dp2[i][T] |= dp2[i - 1][l[i - 1]];
			if (T >= l[i - 1] && T <= r[i - 1])
				dp2[i][T] |= dp2[i - 1][T];
		}
	}
	for (int i = 1; i <= n; i++) {
		int ans = -1;
		for (int T = 0; T < N; T++)
			if (dp1[i][T] && dp2[i][T] && ans == -1)
				ans = T;
		cout << ans << endl;
	}	
}