#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>

using namespace std;
typedef long long ll;

int solve();

int main() {
#ifdef ROII
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)2e6 + 1;
int l[dd], r[dd], c[dd];
ll dp[dd];
ll ans;

void upd(ll &a, ll b) { if (a < b) a = b; }

int solve() {
	int n, a;
	scanf("%d %d", &n, &a);

	int cmin = (int)1e9;

	for (int i = 0; i < n; i++) {
		scanf("%d %d %d", &l[i], &r[i], &c[i]);
	}

	if (n == 1) {
		ll ans = 0;
		ll L = 0, R = 0, cost = 0;

		for (int cnt = 0; ; cnt++) {

			if (L + r[0] > a) break;

			L += l[0];
			R += r[0];
			cost += c[0];

			ans = max(ans, L * (ll)1e9 - cost);

		}
		printf("%lld\n", ans);
		return 0;
	}

	fill(dp, dp + dd, -1);

	dp[0] = 0;

	for (int w = 0; w < a; w++) {
		if (dp[w] == -1) continue;

		for (int i = 0; i < n; i++) {

			if (w + r[i] > a) continue;

			for (int j = w + l[i]; j <= w + r[i]; j++) {
				dp[j] = max(dp[j], dp[w] + c[i]);
			}

		}
	}
	
	ans = (ll)1e18;
	for (int w = 0; w <= a; w++) {
		if (w + r[0] > a)
		ans = min(ans, (ll)1e9 * w - dp[w]);
	}
	printf("%lld\n", ans);
	return 0;
}