#include <iostream>
#include <vector>
#include <queue>
#include <cstdlib>
#include <string>
#include <stack>
#include <algorithm>
#include <cmath>
#include <unordered_set>

using namespace std;

vector<vector<pair<int, int> > > cl;
vector<vector< pair<int, int> > > way;
vector<int> len;
vector<int> relaxed;
vector<int> mxres;

int get_res(int v)
{
  if (mxres[v] != -1)
    return mxres[v];
  int mx = 0;
  for (auto i : way[v])
    mx = max(mx, get_res(i.first) + i.second * i.second);
  return mx;
}

int main(void)
{
  int n, m;
  ios::sync_with_stdio(0);
  cin >> n >> m;
  cl.resize(n);
  way.resize(n);
  len.resize(n);
  relaxed.resize(n);
  mxres.resize(n);
  int cnt = 1;
  for (int i = 0; i < n; i++)
    relaxed[i] = 0, len[i] = -1, mxres[i] = -1;
  len[0] = 0;
  mxres[0] = 0;
  for (int i = 0; i < m; i++)
  {
    int s, v, t, u;
    cin >> s >> v >> t >> u;
    cl[v - 1].push_back(make_pair(u - 1, t));
  }
  while (1)
  {
    int mn = -1;
    for (int i = 0; i < n; i++)
      if (!relaxed[i])
        if (mn == -1)
          mn = i;
        else if (len[i] != -1 && len[mn] > len[i])
          mn = i;
    if (mn == -1 || len[mn] == -1)
      break;
    for (auto &i : cl[mn])
    {
      if (len[i.first] == -1)
        len[i.first] = len[mn] + i.second, way[i.first].push_back(make_pair(mn, i.second));
      else if (len[i.first] == len[mn] + i.second)
        way[i.first].push_back(make_pair(mn, i.second));
      else if (len[i.first] > len[mn] + i.second)
      {
        len[i.first] = len[mn] + i.second;
        way[i.first].clear();
        way[i.first].push_back(make_pair(mn, i.second));
      }
    } 
    relaxed[mn] = true;
  }
  cout << len[n - 1] << " " << get_res(n - 1) << endl;
  return 0;
}