#include <iostream>
#include <bitset>

using namespace std;

const int maxn = 510;
int a[maxn], b[maxn], c[maxn], d[maxn];
int n, m;
bitset<maxn> used;
int a1, a2;
int b1, b2;
int main()
{
    cin >> n >> m;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    for (int i = 0; i < n; ++i)
        cin >> b[i];
    for (int i = 0; i < m; ++i)
        cin >> c[i];
    for (int i = 0; i < m; ++i)
        cin >> d[i];
    for (int i = 1; i < n; ++i)
        b[i] += b[i - 1];
    for (int i = 1; i < m; ++i)
        d[i] += d[i - 1];
    int ans = 0;

    for (int l1 = 0; l1 < n; ++l1)
        for (int r1 = l1; r1 < n; ++r1)
    {
        used.reset();
        for (int k = l1; k <= r1; ++k)
            used[a[k]] = 1;
        for (int l2 = 0; l2 < m; ++l2)
        {
            int pos = 0;
            if (used[c[l2]])
                continue;
            for (pos = l2; pos < m; ++pos)
                if (used[c[pos]])
                    break;
            pos--;
            int s1 = 0, s2 = 0;
            if (l1 == 0)
                s1 = b[r1];
            else
                s1 = b[r1] - b[l1 - 1];

            if (l2 == 0)
                s2 = d[pos];
            else
                s2 = d[pos] - d[l2 - 1];
            if (s1 + s2 > ans)
            {
                ans = s1 + s2;
                a1 = l1 + 1;
                a2 = r1 + 1;
                b1 = l2 + 1;
                b2 = pos + 1;
            }
        }
    }
    for (int i = 0; i < n; ++i)
        for (int j = i; j < n; ++j)
    {
        int s1 = 0;
        if (i == 0)
            s1 = b[j];
        else
            s1 = b[j] - b[i - 1];
        if (s1 > ans)
        {
            ans = s1;
            a1 = i + 1, a2 = j + 1, b1 = 0, b2 = 0;
        }
    }
    for (int i = 0; i < m; ++i)
        for (int j = i; j < m; ++j)
    {
        int s1 = 0;
        if (i == 0)
            s1 = d[j];
        else
            s1 = d[j] - d[i - 1];
        if (s1 > ans)
        {
            ans = s1;
            a1 = 0, a2 = 0, b1 = i + 1, b2 = j + 1;
        }
    }
    cout << ans << endl;
    cout << a1 << " " << a2 << endl;
    cout << b1 << " " << b2 << endl;
    return 0;
}
