#include <iostream>
#include <vector>
#include <set>

using namespace std;

int n, m;
vector<pair<int, int> >* g;

inline void input() {
  cin >> n >> m;
  g = new vector<pair<int, int> >[n];
  for (int i = 0; i < m; i++) {
    int s, v1, len, v2;
    cin >> s >> v1 >> len >> v2;
    g[v1 - 1].push_back(make_pair(len, v2 - 1));
  }
}

int D() {
  vector<bool> used(n, false);
  #define INF 2 * 1e9
  int d[n], d1[n];
  for (int i = 0; i < n; i++)
    d[i] = INF;
  for (int i = 0; i < n; i++)
      d1[i] = - INF;
  set< pair<int, pair<int, int> > > q;
  d[0] = 0;
  d1[0] = 0;
  q.insert(make_pair(d[0], make_pair(d1[0], 0)));
  while (!q.empty()) {
    int v = q.begin()->second.second;
    int dist = q.begin()->first;
    int distq = q.begin()->second.first;
    q.erase(q.begin());
    used[v] = true;
    #define to g[v][i].second
    #define len g[v][i].first
    for (int i = 0; i < g[v].size(); i++) {
      if (!used[to]) {
        used[to] = true;
        d[to] = dist + len;
        d1[to] = distq + len * len;
        q.insert(make_pair(d[to], make_pair(d1[to], to)));
      } else {
        if (d[to] < dist + len || (d[to] == dist + len && d1[to] < distq + len * len)) {
          q.erase(make_pair(d[to], make_pair(d1[to], to)));
          d[to] = dist + len;
          d1[to] = distq + len * len;
          q.insert(make_pair(d[to], make_pair(d1[to], to)));
        }
      }
    }
  }
  for (int i = 0; i < n; i++) {
    cout << d[i] << ' ';
  }
  cout << endl;
  cout << d[n - 1] << ' ' << d1[n - 1] << endl;
}

int main() {
  input();
  D();
}
