#include <iostream>
#include <string>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <stdio.h>
#include <math.h>
#include <cmath>
#include <queue>
#include <deque>


using namespace std;

#define ll long long

const int N = 1000100;

struct block {
    int l, r;
    block(int b, int c) {
        l = b;
        r = c;
    }
};

bool operator<(block x, block y) {
    return (x.r - x.l + 1) > (y.r - y.l + 1);
}

bool need[N];

int lef[N], rig[N];

int main() {
    int q;
    cin >> q;
    for (int ev = 0; ev < q; ++ev) {
        string s, t;
        cin >> s >> t;
        vector< pair<int, int> > a;
        int n = (int)s.size(), m = (int)t.size();
        if (s == t) {
            cout << "Yes" << endl;
            continue;
        }
        for (int i = 0; i <= n; ++i) {
            need[i] = false;
            lef[i] = 0;
            rig[i] = 0;
        }
        int i = 0;
        while (i < n) {
            int j = i;
            while (j < n - 1 && s[j + 1] == s[j]) {
                ++j;
            }
            a.push_back({i, j});
            rig[i] = j;
            lef[j] = i;
            i = j + 1;
        }
        bool good = true;
        int sz = (int)a.size();
        if (sz == 1) {
                if (n > 16) return -1;
            cout << "No" << endl;
            continue;
        }
        vector<int> ch;
        for (int bl = 0; bl < sz; ++bl) {
            bool fir = false, sec = false;
            char c = '.';
            for (int i = a[bl].first; i <= a[bl].second; ++i) {
                if (s[i] != t[i]) {
                    fir = true;
                    c = t[i];
                } else {
                    sec = true;
                }
            }
            ch.push_back(c);
            if (fir && sec) {
                good = false;
                break;
            }
            if (c != '.') {
                for (int i = a[bl].first; i <= a[bl].second; ++i) {
                    need[i] = true;
                }
            }
        }

        if (!good) {
            if (n > 16) {
                return -1;
            }
            cout << "No" << endl;
            continue;
        }
        set<block> S;
        for (int bl = 0; bl < sz; ++bl) {
            int i = a[bl].first, j = a[bl].second;
            if (!need[i]) {
                continue;
            }
            if (i > 0) {
                if ((i - 1) - lef[i - 1] + 1 > j - i + 1) {
                    S.insert(block(lef[i - 1], i - 1));
                }
            }
            if (j < n - 1) {
                if (rig[j + 1] - (j + 1) + 1 > j - i + 1) {
                    S.insert(block(j + 1, rig[j + 1]));
                }
            }
        }
        while (!S.empty()) {
            block p = *S.begin();
            S.erase(S.begin());
            int i = p.l, j = p.r;
            if (i > 0 && need[i - 1] && j - i + 1 > (i - 1) - lef[i - 1] + 1) {
                for (int x = lef[i - 1]; x < i; ++x) {
                    need[x] = false;
                    if (s[x] == '-') {
                        s[x] = '+';
                    } else {
                        s[x] = '-';
                    }
                }
            }
            while (i > 0 && s[i - 1] == s[i]) {
                --i;
            }
             if (need[j + 1] && j - i + 1 > rig[j + 1] - (j + 1) + 1) {
                for (int x = j + 1; x <= rig[j + 1]; ++x) {
                    need[x] = false;
                    if (s[x] == '-') {
                        s[x] = '+';
                    } else {
                        s[x] = '-';
                    }
                }
            }
           // cout << s << endl;
            while (j < n - 1 && s[j + 1] == s[j]) {
                ++j;
            }
            if (i > 0 && need[i - 1] && j - i + 1 > (i - 1) - lef[i - 1] + 1) {
                S.insert(block(i, j));
            } else if (j + 1 < n && need[j + 1] && j - i + 1 > rig[j + 1] - (j + 1) + 1) {
                S.insert(block(i, j));
            }
        }
        for (int i = 0; i < n; ++i) {
            if (need[i]) {
                good = false;
                break;
            }
        }
        if (good) {
            cout << "Yes" << endl;
        } else {
            cout << "No" << endl;
        }
    }
    return 0;
}
