#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <bitset>
#include <algorithm>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#define ll long long
#define mp make_pair
#define MOD 1000000007

using namespace std;

const ll mx = 2000;
const ll mx2 = 20;
const ll INF = 1000000000000000000ll;
const ll cost = 1000000000;
ll dp[mx], l[mx2], r[mx2], c[mx2], n, a;

int main()
{
    cin >> n >> a;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i] >> c[i];
    }
    if (n == 1) {
        ll ans = INF;
        for (ll ex = 0; ex <= a; ++ex) {
            ll L = ex*l[0];
            ll R = ex*r[0];
            ans = min(ans, max(L, (a-r[0]+1))*cost - c[0]*ex);
        }
        cout << ans << '\n';
        return 0;
    }
    for (int i = 0; i <= a; ++i) {
        dp[i] = INF;
    }
    dp[0] = 0;
    ll ans = 0;
    for (int i = 0; i <= a; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i + l[j] <= a)
                dp[i+l[j]] = min(dp[i+l[j]], dp[i] + c[j]);
        }
    }
    for (int i = 0; i <= a; ++i) {
        ans = max(ans, cost*i - dp[i]);
    }
    cout << ans << '\n';
    return 0;
}
