#include <iostream>
#include <fstream>
#include <vector>
#include <set>
#include <map>
#include <array>
#include <bitset>
#include <algorithm>
#include <string>
#include <cmath>
#include <stack>
#include <queue>
#include <deque>
#define ll long long
#define mp make_pair
#define MOD 1000000007

using namespace std;

const int mx = 2000;
ll n, m, a[mx], x[mx], b[mx], y[mx], px[mx], py[mx];
bool used[mx], used2[mx];

int main()
{
    cin >> n >> m;
    for (int i = 1; i <= n; ++i) {
        cin >> a[i];
    }
    for (int i = 1; i <= n; ++i) {
        cin >> x[i];
    }
    for (int i = 1; i <= m; ++i) {
        cin >> b[i];
    }
    for (int i = 1; i <= m; ++i) {
        cin >> y[i];
    }
    px[0] = 0;
    py[0] = 0;
    for (int i = 1; i <= n; ++i) {
        px[i] = px[i-1] + x[i];
    }
    for (int i = 1; i <= m; ++i) {
        py[i] = py[i-1] + y[i];
    }
    ll ans = 0, lb, rb, Lb, Rb;
    for (int l = 1; l <= n; ++l) {
        for (int r = l; r <= n; ++r) {
            for (int i = 0; i <= (n+m); ++i)
                used[i] = 0;
            for (int i = l; i <= r; ++i) {
                used[a[i]] = 1;
            }
            for (int i = 1; i <= m; ++i) {
                used2[i] = used[b[i]];
            }
            int lst = 0;
            for (int i = 1; i <= m; ++i) {
                if (used2[i] == 0) {
                    lst = i;
                    break;
                }
            }
            if (lst == 0) {
                if (px[r] - px[l-1] > ans) {
                    ans = px[r] - px[l-1];
                    lb = l;
                    rb = r;
                    Lb = 0;
                    Rb = 0;
                }
                continue;
            }
            for (int i = (lst+1); i <= m; ++i) {
                if ((used2[i] == 1) && (used2[i-1] == 0)) {
                    if ((px[r] - px[l-1] + py[i-1] - py[lst-1]) > ans) {
                        ans = (px[r] - px[l-1] + py[i-1] - py[lst-1]);
                        lb = l;
                        rb = r;
                        Lb = lst;
                        Rb = i-1;
                    }
                }
                if ((used2[i] == 0) && (used2[i-1] == 1)) {
                    lst = i;
                }
            }
            if (used2[m] == 0) {
                if ((px[r] - px[l-1] + py[m] - py[lst-1]) > ans) {
                    ans = (px[r] - px[l-1] + py[m] - py[lst-1]);
                    lb = l;
                    rb = r;
                    Lb = lst;
                    Rb = m;
                }
            }
        }
    }
    if (py[m] > ans) {
        ans = py[m];
        lb = 0;
        rb = 0;
        Lb = 1;
        Rb = m;
    }
    cout << ans << '\n';
    cout << lb << " " << rb << '\n';
    cout << Lb << " " << Rb << '\n';
    return 0;
}
