#include <iostream>
#include <unordered_set>

using namespace std;

constexpr int maxn = 2e6;

int a[maxn];
int should = 0, should_not = 0;
int n;
int where[maxn];
bool what[maxn];
int cnts[50];
int cntsn[50];

void update(int i)
{
    if (where[i] != -1) {
        if (what[i]) {
            --cnts[where[i]];
            if (cnts[where[i]] == 0) {
                should &= ~(1<<where[i]);
            }
        } else {
            --cntsn[where[i]];
            if (cntsn[where[i]] == 0) {
                should_not &= ~(1<<where[i]);
            }
        }
    }
    int t = 0;
    int u = a[i], v = a[i+1];
    while (u != v) {
        u >>= 1;
        v >>= 1;
        ++t;
    }
    if (t > 0) {
        --t;
        where[i] = t;
        if (a[i+1] & (1<<t)) {
            should_not |= (1<<t);
            what[i] = 0;
            ++cntsn[t];
        } else {
            should |= (1<<t);
            what[i] = 1;
            ++cnts[t];
        }
    } else {
        where[i] = -1;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    int q;
    cin >> q;
    for (int i = 0; i+1 < n; ++i) {
        where[i] = -1;
        update(i);
    }
    if (should & should_not) {
        cout << "-1\n";
    } else {
        cout << should << '\n';
    }
    for (int w = 0; w < q; ++w) {
        int p, v;
        cin >> p >> v;
        --p;
        a[p] = v;
        if (p != 0) {
            update(p-1);
        }
        if (p != n-1) {
            update(p);
        }
        if (should & should_not) {
            cout << "-1\n";
        } else {
            cout << should << '\n';
        }
    }
    return 0;
}