#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cassert>
#include <cmath>
#include <climits>
#include <vector>
#include <functional>

using namespace std;

typedef unsigned int index;

int main()
{
#ifdef ONPC
	assert(freopen("a.in", "r", stdin));
	assert(freopen("a.out", "w", stdout));
#else
	assert(freopen("servers.in", "r", stdin));
	assert(freopen("servers.out", "w", stdout));
#endif
	ios::sync_with_stdio(false);
	size_t n;
	cin >> n;
	vector<long long> t(n);
	for (auto &i: t)
		cin >> i;
	vector<pair<long long, long long>> go(n - 1);
	for (auto &i: go)
		cin >> i.first >> i.second;
	vector<pair<long long, long long>> d(n), dr(n);
	d[0] = {0, 2000000000};
	for (index i = 1; i < n; i++)
	{
		if (go[i - 1].first >= d[i - 1].first)
		{
			d[i].first = max(0ll, go[i - 1].first - t[i]);
		}
		else
		{
			d[i].first = d[i - 1].first;
		}
		d[i].second = min(d[i - 1].second, go[i - 1].second);
		if (go[i - 1].first > d[i - 1].second)
			d[i] = {1e9, -1e9};
		if (d[i].second < d[i].first)
			d[i] = {1e9, -1e9};
	}
	dr[n - 1] = {0, 2000000000};
	for (index i = (index)n - 2; i != (index)-1; i--)
	{
		if (go[i].first >= dr[i + 1].first)
		{
			dr[i].first = max(0ll, go[i].first - t[i]);
		}
		else
		{
			dr[i].first = dr[i + 1].first;
		}
		dr[i].second = min(dr[i + 1].second, go[i].second);
		if (go[i].first > dr[i + 1].second)
			dr[i] = {1e9, -1e9};
		if (dr[i].second < dr[i].first)
			dr[i] = {1e9, -1e9};
	}
	for (index i = 0; i < n; i++)
	{
		long long l = max(d[i].first, dr[i].first), r = min(d[i].second, dr[i].second);
		if (l <= r)
			cout << l << endl;
		else
			cout << -1 << endl;
	}
}
