#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cstdio>
#include <string>
using namespace std;

bool can_do(string s, bool is_plus) {
	vector<int> blocks;
	vector<bool> code;
	int last = 0;
	for (int i = 1; i < s.size() ; i++) {
		if (s[last] != s[i]) {
			blocks.push_back(i - last);
			code.push_back(((s[last] == '+') == is_plus));
			if (!code.back()) {
				if (code.size() != 1 && blocks[code.size() - 2] > blocks.back()) {
					int topop = blocks[code.size() - 2] + blocks.back();
					code.pop_back();
					blocks.pop_back();
					blocks.pop_back();
					blocks.push_back(topop);
				}
				else {
					last = i;
					continue;
				}
			}
			while (1) {
				if (code.size() == 1) break;

				if (code[code.size() - 2] == 1) {
					int topop = blocks[code.size() - 2] + blocks.back();
					code.pop_back();
					blocks.pop_back();
					blocks.pop_back();
					blocks.push_back(topop);
				}
				else if ((blocks[code.size() - 2] < blocks.back())) {
					int topop = blocks[code.size() - 2] + blocks.back();
					code.pop_back();
					code.pop_back();
					code.push_back(1);
					blocks.pop_back();
					blocks.pop_back();
					blocks.push_back(topop);
				}
				else break;
			}
			last = i;

		}
	}
	blocks.push_back(s.size() - last);
	code.push_back(((s[last] == '+') == is_plus));

	if (!code.back()) {
		if (code.size() != 1 && blocks[code.size() - 2] > blocks.back()) {
			int topop = blocks[code.size() - 2] + blocks.back();
			code.pop_back();
			blocks.pop_back();
			blocks.pop_back();
			blocks.push_back(topop);
		}
		else {
			return 0;
		}
	}
	while (1) {
		if (code.size() == 1) break;

		if (code[code.size() - 2] == 1) {
			int topop = blocks[code.size() - 2] + blocks.back();
			code.pop_back();
			blocks.pop_back();
			blocks.pop_back();
			blocks.push_back(topop);
		}
		else if ((blocks[code.size() - 2] < blocks.back())) {
			int topop = blocks[code.size() - 2] + blocks.back();
			code.pop_back();
			code.pop_back();
			code.push_back(1);
			blocks.pop_back();
			blocks.pop_back();
			blocks.push_back(topop);
		}
		else break;
	}
	if (code.size() == 1)
		return 1;
	return 0;
}

int main() {
	//freopen("test.in", "r", stdin);
	//freopen("test.out", "w", stdout);

	int q;
	cin >> q;
	
	for (int qq = 0; qq < q; qq++) {
		string s, t;
		cin >> s >> t;
		int last = 0;
		int f = 1;
		//bool change = 0;
		for (int i = 1; i < t.size(); i++) {
			/*if (change) {
				if (s[i - 1] != s[i]) {
					s[i] = s[i - 1];
				}
				else {
					change = 0;
				}
			}*/
			if (t[last] != t[i]) {
				string n_s = s.substr(last, i - last);
				bool x = can_do(n_s, (t[last] == '+'));
				if (x == 0) {
					cout << "No" << endl;
					f = 0;
					break;
				}
				/*if (s[i - 1] != t[last]) {
					change = 1;
					s[i] = t[last];
				}
				else {
					change = 0;
				}*/
				if (s[i] == s[i - 1] || t[last] == s[i]) {
					cout << "No" << endl;
					f = 0;
					break;
				}
				last = i;
			}
		}
		string n_s = s.substr(last, t.size() - last);
		bool x = can_do(n_s, (t[last] == '+'));
		if (x == 0 && f) {
			cout << "No" << endl;
			f = 0;
		}
		if (f)
			cout << "Yes" << endl;
	}

	return 0;
}