#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cstdio>
#include <utility>
#include <algorithm>
#define pii pair<int, int>
using namespace std;

int n;
vector<int> t;
vector<pii> seg;
vector<int> used;
vector<pii> res;
int INF = (int)1e9;
pii dfs(int a, int type) {
	if (used[a * 2 + type])
		return res[a * 2 + type];
	used[a * 2 + type] = 1;
	if ((a == 0 && type == 1) || (a == n - 1 && type == 0)) {
		res[a * 2 + type] = { 0, INF };
		return res[a * 2 + type];
	}
	pii x = {0, 0};
	if (type == 0) {
		x = dfs(a + 1, type);
	}
	else {
		x = dfs(a - 1, type);
	}
	if (x == pii({-1, -1})) {
		res[2 * a + type] = x;
		return x;
	}
	pii channel = { 0, 0 };
	if (type == 0)
		channel = seg[a];
	else
		channel = seg[a - 1];
	if (channel.second < x.first || channel.first > x.second) {
		res[2 * a + type] = {-1, -1};
		return{-1, -1};
	}
	int left = 0, right = min(channel.second, x.second);
	if (channel.first < x.first) {
		left = x.first;
	}
	else {
		left = channel.first - t[a];
	}
	if (left > right) {
		res[2 * a + type] = {-1, -1};
		return {-1, -1};
	}
	res[2 * a + type] = { left, right };
	return res[2 * a + type];
}

int main() {
	//freopen("test.in", "r", stdin);
	//freopen("test.out", "w", stdout);
	cin >> n;

	t.resize(n);
	used.resize(2 * n);
	res.resize(2 * n);
	seg.resize(n - 1);
	for (int i = 0; i < n; i++)
		cin >> t[i];
	for (int i = 0; i < n - 1; i++) {
		int l, r;
		cin >> l >> r;
		seg[i] = { l, r };
	}
	for (int i = 0; i < n; i++) {
		pii x;
		x = dfs(i, 0);
		pii y;
		y = dfs(i, 1);
		if (x == pii({-1, -1}) || y == pii({-1, -1})) {
			cout << -1 << endl;
			continue;
		}
		pii z;
		z.first = max(x.first, y.first);
		z.second = max(x.second, y.second);
		if (z.first > z.second) {
			cout << -1 << endl;
			continue;
		}
		if (z.first < 0 && z.second < 0) {
			cout << -1 << endl;
			continue;
		}
		cout << max(0, z.first) << endl;
	}




	return 0;
}