#include <bits/stdc++.h>
using namespace std;
#define DB(v) cerr << #v << ' ' << v << endl
#define sz(v) int(v.size())
#define For(i, a, b) for(int i = a;i <= b; ++i)
#define fi first
#define se second

typedef pair <int,int> pii;

const int N = 2e5 + 9;
const int INF = 1e9 + 9;
int n;

template <typename T>
inline ostream &operator << (ostream &out, const vector <T> &v) {
    for(auto to: v)
        out << to << ' ';
    out << '\n';
    return out;
}

template <typename T1, typename T2>
inline ostream &operator << (ostream &out, const pair <T1, T2> &v) {
    out << v.fi << ' ' << v.se << '\n';
    return out;
}


vector <int> store;
vector <pii> to_left, to_right;
vector <pii> channel;

int main()
{
#ifdef HOME
    freopen("input.txt","r",stdin);
#endif // HOME
    ios::sync_with_stdio(NULL); cin.tie(NULL);
    cin >> n;
    store.resize(n + 1);
    to_left.resize(n + 1);
    to_right.resize(n + 1);
    channel.resize(n + 1);
    For(i, 1, n) {
        cin >> store[i];
    }

    For(i, 1, n - 1) {
        cin >> channel[i].fi >> channel[i].se;
    }

    to_left[1] = make_pair(0, INF);
    for(int i = 2;i <= n; ++i) {
        int lf_border = max(to_left[i - 1].fi, channel[i - 1].fi), rg_border = min(channel[i - 1].se, to_left[i - 1].se);
        if(channel[i - 1].fi >= to_left[i - 1].fi && lf_border <= rg_border)
            lf_border = channel[i - 1].fi - store[i];
        to_left[i] = make_pair(lf_border, rg_border);
    }

    to_right[n] = make_pair(0, INF);
    for(int i = n - 1;i >= 1;i--) {
        int lf_border = max(to_right[i + 1].fi, channel[i].fi), rg_border = min(channel[i].se, to_right[i + 1].se);;
        if(channel[i].fi >= to_right[i + 1].fi && lf_border <= rg_border)
            lf_border = channel[i].fi - store[i];
        to_right[i] = make_pair(lf_border, rg_border);
    }
    /*cout << to_left << endl;

    cout << to_right << endl;*/


    for(int i = 1;i <= n; ++i) {
        int lf = max(to_left[i].fi, to_right[i].fi), rg = min(to_left[i].se, to_right[i].se);
        if(rg < lf)
            cout << -1;
        else
            cout << lf;
        cout << '\n';
    }
    return 0;
}
