#include <iostream>
#include <vector>

using namespace std;

bool isSorted(vector<uint32_t>& numbers) {
    for(uint32_t c = 0; c < numbers.size() - 1; c++) {
        if(numbers[c] > numbers[c + 1]) return false;
    }
    return true;
}
void allXor(vector<uint32_t>& numbers, uint32_t value) {
    for(uint32_t c = 0; c < numbers.size(); c++) {
        numbers[c] ^= value;
    }
}
void proc(vector<uint32_t>& numbers) {
    for(uint32_t result = 0; result < 512; result++) {
        vector<uint32_t> cp = numbers;
        allXor(cp, result);
        if(isSorted(cp)) {
            cout << result << endl;
            return;
        }
    }
    cout << -1 << endl;
}
int main() {
    uint32_t n;
    cin >> n;
    vector<uint32_t> nums(n);
    for(uint32_t c = 0; c < n; c++) {
        cin >> nums[c];
    }
    proc(nums);
    uint32_t count, index, value;
    cin >> count;
    for(uint32_t c = 0; c < n; c++) {
        cin >> index >> value;
        nums[index - 1] = value;
        proc(nums);
    }
}
