#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

struct Block {
    Block(int length, char sym) :
        length(length), sym(sym) {
        next = pref = nullptr;
    }
    Block *next, *pref;
    int length;
    char sym;
};

bool cmp(const Block& one, const Block& two) {
    if(one.length <= two.length) {
        return true;
    }
    return false;
}


int main() {
    ios_base::sync_with_stdio(false);
    string a, b;
    int n;
    cin >> n;
    for(uint32_t k = 0; k < n; k++) {
        cin >> a >> b;
        a += '?';
        char pref = '?';
        int length = 0, counter = 0;
        Block* curr = new Block({0, '?'});
        for(uint32_t c = 0; c < a.size(); c++) {
            if(a[c] != pref) {
                if(c != 0) {
                    curr->next = new Block({length, pref});
                    curr->next->pref = curr;
                    curr = curr->next;
                    counter++;
                }
                pref = a[c];
                length = 1;
            } else {
                length++;
            }
        }
        curr->next = new Block({0, '?'});
        curr->next->pref = curr;
        do {
            counter = 0;
            bool right = false;
            while(((right)? curr->next : curr-> pref) != nullptr) {
                bool check = false;
                if(curr->pref->sym != '?') {
                    if(curr->pref->length < curr->length && curr->sym == '+') {
                        //cout << curr->pref->length << " " << curr->length << endl;
                        curr->length = curr->pref->length + curr->length;
                        auto rem = curr->pref;
                        curr->pref = curr->pref->pref;
                        curr->pref->next = curr;
                        delete rem;
                        check = true;
                    }
                }
                if(curr->next->sym != '?') {
                    if(curr->next->length < curr->length && curr->sym == '+') {
                        //cout << curr->next->length << " " << curr->length << endl;
                        curr->length = curr->next->length + curr->length;
                        auto rem = curr->next;
                        curr->next = curr->next->next;
                        curr->next->pref = curr;
                        delete rem;
                        check = true;
                    }
                }
                if(!check) {
                    curr = ((right)? curr->next : curr->pref);
                } else {
                    counter++;
                }
            }
            right = !right;
        } while(counter != 0);
        bool no = true;
        if(curr->next != nullptr) {
            if(curr->next->length + 1 == a.size() && curr->next->sym == '+') {
                no = false;
            }
        } else {
            if(curr->pref != nullptr) {
                if(curr->pref->length + 1 == a.size() && curr->pref->sym == '+') {
                    no = false;
                }
            }
        }
        if(no) {
            cout << "No" << endl;
        } else {
            cout << "Yes" << endl;
        }
    }
    return 0;
}
