#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<string>
#include<vector>
#include<cmath>
#include<algorithm>

using namespace std;

#define X first
#define Y second

const int MAXN = 200000 + 100, INF = 1e9 + 10;

int n, xl[MAXN], xr[MAXN], x[MAXN], l, r;
int rl[MAXN], rr[MAXN], ll[MAXN], lr[MAXN], tec, tlr, trr, trl, tll;

int main()
{
#if _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen("servers.in", "r", stdin);
	freopen("servers.out", "w", stdout);
#endif
	cin >> n;
	for (int i = 0; i < n; i++)
	{
		cin >> x[i];
	}
	for (int i = 0; i < n - 1; i++)
	{
		cin >> xl[i] >> xr[i];
	}
	rr[n - 1] = INF;
	rl[n - 1] = 0;
	for (int i = n - 2; i >= 0; i--)
	{
		rr[i] = min(xr[i], rr[i + 1]);
		rl[i] = max(xl[i] - x[i], rl[i + 1]);
	}
	lr[0] = INF;
	ll[0] = 0;
	for (int i = 1; i < n; i++)
	{
		lr[i] = min(xr[i - 1], lr[i - 1]);
		ll[i] = max(xl[i - 1] - x[i], ll[i - 1]);
	}
	for (int i = 0; i < n; i++)
	{
		tec = max(ll[i], rl[i]);
		if (ll[i] <= tec && tec <= lr[i] && rl[i] <= tec && tec <= rr[i])
			cout << tec << endl;
		else
			cout << -1 << endl;
	}
	return 0;
}