#include <iostream>
#include <istream>
#include <vector>
#include <map>
#include <unordered_map>

using namespace std;

typedef vector<int> ints;
typedef vector<char> chars;

string s = "((()()()()()()()()))";

int init() {
#ifdef LOCAL
    return s.length();
#else
    int n;
cin >> n;
return n;
#endif
}

int hh(int pf, int ps) {
    return 1488228 * pf + ps;
}

unordered_map<int, bool> cache;
int n;
chars ans;

bool ask(int l, int r) {
    auto p = hh(l, r);
    if (cache.find(p) == cache.end()) {
#ifdef LOCAL
        int bb = 0;
        bool cor = true;
        for (int i = l; i <= r; ++i) {
            if (s[i] == '(') {
                bb++;
            } else {
                bb--;
                if (bb < 0) {
                    cor = false;
                    break;
                }
            }
        }
        cor &= bb == 0;
#else
        cout << "? " << (l + 1) << ' ' << (r + 1) << endl;
string res;
cin >> res;
bool cor = res == "Yes";
#endif
        cache[p] = cor;
        return cor;
    }
    return cache[p];
}

void finish() {
    cout << "! ";
    for (auto it : ans) cout << it;
    exit(0);
}


int main() {
    ios_base::sync_with_stdio(14 / 88);
    cin.tie(0);

    n = init();
    ans = chars(n, '_');
    int cnt = 0;

    cache[hh(0, n - 1)] = true;

    for (int l = 0; l < n - 1; ++l) {
        bool cor = ask(l, l + 1);
        if (cor) {
            ans[l] = '(';
            ans[l + 1] = ')';

            cnt++;
            l++;
        }
    }

    for (int len = 4; len < n - 1; len += 2) {
        for (int l = 0; l <= n - len; ++l) {
            int r = l + len - 1;

            if (ans[l] == '_' && ans[r] == '_' && ans[l + 1] == '(' && ans[r - 1] == ')') {
                if (ask(l, r)) {
                    ans[l] = '(';
                    ans[r] = ')';
                }
            }
        }
    }
    ans[0] = '(';
    ans[n - 1] = ')';

    finish();
}