#include <bits/stdc++.h>

#define X first
#define Y second
#define pb push_back
#define REP(i, a, b) for (int  i = (a); i <= (b); ++i)
#define sz(v) int((v).size())
#define all(v) (v).begin(), (v).end()

using namespace std;

typedef long long ll;
typedef pair <int, ll> pii;

int n, m;

const int maxn = 2000;

void upd(pair <ll, ll> &x, pair <ll, ll> y, ll c)
{
    if (x.X > y.X + c)
    {
        x.X = y.X + c;
        x.Y = y.Y + c*c;
    }

    if (x.X == y.X + c)
    {
        x.Y = max(x.Y, y.Y + c*c);
    }
}

map <int, int> pos[maxn];

int main()
{
    ios_base::sync_with_stdio(false);

    cin >> n >> m;

    vector < vector <ll> > ed(m);

    REP (i, 0, m - 1)
    {
        int k;
        cin >> k;
        ed[i].resize(2*k + 1);
        REP (j, 0, 2*k)
            cin >> ed[i][j];

        for (int j = 0; j < sz(ed); j += 2)
            pos[ed[i][j] - 1][i] = j;
    }

    vector <pair <ll, ll> > dp(n, {1e18, 0});

    dp[0] = {0, 0};

    REP (i, 1, 1000)
    {
        REP (v, 0, n - 1)
        {
            for (auto e : pos[v])
            {
                int k = e.X;
                int p = e.Y;
                ll s = ed[k][p + 1];

                for (int j = p + 2; j < sz(ed[k]); j += 2)
                {
                    upd(dp[ed[k][j] - 1], dp[v], s);
                    if (j + 1 < sz(ed[k]))
                        s += ed[k][j + 1];
                }
            }
        }
    }

    cout << dp[n - 1].X << ' ' << dp[n - 1].Y << '\n';
    return 0;
}
