#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;

int n;

int g_left(string & s, int v, char diff) {
    int cnt = 0;
    for (int i = v - 1; i >= 0; i--) {
        if (s[i] != diff) {
            cnt++;
        } else {
            break;
        }
    }
    return cnt;
}

int g_right(string & s, int v, char diff) {
    int cnt = 0;
    for (int i = v + 1; i < s.size(); i++) {
        if (s[i] != diff) {
            cnt++;
        } else {
            break;
        }
    }
    return cnt;
}

void color(string & s, int a, int b) {
    for (int i = a; i <= b; i++) {
        if (s[i] == '-')
            s[i] = '+';
        else
            s[i] = '-';
    }
}

int main() {
    cin >> n;
    for (int i = 0; i < n; i++) {
        string a, b;
        cin >> a >> b;
        int len = (int)a.size();
        vector<pii> vec;
        int cur = INT_MAX;
        char ch = a[0];
        for (int z = 0; z < len; z++) {
            if (ch == a[z] && ch != b[z]) {
                cur = min(cur, z);
            } else {
                ch = a[z];
                if (cur <= z - 1)
                    vec.push_back({cur, z - 1});
                cur = INT_MAX;
            }
        }
        if (cur <= len - 1)
            vec.push_back({cur, len - 1});

        while (vec.size() > 0) {
            bool can = false;
            int cnt = -1;
            for (auto it : vec) {
                cnt++;
                int maximal = max(g_left(a, it.first, a[it.first]),
                                    g_right(a, it.second, a[it.second]));
                if (maximal > it.second - it.first + 1) {
                    color(a, it.first, it.second);
                    can = true;
                    break;
                }
            }
            if (!can)
                break;
            vec.erase(vec.begin() + cnt);
        }

        if (vec.size() > 0)
            cout << "No" << endl;
        else
            cout << "Yes" << endl;
    }
}

/*
 1
 ----+++++
 ++++-----

 1
 ++-+--+-+-++
 ++++----++++

 3
 ++- +++
 ++-- ++++
 ++-+--+- ++++++++

 1
 ++-+--+- ++++++++

 3
 ++-+-- ++----
 ++-+-- +++---
 -++- -++-
 */