#include <bits/stdc++.h>
using namespace std;
typedef long long int ll;
typedef pair<int, int> pii;

const int maxn = 100 + 5;
const int maxk = 3000000 + 5;

int n, v;
vector<pii> bounds;
vector<int> cost;
pii calced[maxk];

struct tree {
    int n;
    vector<pii> t;

    void build(int v, int l, int r) {
        if (l == r) {
            t[v] = { INT_MAX, INT_MAX };
        } else {
            build(v * 2, l, (l + r) / 2);
            build(v * 2 + 1, (l + r) / 2 + 1, r);
            t[v] = min(t[v * 2], t[v * 2 + 1]);
        }
    }

    void init(int n) {
        this->n = n;
        t.resize(4 * n);
        build(1, 0, n - 1);
    }

    void change(int v, int l, int r, int pos, pii val) {
        if (l == r) {
            t[v] = val;
            t[v].first += n - 1 - pos;
        } else {
            if (pos <= (l + r) / 2)
                change(v * 2, l, (l + r) / 2, pos, val);
            else
                change(v * 2 + 1, (l + r) / 2 + 1, r, pos, val);
            t[v] = min(t[v * 2], t[v * 2 + 1]);
        }
    }

    void change(int pos, pii val) {
        change(1, 0, n - 1, pos, val);
    }

    pii get(int v, int L, int R, int l, int r) {
        if (r < L || R < l)
            return { INT_MAX, INT_MAX };
        if (l >= L && r <= R)
            return t[v];
        return min(
                get(v * 2, L, R, l, (l + r) / 2),
                get(v * 2 + 1, L, R, (l + r) / 2 + 1, r)
        );
    }

    pii get(int l, int r) {
        return get(1, l, r, 0, n - 1);
    }
} t;

void dp(int a) {
    pii pr = { 0, 0 };
    for (int b = 0; b < n; b++) {
        if (a >= bounds[b].second) {
            pii pdd = t.get(a - bounds[b].second, a - bounds[b].first);
            pdd.first -= v - a;
            pdd.second -= cost[b];
            pr = max(pr, pdd);
        }
    }

    t.change(a, pr);
}

int main() {
    scanf("%d%d", &n, &v);
    t.init(v + 1);
    for (int i = 0; i < n; i++) {
        int l, r, c;
        scanf("%d%d%d", &l, &r, &c);
        bounds.push_back({l, r});
        cost.push_back(c);
    }

    for (int i = 0; i <= v; i++)
        dp(i);
    
    pii pr = calced[v];

    ll ank = pr.first;
    ank *= 1000000000LL;
    ank += pr.second;
    cout << ank;
}