#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <stack>
#include <set>
#include <queue>

using namespace std;

const long long INF = 1e18;

int main() {
	ios_base::sync_with_stdio(false);
	int n, m;
	cin >> n >> m;
	vector< vector< pair<int, int> > > arr(m);
	vector< vector< pair<int, int>> > g(n);
	for (int i = 0; i < m; i++) {
		int sz;
		cin >> sz;
		arr[i].resize(sz);
		int now;
		cin >> now;
		now--;
		for (int j = 0; j < sz; j++) {
			int t, to;
			cin >> t >> to; to--;
			arr[i][j] = { t, to };
			g[now].push_back( { i, j });
			now = to;
		}
	}
	vector< pair<long long, long long> > d(n, { INF, -INF });
	d[0] = { 0, 0 };
	vector<bool> used(n);
	for (int i = 0; i < n; i++) {
		int v = -1;
		for (int j = 0; j < n; j++) {
			if (!used[j] && (v == -1 || d[v] > d[j]))
				v = j;
		}
		used[v] = 1;
		for (pair<int, int> j : g[v]) {
			long long up = 0;
			while (j.second < arr[j.first].size()) {
				up += arr[j.first][j.second].first;
				d[arr[j.first][j.second].second] = min(make_pair( long long(d[i].first + up), -long long(-d[i].second + up * up )), d[arr[j.first][j.second].second]);
				j.second++;
			}
		}
	}
	cout << d[n - 1].first << ' ' << -d[n - 1].second;
	return 0;
}
