#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <cstdio>
#include <cstdlib>
#include <string>
#include <cassert>
using namespace std;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int MAXN = 5e4 + 23;

int a[MAXN];
int n;
void printAns(int mx = 520) {
	bool fl = 1;
	for (int cur = 0; cur <= mx; cur++) {
		fl = 1;
		for (int i = 0; i + 1 < n; i++)
			if ((a[i] ^ cur) > (a[i + 1] ^ cur)) { 
				fl = 0; 
				break; 
			}
		if (fl) {
			cout << cur << '\n'; break;
		}
	}
	if (!fl) cout << "-1\n";
}
int solve() {
	
	cin >> n;
	int mx = 0;
	for (int i = 0; i < n; i++) {
		cin >> a[i];
		mx = max(mx, a[i]);
	}

	printAns();
	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int x, y;
		cin >> x >> y;
		a[x - 1] = y;
		printAns();
	}
	return 0;
}