#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <algorithm>
#include <string>

using namespace std;

int solve();

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
	return 0;
}

const int MAXN = 1e6 + 23;
vector<int> a;
vector<bool> type;
int solve() {
	int n;
	cin >> n;
	for (int tt = 0; tt < n; tt++) {
		string s1, s2;
		cin >> s1 >> s2;
		int cnt = 1;
		for (int i = 1; i < s1.size(); i++) {
			if (s1[i - 1] != s1[i]) {
				type.push_back(s1[i - 1] == '+');
				a.push_back(cnt);
				cnt = 1;
			}
			else cnt++;
		}

		type.push_back(s1.back() == '+');
		a.push_back(cnt);

		bool ffl = 1;
		int sum = 0;
		bool fl = 0;
		for (int i = 0; i < (int)a.size(); i++) {
			fl = 0;
			if (!type[i]) {
				if (i > 0 && sum > a[i]) fl = 1;
				if (i + 1 < (int)a.size() && a[i + 1] > a[i]) fl = 1;
				if (!fl) {
					ffl = 0;
					break;
				}
			}
			sum += a[i];
		}

		if (ffl) {
			cout << "Yes\n";
			continue;
		}


		sum = 0;
		ffl = 1;
		for (int i = (int)a.size() - 1; i >= 0; i--) {
			fl = 0;
			sum += a[i];
			if (!type[i]) {
				if (i > 0 && a[i - 1] > a[i]) fl = 1;
				if (i + 1 < (int)a.size() && a[i + 1] > a[i]) fl = 1;
				if (!fl) {
					ffl = 0;
					cout << "No\n";
					break;
				}
			}
			a[i] = sum;
		}
		if (ffl) cout << "Yes\n";
	}
	return 0;
}