#include <stdio.h>
#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define sz(a) (int)a.size()
#define mp(a, b) make_pair(a, b)

using namespace std;

//const int N = 2000000 + 1;
const int N = 500000 + 1;
const int inf = (int)1e9;
const ll oo = (ll)1e18 + 1;

struct exper
{
    int l, r, cost;
    exper() {}
    exper(int l, int r, int cost) : l(l), r(r), cost(cost) {}
    void read() { scanf("%d %d %d", &l, &r, &cost); }
};

bool operator < (exper e1, exper e2)
{
    return e1.r < e2.r;
}

struct MinQueue
{
    deque<ll> q;
    MinQueue() {}
    void add(ll x)
    {
        while (!q.empty() && q.front() > x)
            q.pop_front();
        q.push_front(x);
    }
    void del(ll x)
    {
        if (!q.empty() && q.back() == x)
            q.pop_back();
    }
    ll get()
    {
        if (!q.empty())
            return q.back();
        else
            return oo;
    }
};

int main()
{
    //freopen("a.in", "r", stdin);
    int n, X;
    scanf("%d %d", &n, &X);
    exper a[n];
    rep(i, 0, n)
        a[i].read();
    sort(a, a + n);
    ll dp[X + 1];
    dp[X] = 0 + 1LL * X * inf;
    MinQueue q[n];
    repb(j, X - 1, -1)
    {
        rep(i, 0, n)
        {
            if (j + a[i].l <= X)
                q[i].add(dp[j + a[i].l]);
            if (j + a[i].r + 1 <= X)
                q[i].del(dp[j + a[i].r + 1]);
        }
        dp[j] = 0;
        rep(i, 0, n)
            if (j + a[i].r <= X)
                dp[j] = max(dp[j], q[i].get() - (1LL * j * inf + a[i].cost));
            else
                break;
        dp[j] += 1LL * j * inf;
    }
    printf("%lld\n", dp[0]);
    return 0;
}
