#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main() {
	long long n, m;
	cin >> n >> m;
	vector<long long> d1(n + 1), r1(n + 1), d2(m + 1), r2(m + 1), pr1(n + 1, 0), pr2(m + 1, 0);
	for (long long i = 1; i <= n; i++) {
		cin >> d1[i];
	}
	for (long long i = 1; i <= n; i++) {
		cin >> r1[i];
		pr1[i] = r1[i] + pr1[i - 1];
	}
	vector<long long> x(n + m + 1, -1);
	for (long long i = 1; i <= m; i++) {
		cin >> d2[i];
		x[d2[i]] = i;
	}
	for (long long i = 1; i <= m; i++) {
		cin >> r2[i];
		pr2[i] = r2[i] + pr2[i - 1];
	}
	long long ans = pr1[n], s1 = 1, s2 = 0, t1 = n, t2 = 0;
	if (pr2[m] > ans) {
		ans = pr2[m];
		s1 = t1 = 0;
		s2 = 1;
		t2 = m;
	}
	for (long long i = 1; i <= n; i++) {
		vector<long long> used(m + 1, 0);
		vector< pair<long long, long long> > nxt(m + 1, { 0, m + 1 });
		for (long long j = i; j <= n; j++) {
			if (x[d1[j]] != -1) {
				used[x[d1[j]]] = 1;
			}
		}
		long long prev = 0, sum = pr1[n] - pr1[i - 1];
		for (long long j = 1; j <= m; j++) {
			if (used[j]) {
				if (prev != 0) {
					nxt[prev].second = j;
					nxt[j].first = prev;
				}
				if (sum + pr2[j - 1] - pr2[prev] > ans) {
					ans = sum + pr2[j - 1] - pr2[prev];
					s1 = i;
					t1 = n;
					s2 = prev + 1;
					t2 = j - 1;
				}
				prev = j;
			}
		}
		if (sum + pr2[m] - pr2[prev] > ans) {
			ans = sum + pr2[m] - pr2[prev];
			s1 = i;
			t1 = n;
			s2 = prev + 1;
			t2 = m;
		}
		for (long long j = n; j > i; j--) {
			sum -= r1[j];
			long long e = x[d1[j]];
			if (e == -1) {
				continue;
			}
			long long l = nxt[e].first, r = nxt[e].second;
			if (sum + pr2[r - 1] - pr2[l] > ans) {
				ans = sum + pr2[r - 1] - pr2[l];
				s1 = i;
				t1 = j - 1;
				s2 = l + 1;
				t2 = r - 1;
			}
			if (l != 0) {
				nxt[l].second = r;
			}
			if (r != m + 1) {
				nxt[r].first = l;
			}
		}
	}
	cout << ans << endl;
	cout << s1 << " " << t1 << endl;
	cout << s2 << " " << t2;
	return 0;
}