#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
typedef long long ll; 
	
struct pnt {
	int x, y, num;
	pnt() {}
	pnt(int x, int y, int num) : x(x), y(y), num(num) {}
	bool operator < (pnt const& o) const {
		return (y * o.x - x * o.y) >= 0;
	}
};

pnt a[65];

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios::sync_with_stdio(false);
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		a[i] = pnt(x, y, i + 1);
	}
	sort(a, a + n);
	int q;
	cin >> q;
	for (int t = 0; t < q; t++) {
		bool got = false;
		for (int i = 0; i < n - 2; i++) {
			for (int j = i + 1; j < n - 1; j++) {
				for (int k = j + 1; k < n; k++) {
					cout << "? 3 " << a[i].num << " " << a[j].num << " " << a[k].num << endl;
					string ans;
					cin >> ans;
					if (ans == "Yes") {
						got = true;
						cout << "! 3 " << a[i].num << " " << a[j].num << " " << a[k].num << endl;
						break;
					}
				}
				if (got) break;
			}
			if (got) break;
		}
	}
}