#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <set>

using namespace std;

struct edge
{
    int to, w;
};

int n, m;
vector <int> d, sq;
set <pair <int, int> > s;
vector <vector <edge> > g;

inline void dij()
{
    int node = (*s.begin()).second;
    s.erase(s.begin());

    for (int i = 0; i < (int)g[node].size(); i++)
    {
        int to = g[node][i].to, w = g[node][i].w;
        if (d[to] > d[node] + w || (d[to] == d[node] + w && sq[to] < sq[node] + w * w))
        {
            s.erase({d[to], to});
            d[to] = d[node] + w;
            sq[to] = sq[node] + w * w;
            s.insert({d[to], to});
        }
    }

    if (!s.empty())
        dij();
}

int main()
{
    cin >> n >> m;
    g.resize(n + 1);
    d.resize(n + 1, 2e9);
    sq.resize(n + 1, -2e9);
    for (int i = 0; i < m; i++)
    {
        int a, from, w, to;
        cin >> a >> from >> w >> to;
        g[from].push_back({to, w});
    }

    s.insert({0, 1});
    d[1] = 0, sq[1] = 0;
    dij();

    cout << d[n] << ' ' << sq[n];
    return 0;
}

/*

2 1
1 1 3 2

*/
