#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <ctime>
#include <utility>
#include <iterator>
#include <algorithm>
#include <vector>
#include <list>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <bitset>
#include <queue>
#include <deque>
#include <fstream>
#include <sstream>

#define X first
#define Y second
#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()

#define TASK "sequence"
#define SEED 322

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

const int INF = 1e9;
const int MOD = 1e9 + 7;
const ll LINF = 3e18;
const double PI = acos(-1.0);
const double EPS = 1e-8;

//hey there

bool ask(int x) {
	cout << x << endl;
	int res;
	cin >> res;
	if (res == 0)
		exit(0);
	else
		return res > 0;
}

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//freopen(TASK".in", "r", stdin);
	//freopen(TASK".out", "w", stdout);
#endif
	//srand(SEED);

	int n;
	cin >> n;

	int l = 1, r = n + 1;
	while (r - l > 1) {
		int m = (l + r) / 2;

		if (ask(m)) {
			l = m;
		}
		else {
			r = m;
		}
	}

	return 0;
}