#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

int main()
{
	ll n, m;
	cin >> n >> m;

	vector<pair<ll, ll>> h(n + 1, { 0, 0 }), a1, a2;
	for (int i = 1; i <= n; ++i)
	{
		ll a;
		cin >> a;
		h[i].first = a;
	}
	for (int i = 1; i <= n; ++i)
	{
		ll a; cin >> a;
		h[i].second = a;
	}
	a1 = h;
	a1[0] = { -1, 0 };

	h.clear();
	h.resize(m + 1);
	for (int i = 1; i <= m; ++i)
	{
		ll a;
		cin >> a;
		h[i].first = a;
	}
	for (int i = 1; i <= m; ++i)
	{
		ll a; cin >> a;
		h[i].second = a;
	}
	a2 = h;
	a2[0] = { -2, 0 };

	ll maxx = -1, l3 = 0, r3 = 0, l4 = 0, r4 = 0;
	for (int l1 = 0; l1 <= n; ++l1)
	{
		for (int r1 = l1; r1 <= n; ++r1)
		{
			for (int l2 = 0; l2 <= m; ++l2)
			{
				for (int r2 = l2; r2 <= m; ++r2)
				{
					set<ll> sett;
					ll sum = 0, fl = 0;
					for (int i = l1; i <= r1; ++i)
					{
						sett.insert(a1[i].first);
						sum += a1[i].second;
					}
					for (int i = l2; i <= r2; ++i)
					{
						ll sz = sett.size();
						sett.insert(a2[i].first);
						if (sett.size() == sz)
						{
							fl = 1;
							break;
						}
						sum += a2[i].second;
					}

					if (!fl && sum > maxx)
					{
						l3 = l1;
						r3 = r1;

						l4 = l2;
						r4 = r2;

						maxx = sum;
					}
				}
			}
		}
	}

	cout << maxx << endl << l3 << " " << r3 << endl << l4 << " " << r4 << endl;
	return 0;
}

/*
1 17
4 6 10

2 11
2 2 100
3 5 5


7 5
3 1 4 8 6 9 2
2 7 4 10 1 5 3
9 2 11 3 8
3 5 3 4 12


2 3
1 2
1 4
2 3 1
17 2 15


*/