#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <algorithm>
#include <stack>
#include <vector>
#include <set>
#include <map>

using namespace std;

typedef long long ll;

int main()
{
	ll n, m;
	scanf("%lld %lld", &n, &m);

	vector<pair<int, ll>> a1(n + 1, { 0, 0 }), a2(m + 1, { 0, 0 });
	for (int i = 1; i <= n; ++i)
	{
		int a;
		scanf("%d", &a);
		a1[i].first = a;
	}
	for (int i = 1; i <= n; ++i)
	{
		ll a;
		scanf("%lld", &a);
		a1[i].second = a;
	}
	a1[0] = { 603, 0 };

	for (int i = 1; i <= m; ++i)
	{
		int a;
		scanf("%d", &a);
		a2[i].first = a;
	}
	for (int i = 1; i <= m; ++i)
	{
		ll a; scanf("%lld", &a);
		a2[i].second = a;
	}
	a2[0] = { 604, 0 };

	vector<ll> PSUM(m + 1);
	for (int i = 1; i <= m; ++i)
	{
		PSUM[i] = (ll)PSUM[i - 1] + (ll)a2[i].second;
	}
	

	ll maxx = -1, l3 = 0, r3 = 0, l4 = 0, r4 = 0, Pos = 0;
	ll sum1 = 0;
	for (int i = 1; i <= n; ++i)
		sum1 += a1[i].second;

	ll sum2 = 0;
	for (int i = 1; i <= m; ++i)
		sum2 += a2[i].second;

	if (sum1 > sum2)
	{
		maxx = sum1;
		l3 = 1; r3 = n;
		l4 = 0; r4 = 0;
	}
	else
	{
		maxx = sum2;
		l3 = 0; r3 = 0;
		l4 = 1; r4 = m;
	}

	for (int l1 = 1; l1 <= n; ++l1)
	{
		vector<int> used(605);
		ll fsum = 0;
		for (int r1 = l1; r1 <= n; ++r1)
		{
			fsum += a1[r1].second;
			used[a1[r1].first] = 1;
		/*	for (int i = l1; i <= r1; ++i)
			{
				used[a1[i].first] = 1;
				fsum += a1[i].second;
			}*/
			ll predr = 0;

			for (int l2 = predr  + 1; l2 <= m; ++l2)
			{
				ll sum = 0;
				//predr = max(predr, (ll)l2);
				ll fll = 0;
				for(int r2 = l2; r2 <= m; ++r2, predr = r2)
				{
					if (used[a2[r2].first] == 1)
					{
						predr = r2;
						break;
					}
					else
					{
						sum = PSUM[r2] - PSUM[l2 - 1];// a2[r2].second;
					}

					if (sum + fsum > maxx)
					{
						l3 = l1;
						r3 = r1;

						l4 = l2;
						r4 = r2;

						maxx = sum + fsum;
					}
				}

			}
		}
	}
	if (r3 != 0 && l3 == 0)
		l3 = 1;

	if (r4 != 0 && l4 == 0)
		l4 = 1;

	printf("%lld %lld %lld %lld %lld\n", maxx, l3, r3, l4, r4);
	return 0;
}

/*
1 17
4 6 10

2 11
2 2 100
3 5 5


7 5
3 1 4 8 6 9 2
2 7 4 10 1 5 3
9 2 11 3 8
3 5 3 4 12


2 3
1 2
1 4
2 3 1
17 2 15


*/