#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<map>
#include<set>

using namespace std;
vector<long long>p_pow(31);
vector<set<long long>>pos_1(30), pos_0(30);
long long n;
long long give_ans(long long j, long long l, long long r, vector<long long>&ans) {
	if (j == 30)
		return 1;
	if (r - l == 0)
		return 1;
	long long fl = 1;
	long long first_0 = -1, last_0 = -1, first_1 = -1, last_1 = -1;
	auto it = pos_0[j].lower_bound(l);
	if (it != pos_0[j].end() && *it <= r) {
		first_0 = *it;
		it = pos_0[j].upper_bound(r);
		it--;
		if (it != pos_0[j].end())
			last_0 = *it;
		else
			last_0 = first_0;
	}
	it = pos_1[j].lower_bound(l);
	if (it != pos_1[j].end() && *it <= r) {
		first_1 = *it;
		it = pos_1[j].upper_bound(r);
		it--;
		if (it != pos_1[j].end())
			last_1 = *it;
		else
			last_1 = first_1;
	}
	if (first_0 == -1 || first_1 == -1)
		return give_ans(j + 1, l, r, ans);
	if (last_0 < first_1) {
		if (ans[30 - j - 1] == 1)
			return 0;
		ans[30 - j - 1] = 0;
		return min(give_ans(j + 1, l, last_0, ans), give_ans(j + 1, first_1, r, ans));
	}
	if (last_1 < first_0) {
		if (ans[30 - j - 1] == 0)
			return 0;
		ans[30 - j - 1] = 1;
		return min(give_ans(j + 1, l, last_1, ans), give_ans(j + 1, first_0, r, ans));
	}
	if (first_1 < last_0 && first_1 > first_0)
		return 0;
	if (first_0 < last_1 && first_0 > first_1)
		return 0;
	if (last_1 < last_0 && last_1 > first_0)
		return 0;
	if (last_0 < last_1 && last_0 > first_1)
		return 0;
	return 1;
}

int main()
{
	cin >> n;
	p_pow[0] = 1;
	for (long long i = 1; i < 31; i++) {
		p_pow[i] = p_pow[i - 1] * 2;
	}
	vector<vector<long long>>v(n, vector<long long>(30, 0));
	for (long long i = 0; i < n; i++) {
		long long x;
		cin >> x;
		for (long long j = 0; j < 30 && x>0; j++) {
			if (p_pow[30 - j - 1] <= x) {
				v[i][j] = 1;
				x -= p_pow[30 - j - 1];
			}
		}
	}
	for (long long i = 0; i < n; i++)
		for (long long j = 0; j < 30; j++) {
			if (v[i][j] == 0)
				pos_0[j].insert(i);
			else
				pos_1[j].insert(i);
		}
	vector<long long>ans(30, -1);
	if (give_ans(0, 0, n - 1, ans) == 0)
		cout << -1 << endl;
	else {
		long long sum = 0;
		for (long long i = 0; i < 30; i++) {
			if (ans[i] == 1)
				sum += p_pow[i];
		}
		cout << sum << endl;
	}

	long long q;
	cin >> q;
	for (long long i = 0; i < q; i++) {
		long long pos, val;
		cin >> pos >> val;
		pos--;
		for (long long j = 0; j < 30 && val>0; j++) {
			v[pos][j] = 0;
			if (p_pow[30 - j - 1] <= val) {
				v[pos][j] = 1;
				val -= p_pow[30 - j - 1];
			}
		}
		for (long long j = 0; j < 30; j++) {
			pos_0[j].erase(pos);
			pos_1[j].erase(pos);
			if (v[pos][j] == 0)
				pos_0[j].insert(pos);
			else
				pos_1[j].insert(pos);
		}



		vector<long long>ans2(30, -1);
		if (give_ans(0, 0, n - 1, ans2) == 0)
			cout << -1 << endl;
		else {
			long long sum2 = 0;
			for (long long i1 = 0; i1 < 30; i1++) {
				if (ans2[i1] == 1)
					sum2 += p_pow[i1];
			}
			cout << sum2 << endl;
		}
	}
		return 0;
}