#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;
#define pb push_back
#define mp make_pair
#define pii pair <int, int>
#define ff first
#define ss second

bool solve_for_plus(vector <int> &a) {
	int n = a.size() / 2;
	vector <int> lm(n), rm(n);
	queue <int> q;
	for (int i = 0; i < n; ++i) {
		lm[i] = i * 2 - 1;
		rm[i] = i * 2 + 3;
		q.push(2 * i + 1);
	}
	vector <int> st;
	st.pb(0);
	for (int i : a)
		st.pb(st.back() + i);


	vector <bool> used(n, false);
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		if (used[v / 2])
			continue;
		int left = st[v] - st[lm[v / 2] + 1];
		int right = st[rm[v / 2]] - st[v] - a[v];
		if (left > a[v] || right > a[v]) {
			used[v / 2] = 1;
			if (lm[v / 2] != -1) {
				rm[lm[v / 2] / 2] = rm[v / 2];
				q.push(lm[v]);
			}
			if (rm[v / 2] != a.size()) {
				lm[rm[v / 2] / 2] = lm[v / 2];
				q.push(rm[v]);
			}
		}
	}

	for (auto i : used)
		if (!i)
			return 0;
	return 1;
}


bool solve() {
	string s, t;
	cin >> s >> t;
	if (s.size() != t.size())
		return 0;
	vector <int> sts, stt;
	sts.pb(0); stt.pb(0);
	for (int i = 1; i < s.size(); ++i)
		if (s[i] != s[i - 1])
			sts.pb(i);
	for (int i = 1; i < t.size(); ++i)
		if (t[i] != t[i - 1])
			stt.pb(i);

	int j = 0;
	for (auto i : stt) {
		while (j < sts.size() && sts[j] < i)
			j++;
		if (j == sts.size() || sts[j] != i)
			return 0;
	}
	stt.pb(s.size()); sts.pb(t.size());

	vector <pii> was, is;
	was.pb(mp(0, 0));
	for (int i = 0; i + 1 < sts.size(); ++i) 
		was.pb(mp(sts[i + 1] - sts[i], s[sts[i]] != t[sts[i]]));

	for (int i = 0; i + 1 < was.size(); ++i)
		if (was[i].ss && was[i + 1].ss)
			return 0;
	was.pb(mp(0, 0));

	int st = 0;
	while (st < was.size()) {
		while (st < was.size() && !was[st].ss)
			st++;
		if (st == was.size())
			break;
		int fn = st;
		while (fn + 2 < was.size() && was[fn + 2].ss)
			fn += 2;
		vector <int> a;
		for (int i = st - 1; i <= fn + 1; ++i)
			a.pb(was[i].ff);
		if (!solve_for_plus(a))
			return 0;
		st = fn + 2;
	}
	
	return 1;
}



int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);
	int q;
	cin >> q;
	while (q--) {
		if (solve())
			cout << "Yes\n";
		else
			cout << "No\n";
	}
}