#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <string>

using namespace std;

struct Point {
	int x, y, i;
	Point() {}
	Point(int x, int y, int i) : x(x), y(y), i(i) {}
	int operator ^(Point a) {
		return x * a.y - y * a.x;
	}
	Point operator - (Point a) {
		return{ x - a.x, y - a.y, -1 };
	}
};

vector < vector < Point > > conv;

const int MX = 100;

int main() {
	iostream::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);

	int n;
	cin >> n;

	vector < Point > all(n);
	for (int i = 0; i < n; i++) {
		int x, y;
		cin >> x >> y;
		all[i] = { x, y, i };
	}

	int ch[MX][MX][MX];
	for (int i = 0; i < n; i++) {
		for (int j = i + 1; j < n; j++) {
			for (int k = j + 1; k < n; k++) {
				ch[i][j][k] = 1;
				for (int e = 0; e < n; e++) {
					Point ij = all[j] - all[i], ik = all[k] - all[i], ie = all[e] - all[i];
					Point ki = all[i] - all[k], kj = all[j] - all[k], ke = all[e] - all[k];
					if ((ij ^ ie) * (ie ^ ik) > 0 && (ki ^ ke) * (ke ^ kj) > 0)
						ch[i][j][k] = 0;
				}
			}
		}
	}


	int q;
	cin >> q;

	while (q--) {
		bool is = 0;
		for (int i = 0; i < n && !is; i++) {
			for (int j = i + 1; j < n && !is; j++) {
				for (int k = j + 1; k < n && !is; k++) {
					if (!ch[i][j][k])
						continue;
					cout << "? 3 " << i + 1 << ' ' << j + 1 << ' ' << k + 1 << endl;
					string s;
					cin >> s;
					if (s == "Yes\n") {
						is = 1;
						cout << "! 3 " << i + 1 << ' ' << j + 1 << ' ' << ' ' << k + 1 << endl;
					}
				}
			}
		}
	}

	return 0;
}