#define _CRT_SECURE_NO_WARNINGS

#include <cstdio>
#include <algorithm>
#include <cmath>
#include <iostream>
#include <string>
#include <map>
#include <vector>

using namespace std;

typedef long long ll;

#define X first
#define Y second
#define inb push_back
#define mk make_pair
#define all(v) v.begin(), v.end()

int solve();

int main()
{
#define TASK "sequence"
#ifdef _DEBUG
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#else
	//freopen(TASK".in", "r", stdin), freopen(TASK".out", "w", stdout);
#endif
	solve();
}

bool ask(int x)
{
	cout << x << endl;
	int f;
	cin >> f;
	if (!f)
		exit(0);
	if (f > 0)
		return 1;
	return 0;
}

int solve()
{
	int n;
	cin >> n;
	int l = 1, r = n + 1;
	while (r - l > 1)
	{
		int m = l + r >> 1;
		if (!ask(m))
			r = m;
		else
			l = m;
	}
	cout << l;
	return 0;
}