#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<pair<long long, long long>> opt;
long long n, a;
vector<long long> cache;

long long solve(long long gen)
{
	if (cache[gen] != -1)
		return cache[gen];
	long long ans = INT64_MAX;
	for (int i = 0; i < n; ++i)
	{
		long long o = opt[i].first;
		long long c = opt[i].second;
		if (gen + o <= a)
		{
			long long v = solve(gen + o);
			ans = max(ans, v - c + 1000000000 * o);
		}
	}
	if (ans == INT64_MAX)
		return 0;
	return ans;
}

int main()
{
	cin >> n >> a;
	cache.resize(1001, -1);
	if (n == 1)
	{
		long long ans;
		long long l, r, c;
		cin >> l >> r >> c;
		if (r > a)
		{
			cout << 0 << endl;
			return 0;
		}
		long long lx = 0;
		long long rx = 0;
		long long x = 0;
		while (rx + r <= a)
		{
			lx += l;
			rx += r;
			x++;
		}
		long long am = a - r + 1;
		if (am < lx)
			am = lx;
		long long income = 1000000000 * am;
		while (am >= (lx + l) && am <= (rx + r))
		{
			lx += l;
			rx += r;
			x++;
		}
		income -= c * x;
		cout << income << endl;
		return 0;
	}
	for (int i = 0; i < n; ++i)
	{
		long long l, r, c;
		cin >> l >> r >> c;
		opt.push_back(make_pair(l, c));
	}
	cout << solve(0) << endl;
	return 0;
}