#include <bits/stdc++.h>

using namespace std;

#define Y second
#define X first

typedef long long ll;

const ll INF = 1e9;
ll n, a;

void solve1() {
    ll l, r, c;
    cin >> l >> r >> c;

    ll ans = 0;
    ll nows = 0;

    ll nl = 0, nr = 0;

    while (true) {
        if (nl + r > a)
            break;

        nl += l;
        nr += r;
        nr = min(nr, a);
        nows++;

        ans = max(ans, nl * INF - nows * c);
    }
    cout << ans << endl;
}

void solve2() {
    vector<ll> l(n), c(n), d(a + 1, -1);
    ll ans = 0;

    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> l[i] >> c[i];
    }
    d[0] = 0;
    for (int i = 1; i <= a; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i >= l[j] && d[i - l[j]] != -1) {
                d[i] = max(d[i - l[j]] + l[j] * INF - c[j], d[i]);
            }
        }
    }
    cout << *max_element(d.begin(), d.end());
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(false);

    cin >> n >> a;

    if (n == 1) {
        solve1();
    } else {
        solve2();
    }


    return 0;
}
