import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class A {
	public static void main(String[] args) throws IOException {
		BufferedReader bf = new BufferedReader(new InputStreamReader(System.in));

		int n = Integer.parseInt(read(bf));

		char[] res = new char[n];

		Arrays.fill(res, '#');

		int cnt = 0;

		for (int i = 0; i < n - 1; i++) {
			ask(i, i + 1);

			String ans = read(bf);

			if (ans.equals("Yes")) {
				res[i] = '(';
				res[i + 1] = ')';
				i++;
				cnt += 2;
			}
		}

		while (cnt != n) {
			for (int i = 0; i < n; i++) {
				if (res[i] != '#') {
					int ff = i;

					while (i < n && res[i] != '#') {
						i++;
					}

					i--;

					int ll = i;

					int centrum = (ll + ff) / 2;

					int left = (ll - ff + 1) / 2;

					int right = Math.min(n - ll - 1, ff) + left + 1;

					while (left + 1 < right) {
						int mid = (left + right) / 2;

						ask(centrum - mid + 1, centrum + mid);

						String ans = read(bf);

						if (ans.equals("Yes")) {
							left = mid;
						} else {
							right = mid;
						}
					}

					for (int j = centrum - left + 1; j < ff; j++) {
						if (res[j] == '#') {
							res[j] = '(';
							cnt++;
						}
					}

					for (int j = ll + 1; j <= centrum + left; j++) {
						if (res[j] == '#') {
							res[j] = ')';
							cnt++;
						}
					}
				}
			}
		}

		System.out.print("! ");

		for (int i = 0; i < n; i++) {
			System.out.print(res[i]);
		}
		System.out.flush();
	}

	private static void ask(int i, int j) {
		i++;
		j++;
		System.out.println("? " + i + " " + j);
		System.out.flush();
	}

	private static String read(BufferedReader bf) throws IOException {
		StringTokenizer st = new StringTokenizer(bf.readLine());

		return st.nextToken();
	}
}
