#include <bits/stdc++.h>

using namespace std;
using pii = pair<int, int>;
using ll = long long;
using pil = pair<int, ll>;
using pili = pair<pil, int>;

#define mp make_pair

vector<vector<pii>> list_gr;
vector<int> dist;
vector<ll> sq_dist;
int n;

class pair_less_comporator
{
public:
	bool operator()(pili a, pili b)
	{
		if (a.first.first != b.first.first)
			return a.first.first > b.first.first;
		return a.first.second < b.first.second;
	}
};

void djikstra()
{
	dist[0] = 0;
	sq_dist[0] = 0;
	priority_queue<pili, vector<pili>, pair_less_comporator> pr;
	pr.push(mp(mp(0, 0), 0));
	while (pr.size())
	{
		pili k;
		while (pr.size())
		{
			k = pr.top();
			pr.pop();
			if (dist[k.second] == k.first.first && sq_dist[k.second] == k.first.second)
				break;
			k = mp(mp(-1, -1), -1);
		}
		if (k.second == -1)
		{
			break;
		}
		auto v = k.second;
		for (auto x : list_gr[v])
		{
			if (dist[x.first] > dist[v] + x.second || 
				(dist[x.first] == dist[v] + x.second && sq_dist[x.first] < sq_dist[v] + x.second * x.second))
			{
				dist[x.first] = dist[v] + x.second;
				sq_dist[x.first] = sq_dist[v] + x.second * x.second;
				pr.push(mp(mp(dist[v], sq_dist[v]), v));	
			}
		}
	}
}

void input_edge()
{
	int s;
	cin >> s;
	int prv, d, v;
	cin >> prv;
	--prv;
	for (int i = 0; i < s; ++i)
	{
		cin >> d >> v;
		list_gr[prv].push_back({v - 1, d});
		prv = v;
	}
}

void input()
{
	cin >> n;
	list_gr.resize(n);
	dist.resize(n, 2000000000);
	sq_dist.resize(n, 0);
	int m;
	cin >> m;
	for (int i = 0; i < m; ++i)
		input_edge();
}

int main()
{
	input();
	djikstra();
	cout << dist.back() << " " << sq_dist.back() << endl;
}