#include <bits/stdc++.h>
 
using namespace std;
using pbi = pair<bool, int>;
 
void process(vector<pbi> &v)
{
	if (v.size() <= 1)
		return;
	if (!v.back().first)
	{
		auto x = v.back();
		v.pop_back();
		if (v.back().second > x.second)
		{
			v.back().second += x.second;
			process(v);
			return;
		}
		v.push_back(x);
		return;
	}
	if (v.size() <= 1)
		return;
	auto x = v.back();
	v.pop_back();
	while (v.size())
	{
		if (v.back().first)
		{
			x.second += v.back().second;
			v.pop_back();
		}
		else
			if (v.back().second < x.second)
			{
				x.second += v.back().second;
				v.pop_back();
			}
			else
				break;
	}
	v.push_back(x);
}

bool can_solve(string a, bool b)
{
    vector<pbi> v;
    int prev = -1;
    for (auto &x : a)
        x = (x == '+');
    for (auto x : a)
    {
        if (x == prev)
            ++v.back().second;
        else
        {
            v.push_back({x, 1});
            prev = x;
        }
    }
    for (auto &x : v)
    	x.first ^= b;
    vector<pbi> stack;
    for (auto x : v)
    {
    	stack.push_back(x);
    	process(stack);
    	// for (auto x : stack)
    	// 	cout << x.first << " ";
    	// cout << endl;
    	// for (auto x : stack)
    	// 	cout << x.second << " ";
    	// cout << endl << endl;
    }
    if (stack.size() > 1)
    	return false;
    if (!stack.back().first)
    	return false;
    return true;
}
 
string get_rand_string(int l)
{
    string s;
    for (int i = 0; i < l; ++i)
        s += ((rand() & 1) ? '+' : '-');
    return s;
}

bool can_solve(string a, string b)
{
	int n = a.length();
	for (int i = 1; i < n; ++i)
		if (b[i] != b[i - 1] && a[i] == a[i - 1])
			return false;
	string test;
	test += a[0];
	for (int i = 1; i < n; ++i)
	{
		if (b[i] != b[i - 1])
		{
			if (!can_solve(test, b[i - 1] == '-'))
				return false;
			if (a[i - 1] != b[i - 1] && a[i] != b[i])
				return false;
			test = "";
		}
		test += a[i];
	}
	if (!can_solve(test, b.back() == '-'))
		return false;
	return true;
}

int main()
{
    int n;
    cin >> n;
    string a, b;
    for (int i = 0; i < n; ++i)
    {
    	cin >> a >> b;
    	if (can_solve(a, b))
    		cout << "Yes" << endl;
    	else
    		cout << "No" << endl;
    }
}