import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class Main {
    public void solve() throws IOException {
        int n = nextInt();
        int l = 1;
        int r = n;
        boolean x = false;
        int t = 0;
        TreeSet<Integer> q = new TreeSet<>();
        while (r - l > 1) {
            int m = (l + r) / 2;
            q.add(m);
            out.println(m);
            out.flush();
            int y = nextInt();
            if (y == 0) {
                x = true;
                break;
            } else {
                if (y == 1) {
                    l = m + 1;
                } else {
                    r = m - 1;
                }
            }
        }
        if (!x) {
            if (!q.contains(l)) {
                out.println(l);
                out.flush();
                int y = nextInt();
                if (y != 0) {
                    out.println(r);
                }
            }else {
                out.println(r);
            }
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
//            br = new BufferedReader(new FileReader("sum.in"));
//            out = new PrintWriter(new File("sum.out"));
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}