#include <iostream>
#include <vector>

using namespace std;

const long long inf = 1000000000000000009;

int main() {
    long long n, m;
    cin >> n >> m;
    vector <pair <long long, long long> > res(n, {inf, 0});
    res[0].first = 0;
    vector <bool> used(n, false);
    vector <vector <pair<long long, long long> > > gr1(n);
    vector <vector <pair<long long, long long> > > tr(m);
    long long s, v, t;
    for (long long i = 0; i < m; i++){
        cin >> s;
        cin >> v;
        tr[i].push_back(make_pair(v - 1, 0));
        gr1[v - 1].push_back(make_pair(i, 0));
        for (long long j = 0; j < s; j++) {
            cin >> t >> v;
            tr[i].push_back(make_pair(v - 1, tr[i][tr[i].size() - 1].second + t));
            gr1[v - 1].push_back(make_pair(i, j + 1));
        }
    }
    for (long long i = 0; i < n - 1; i++){
        long long indn = -1;
        for (long long j = 0; j < n; j++){
            if (!used[j]){
                if (indn == -1 || res[indn].first > res[j].first){
                    indn = j;
                }
            }
        }
        used[indn] = true;
        for (long long j = 0; j < (long long) gr1[indn].size(); j++){
            long long trnow = gr1[indn][j].first, pos = gr1[indn][j].second;
            for (long long k = pos + 1; k < (long long) tr[trnow].size(); k++){
                long long u = tr[trnow][k].first;
                long long r1 = tr[trnow][k].second - tr[trnow][pos].second;
                if (res[u].first > res[indn].first + r1 || (res[u].first == res[indn].first && res[u].second < res[indn].second + r1 * r1)){
                    res[u] = make_pair(res[indn].first + r1, res[indn].second + r1 * r1);
                }
            }
        }
    }
    cout << res[n - 1].first << " " << res[n - 1].second << endl;
    return 0;
}