#include <iostream>
#include <vector>

using namespace std;

const long long inf = 1000000000;
vector <long long> l, r, c;
long long n, a;

long long gen(long long now, long long s){
    long long res = inf * now - s;
    for (long long i = 0; i < n; i++){
        if (now + r[i] <= a){
            long long tempres = gen(now + l[i], s + c[i]);
            for (long long j = now + l[i] + 1; j <= now + r[i]; j++){
                tempres = min(gen(j, s + c[i]), tempres);
            }
            res = max(tempres, res);
        }
    }
    return res;
}

int main() {
    cin >> n >> a;
    l.resize(n);
    r.resize(n);
    c.resize(n);
    for (long long i = 0; i < n; i++){
        cin >> l[i] >> r[i] >> c[i];
    }
    if (n == 1) {
        cout << gen(0, 0);
        return 0;
    }
    else {
        vector <long long> res(a + 1, inf * inf);
        res[0] = 0;
        long long res2 = 0;
        for (int i = 0; i < n; i++){
            for (int j = 0; j <= a - r[i]; j++){
                res[j + r[i]] = min(res[j] + c[i], res[j + r[i]]);
                res2 = max(res2, (j + r[i]) * inf - res[j + r[i]]);
            }
        }
        cout << res2;
    }
}