#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main() {
    int n, m, tmp;
    cin >> n >> m;
    vector <long long> prsma(n + 1, 0), prsmb(m + 1, 0);
    vector <int> lsa(n), lsb(m);
    for (int i = 0; i < n; i++){
        cin >> lsa[i];
    }
    for (int i = 0; i < n; i++){
        cin >> tmp;
        prsma[i + 1] = prsma[i] + tmp;
    }
    for (int i = 0; i < m; i++){
        cin >> lsb[i];
    }
    for (int i = 0; i < m; i++){
        cin >> tmp;
        prsmb[i + 1] = prsmb[i] + tmp;
    }
    long long r1 = prsma[n], r2 = 1, r3 = n, r4 = 0, r5 = 0;
    if (prsmb[m] > r1){
        r1 = prsmb[m];
        r2 = 0; r3 = 0; r4 = 1; r5 = m;
    }
    set <int> now;
    for (int i = 0; i < n; i++){
        now.clear();
        for (int j = i; j < n; j++){
            now.insert(lsa[j]);
            int prs = -1;
            for (int ii = 0; ii < m; ii++){
                if (now.count(lsb[ii])) {
                    if (prsma[j + 1] - prsma[i] + prsmb[ii] - prsmb[prs + 1] > r1) {
                        r1 = prsma[j + 1] - prsma[i] + prsmb[ii] - prsmb[prs + 1];
                        r2 = i + 1;
                        r3 = j + 1;
                        r4 = prs + 2;
                        r5 = ii;
                    }
                    prs = ii;
                }
            }
            if (prsma[j + 1] - prsma[i] + prsmb[m] - prsmb[prs + 1] > r1){
                r1 = prsma[j + 1] - prsma[i] + prsmb[m] - prsmb[prs + 1];
                r2 = i + 1;
                r3 = j + 1;
                r4 = prs + 2;
                r5 = m;
            }
        }
    }
    cout << r1 << endl << r2 << " " << r3 << endl << r4 << " " << r5 << endl;
    return 0;
}