#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<int> a1(n), b1(n), a2(m), b2(m);
	for (int i = 0; i < n; i++) {
		cin >> a1[i];
	}
	for (int i = 0; i < n; i++) {
		cin >> b1[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> a2[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> b2[i];
	}
	int ans_l1 = -1;
	int ans_r1 = -1;
	int ans_l2 = -1;
	int ans_r2 = -1;
	long long ans_sum = -1;
	for (int l = 0; l < n; l++) {
		for (int r = l - 1; r < n; r++) {
			set<int> s;
			long long sum1 = 0;
			for (int i = l; i <= r; i++) {
				s.insert(a1[i]);
				sum1 += b1[i];
			}
			vector<bool> can(m);
			for (int i = 0; i < m; i++) {
				if (s.find(a2[i]) != s.end()) {
					can[i] = false;
				}
				else {
					can[i] = true;
				}
			}
			long long sum = 0;
			long long sum2 = 0;
			int l2 = -1;
			int r2 = -1;
			int now_l = 0;
			for (int i = 0; i < m; i++) {
				if (can[i]) sum += b2[i];
				else {
					if (sum2 < sum) {
						sum2 = sum;
						l2 = now_l;
						r2 = i - 1;
					}
					sum = 0;
					now_l = i + 1;
				}
			}
			if (sum2 < sum) {
				sum2 = sum;
				l2 = now_l;
				r2 = m - 1;
			}
			if (sum1 + sum2 > ans_sum) {
				ans_sum = sum1 + sum2;
				ans_l1 = l;
				ans_r1 = r;
				ans_l2 = l2;
				ans_r2 = r2;
			}
		}
	}
	cout << ans_sum << endl;
	if (ans_l1 <= ans_r1) {
		cout << ans_l1 + 1 << ' ' << ans_r1 + 1 << endl;
	}
	else {
		cout << 0 << ' ' << 0 << endl;
	}
	if (ans_l2 <= ans_r2) {
		cout << ans_l2 + 1 << ' ' << ans_r2 + 1 << endl;
	}
	else {
		cout << 0 << ' ' << 0 << endl;
	}
    return 0;
}

