#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 2e5 + 10;

int n;
int t[MAX_N];
int L[MAX_N], R[MAX_N];
int dpl[MAX_N], dpr[MAX_N];
int dp2l[MAX_N], dp2r[MAX_N];

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n;
    if (n == 1) {
        cout << "0\n";
        return 0;
    }
    for (int i = 0; i < n; i++) {
        cin >> t[i];
    }
    for (int i = 0; i < n - 1; i++) {
        cin >> L[i] >> R[i];
    }
    fill(dpl, dpl + n, -1);
    fill(dpr, dpr + n, -1);
    fill(dp2l, dp2l + n, -1);
    fill(dp2r, dp2r + n, -1);
    for (int i = 0; i < n - 1; i++) {
        if (i == 0) {
            dpl[i] = max(0, L[i] - t[i + 1]);
            dpr[i] = R[i];
            continue;
        }
        int p = dpl[i - 1];
        int q = dpr[i - 1];
        dpl[i] = max(p, L[i]);
        dpr[i] = min(q, R[i]);
        if (L[i] >= L[i - 1] && L[i] >= p && L[i] <= q) {
            dpl[i] = min(dpl[i], max(0, L[i] - t[i + 1]));
        }
        if (dpl[i] > dpr[i]) {
            dpl[i] = -1;
            dpr[i] = -1;
            break;
        }
    }
    for (int i = n - 2; i >= 0; i--) {
        if (i == n - 2) {
            dp2l[i] = max(0, L[i] - t[i]);
            dp2r[i] = R[i];
            continue;
        }
        int p = dp2l[i + 1];
        int q = dp2r[i + 1];
        dp2l[i] = max(p, L[i]);
        dp2r[i] = min(q, R[i]);
        if (L[i + 1] <= L[i] && L[i] >= p && L[i] <= q) {
            dp2l[i] = min(dp2l[i], max(0, L[i] - t[i]));
        }
        if (dp2l[i] > dp2r[i]) {
            dp2l[i] = -1;
            dp2r[i] = -1;
            break;
        }
    }
    for (int i = 0; i < n; i++) {
        if (i == 0) {
            cout << dp2l[i] << "\n";
            continue;
        }
        if (i == n - 1) {
            cout << dpl[i - 1] << "\n";
            continue;
        }
        if (dpl[i - 1] == -1 || dp2l[i] == -1) {
            cout << "-1\n";
            continue;
        }
        cout << max(dpl[i - 1], dp2l[i]) << "\n";
    }
}
