#include <bits/stdc++.h>

using namespace std;

const long long COST = 1e9;
const long long INF = 2e18;
const int MAX_N = 1e5 + 10;

int n, a;
long long tree[4 * MAX_N], topush[4 * MAX_N];
long long L[110], R[110], c[110];

void push(int v) {
    if (topush[v]) {
        topush[2 * v + 1] += topush[v];
        topush[2 * v + 2] += topush[v];
        topush[v] = 0;
    }
}

void st(int v, int L, int R, int pos, long long val) {
    if (pos < L || pos >= R) {
        return;
    }
    if (R - L == 1) {
        tree[v] = val;
        return;
    }
    push(v);
    int M = (R + L) / 2;
    st(2 * v + 1, L, M, pos, val);
    st(2 * v + 2, M, R, pos, val);
    tree[v] = min(tree[2 * v + 1] + topush[2 * v + 1], tree[2 * v + 2] + topush[2 * v + 2]);
}

void add(int v, int L, int R, int a, int b, long long val) {
    if (L >= b || R <= a) {
        return;
    }
    if (a <= L && R <= b) {
        topush[v] += val;
        return;
    }
    int M = (R + L) / 2;
    push(v);
    add(2 * v + 1, L, M, a, b, val);
    add(2 * v + 2, M, R, a, b, val);
    tree[v] = min(tree[2 * v + 1] + topush[2 * v + 1], tree[2 * v + 2] + topush[2 * v + 2]);
}

inline long long mn(int v, int L, int R, int a, int b) {
    if (L >= b || R <= a) {
        return INF;
    }
    if (a <= L && R <= b) {
        return tree[v] + topush[v];
    }
    push(v);
    int M = (R + L) / 2;
    long long ans = min(mn(2 * v + 1, L, M, a, b), mn(2 * v + 2, M, R, a, b));
    tree[v] = min(tree[2 * v + 1] + topush[2 * v + 1], tree[2 * v + 2] + topush[2 * v + 2]);
    return ans;
}

int main() {
    freopen("anti.in", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> a;
    for (int i = 0; i < n; i++) {
        cin >> L[i] >> R[i] >> c[i];
    }
    st(0, 0, a + 1, a, 0);
    for (int i = a - 1; i >= 0; i--) {
        add(0, 0, a + 1, i + 1, a + 1, COST);
        long long mx = 0;
        for (int i = 0; i < n; i++) {
            if (i + R[i] > a) {
                continue;
            }
            mx = max(mx, mn(0, 0, a + 1, i + L[i],i + R[i] + 1) - c[i]);
        }
        st(0, 0, a + 1, i, mx);
    }
    cout << mn(0, 0, a + 1, 0, 1) << "\n";
}
