#include<iostream>
#include<string>
#include<map>
#include<vector>
#include<stack>
#include<algorithm>

using namespace std;

bool used[5113];
int n;
vector<pair<int, int>> p;
vector<int> w;

void dfs(int v, int t)
{
	used[v] = 1;
	if (v > 0)
		if (!used[v - 1])
			if (max(t, p[v - 1].first) <= min(t + w[v], p[v - 1].second))
				dfs(v - 1, max(t, p[v - 1].first));
	if (v < n - 1)
		if (!used[v + 1])
			if (max(t, p[v].first) <= min(t + w[v], p[v].second))
				dfs(v + 1, max(t, p[v].first));
}

int main()
{
	int a, b;
	cin >> n;
	bool tr = true, tr2 = true;
	for (int i = 0; i < n; i++)
	{
		cin >> a;
		w.push_back(a);
	}
	for (int i = 0; i + 1 < w.size(); i++)
		if (w[i] != 5000 && w[i] != 1e9)
			tr = false;	
	if (n == 1)
	{
		cout << 0 << endl;
		return 0;
	}
	for (int i = 0; i < n - 1; i++)
	{
		cin >> a >> b;
		p.push_back(make_pair(a, b));
	}
	for (int i = 0; i < n - 1; i++)
		if (p[i].second != 5000)
			tr2 = false;
	if (tr)
	{
		vector<pair<int, int>> p2, p3;
		p2.push_back(make_pair(max(p[n - 2].first - w[n - 2], 0), p[n - 2].second));
		for (int i = n - 3; i >= 0; i--)
			if (max(p[i].first, (p2.back()).first) <= min(p[i].second, (p2.back().second)))
				p2.push_back(make_pair(max(max(p[i].first - w[i], 0), (p2.back()).first), min(p[i].second, (p2.back()).second)));
			else
				p2.push_back(make_pair(max(p[i].first, (p2.back()).first), min(p[i].second, (p2.back()).second)));
		for (int i = 0; i < n; i++)
		{
			if (i == 0)
			{
				if (p2.back().first >(p2.back()).second)
					cout << "-1" << endl;
				else
					cout << p2.back().first << endl;
			}
			else
			{
				pair<int, int> d = make_pair(max(p[i - 1].first - w[i], 0), p[i - 1].second);
				if (p3.size() != 0)
				{
					if (max(p[i - 1].first, (p3.back()).first) <= min(p[i - 1].second, (p3.back().second)))
						p3.push_back(make_pair(max(max(p[i - 1].first - w[i], 0), (p3.back()).first), min(p[i - 1].second, (p3.back().second))));
					else
						p3.push_back(make_pair(max(p[i - 1].first, (p3.back()).first), min(p[i - 1].second, (p3.back().second))));
				}
				else
					p3.push_back(d);
				if (p2.size() == 0)
					if (p3.back().first > p3.back().second)
						cout << "-1" << endl;
					else
						cout << p3.back().first << endl;
				else
				{
					if (p2.back().first > p2.back().second || p3.back().first > p3.back().second)
						cout << "-1" << endl;
					else
					{
						d = make_pair(max(p2.back().first, p3.back().first), min(p2.back().second, p3.back().second));
						if (d.first > d.second)
							cout << "-1" << endl;
						else
							cout << d.first << endl;
					}
				}
			}
			if (p2.size())
				p2.pop_back();
		}
	}
	else if (tr2)
	{
		for (int i = 0; i < n; i++)
		{
			int l, r, j;
			if (i + 1 < n)
				l = 0, r = p[i].second + 1;
			else
				l = 0, r = p[i - 1].second + 1;
			while(l + 1 < r)
			{
				long long m = (l + r) / 2;
				dfs(i, m);
				int k = 0;
				for (int i = 0; i < n; i++)
				{
					if (used[i])
					{
						k++;
						used[i] = 0;
					}
				}
				if (k == n)
					l = m;
				else
					r = m;
			}
			cout << l << endl;
		}
	}
	else
	{
		for (int i = 0; i < n; i++)
		{
			int l, r, j;
			if (i + 1 < n)
				l = max(p[i].first - w[i], 0), r = p[i].second + 1;
			else
				l = max(p[i - 1].first - w[i], 0), r = p[i - 1].second + 1;
			for (j = l; j <= r; j++)
			{
				dfs(i, j);
				int k = 0;
				for (int i = 0; i < n; i++)
				{
					if (used[i])
					{
						k++;
						used[i] = 0;
					}
				}
				if (k == n)
					break;
			}
			if (j == r + 1)
				cout << -1 << endl;
			else
				cout << j << endl;
		}
	}
}
/*
3
1 2 4
7 10
3 5

4
1 0 3 2
4 6
5 5
7 10
*/