// C.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <math.h>

using namespace std;

struct p
{
	int x, y;

	p() {}
	p(int _x, int _y)
	{
		x = _x;
		y = _y;
	}
};

int n;
vector<p> arr;
const double EPS = 0.000001;

bool inside(int q, int a, int b, int c)
{
	int x1 = arr[q].x - arr[a].x;
	int y1 = arr[q].y - arr[a].y;
	int x2 = arr[b].x - arr[a].x;
	int y2 = arr[b].y - arr[a].y;
	long long cp1 = x1 * y2 - y1 * x2;

	x1 = arr[q].x - arr[b].x;
	y1 = arr[q].y - arr[b].y;
	x2 = arr[c].x - arr[b].x;
	y2 = arr[c].y - arr[b].y;
	long long cp2 = x1 * y2 - y1 * x2;

	x1 = arr[q].x - arr[c].x;
	y1 = arr[q].y - arr[c].y;
	x2 = arr[a].x - arr[c].x;
	y2 = arr[a].y - arr[c].y;
	long long cp3 = x1 * y2 - y1 * x2;

	bool b1 = cp1 > 0;
	bool b2 = cp2 > 0;
	bool b3 = cp3 > 0;

	return (b1 == b2 && b2 == b3 && b3 == b1);
}

bool no_ins(int a, int b, int c)
{
	for (int i = 0; i < n; ++i)
	{
		if (i != a && i != b && i != c && inside(i, a, b, c))
		{
			return false;
		}
	}
	return true;
}

void get()
{
	for (int i = 0; i < n; ++i)
	{
		for (int j = i + 1; j < n; ++j)
		{
			for (int k = j + 1; k < n; ++k)
			{
				if (no_ins(i, j, k))
				{
					cout << "? 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;

					string res;
					cin >> res;
					if (res == "Yes")
					{
						cout << "! 3 " << i + 1 << " " << j + 1 << " " << k + 1 << endl;
						return;
					}
				}
			}
		}
	}
}

int main()
{
	cin >> n;

	for (int i = 0; i < n; ++i)
	{
		int _x, _y;
		cin >> _x >> _y;
		arr.push_back(p(_x, _y));
	}

	int q;
	cin >> q;

	for (int o = 0; o < q; ++o)
	{
		get();
	}

	return 0;
}

