#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <algorithm>
#include <utility>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <queue>

using namespace std;

void ans(bool ok) {
	if (ok)
		cout << "Yes\n";
	else
		cout << "No\n";
}

int len(pair<int, int> a) {
	return a.second - a.first + 1;
}

int main() {
	srand(1231);
	ios_base::sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
	int q;
	cin >> q;
	while (q--) {
		string s, t;
		cin >> s >> t;
		if (s == t) {
			ans(1);
			continue;
		}
		set< pair<int, int> > S2;
		string cur = "";
		cur += s[0];
		int n = s.size();
		int i = 1;
		int fs = i - 1;
		vector<pair<int, int> > S;
		while (i < n) {
			while (i < n && s[i] == s[i - 1]) {
				cur += s[i];
				i++;
			}
			if (cur.back() != '+') {
				S.push_back(make_pair(fs, i - 1));
			}
			S2.insert(make_pair(fs, i - 1));
			cur = "";
			if (i < n) {
				cur += s[i];
				i++;
			}
			fs = i - 1;
		}
		if (cur != "") {
			if (cur.back() != '+') {
				S.push_back(make_pair(fs, i - 1));
			}
			S2.insert(make_pair(fs, i - 1));
		}
		queue<pair<pair<int, int>, int> > Q;
		random_shuffle(S.begin(), S.end());
		for (auto i : S) {
			Q.push({ i, -1 });
		}
		bool fl = true;
		while (!Q.empty()) {
			auto cur = Q.front();
			Q.pop();

			if (S2.count(cur.first) == 0)
				continue;
			pair<int, int> c1 = make_pair(0, -1000000000), c2 = make_pair(0, -1000000000);
			auto it = S2.find(cur.first);
			if (it != S2.begin()) {
				auto it2 = S2.find(cur.first);
				it2--;
				c1 = *it2;
			}
			it++;
			if (it != S2.end()) {
				c2 = *it;
			}
			if (len(c1) <= len(cur.first) && len(c2) <= len(cur.first)) {
				Q.push({ cur.first, S2.size() }
				);
				if (S2.size() == cur.second) {
					fl = false;
					break;
				}
				continue;
			}
			else {
				S2.erase(cur.first);
				S2.erase(c1);
				S2.erase(c2);
				pair<int, int> nw = { c1.first, c2.second };
				if (c1.second == -1000000000)
					nw.first = cur.first.first;
				if (c2.second == -1000000000)
					nw.second = cur.first.second;
				S2.insert(nw);
			}
		}
		if (fl)
			ans(1);
		else {
			ans(0);
		}
	}

	return 0;
}