#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <memory.h>
#include <set>
#include <map>

using namespace std;

const long long INF = 1e18 + 7;

int main()
{
    //freopen("input.txt", "r", stdin);
    //freopen("storage.in", "r", stdin);
    //freopen("storage.out", "w", stdout);
    ios_base::sync_with_stdio(0);
    long long n, a, dp[2007];
    cin >> n >> a;
    vector <pair <pair <long long, long long>, long long>> v;
    for (int i = 0; i < n; ++i) {
        long long l, r, c;
        cin >> l >> r >> c;
        v.push_back({{l, r}, c});
    }
    for (int i = 1; i <= a; ++i) {
        dp[i] = INF;
    }
    dp[0] = 0;
    for (int i = 1; i <= a; ++i) {
        for (int j = 0; j < n; ++j) {
            long long l = v[j].first.first, c = v[j].second;
            if (i - l >= 0) {
                dp[i] = min(dp[i - l] + c, dp[i]);
            }
        }
    }
    long long mx = 0;
    for (int i = 0; i <= a; ++i) {
        mx = max(mx, i * 1000000000 - dp[i]);
    }
    cout << mx << endl;
    return 0;
}
