#include <iostream>

using namespace std;

const int MAXA = 50000;
const int MAXN = 100;
const int INF = 1e9 ;
int dpl[MAXA];
int dpc[MAXA];
int c[MAXN];
int L[MAXN];
int R[MAXN];


int main(){
    int n;
    int a;
    cin >> n >> a;
    a += 1;
    for (int i = 0; i < n; i++){
        cin >> L[i] >> R[i] >> c[i];
    }

    for (int i = 0; i < n; i++){
        int wl = L[i];
        int wr = R[i];
        int wc = c[i];
        for (int r = wr; r < MAXA; r++){
            int cl = dpl[r - wr] + wl;
            cl = max(cl, r - wr + 1);
            int cost = dpc[r - wr] + wc;
            if (dpl[r] < cl){
                dpl[r] = cl;
                dpc[r] = cost;
            }
            else if (dpl[r] == cl){
                if (dpc[r] > cost){
                    dpc[r] = cost;
                }
            }
        }
    }
    int ML = 0;
    int MC = INF;
    for (int r = 0; r < a; r++){
        cout << r << ' ';
    }
    cout << endl;
    for (int r = 0; r < a; r++){
        cout << dpl[r] << ' ';
    }
    cout << endl;
    for (int r = 0; r < a; r++){
        cout << dpc[r] << ' ';
    }
    cout << endl;
    for (int r = 0; r < a; r++){
        if (dpl[r] > ML){
            ML = dpl[r];
            MC = dpc[r];
        }
        else if (dpl[r] == ML){
            MC = min(MC, dpc[r]);
        }
    }
    cout << (long long)ML * INF - MC;
}
