#include <bits/stdc++.h>

using namespace std;

const int MAXN = 1e6 + 2;

vector <int> rootR(MAXN);
vector <int> root(MAXN);

int getR(int n)
{
    return (root[n] == n ? n : getR(root[n]));
}

void merge(int n1, int n2)
{
    n1 = getR(n1);
    n2 = getR(n2);
    int r1 = rootR[n1];
    int r2 = rootR[n2];
    if (r1 < r2)
        swap(n1, n2);
    if (r1 == r2)
        rootR[n1]++;
    root[n2] = n1;
}

struct el
{
    int n;
    bool t;
    int ind;
};

bool operator <(el a, el b)
{
    return a.n < b.n;
}

void solve(string s, string t)
{
    int n = s.size();

    vector <el> st(n + 1);
    multiset <el> st2;
    int c = 0;
    for (int i = 0; i < n; i++)
    {
        int k = 1;
        while (i < n - 1 && s[i] != t[i] && s[i] == s[i + 1])
        {
            if (s[i + 1] == t[i + 1])
            {
                cout << "No\n";
                return;
            }
            k++;
            i++;
        }

        if (s[i] != t[i])
            st[c++] = {k, s[i] == '+', c};
        else
        {
            k = 1;
            while (i < n - 1 && s[i] == s[i + 1])
            {
                i++;
                k++;
            }
            st2.insert({k, s[i] == '+', c++});
        }
    }

    for (int i = 0; i < n; i++)
    {

    }
}

void solve2(string s, string t)
{
    int n = s.size();
    vector <int> sz(n);
    int mx = 0, ind = 0;
    int c = 0;

    for (int i = 0; i < n;)
    {
        if (s[i] == '+')
        {
            int k = 0;
            while (i < n && s[i] == '+')
                k++, i++;
            sz[c++] = k;
            if (k > mx)
            {
                ind = c - 1;
                mx = k;
            }
        }
        else
        {
            int k = 0;
            while (i < n && s[i] == '-')
                k++, i++;
            sz[c++] = k;
        }
    }

    int l = ind - 1, r = ind + 1;
    for (int i = 0; i < n; i++)
    {
        bool sw = 0;

        if (l >= 0 && sz[l] < mx)
        {
            mx += sz[l];
            l--;
            if (l >= 0)
                mx += sz[l];
            l--;
            sw = 1;
        }

        if (r < n && sz[r] < mx)
        {
            mx += sz[r];
            r++;
            if (r < n)
                mx += sz[r];
            r++;
            sw = 1;
        }

        if (mx == n)
        {
            cout << "Yes\n";
            return;
        }
        if (!sw)
        {
            cout << "No\n";
            return;
        }
    }
}

int main()
{
#ifdef PC
    freopen("in", "r", stdin);
#endif
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        string s, t;
        cin >> s >> t;
        //solve(s, t);
        solve2(s, t);
    }

    return 0;
}
