#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#define X first
#define Y second
typedef long long ll;
const ll INF = 1e18;
using namespace std;

vector<ll> b;
vector<pair<ll, ll> > l, r;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ll n;
	cin >> n;
	b.resize(n);
	for (ll i = 0; i < n; i++)
		cin >> b[i];
	l.resize(n), r.resize(n);
	for (ll i = 0; i < n - 1; i++) {
		cin >> l[i].X >> l[i].Y;
		r[i + 1] = l[i];
	}
	vector<pair<ll, ll> > p(n, { 0,INF }), s(n, { 0,INF });
	vector<bool> bad(n, false),bad2(n,false);
	for (ll i = n - 2; i >= 0; i--) {
		if (s[i + 1].X <= r[i + 1].X)
			s[i].X = max(0ll, r[i + 1].X - b[i]);
		else s[i].X = max(0ll, max(s[i + 1].X,r[i+1].X));
		s[i].Y = min(s[i + 1].Y, r[i+1].Y);
		bad2[i] = max(bad2[i], bad2[i + 1]);
		bad2[i] = max(bool(bad2[i]), bool(s[i + 1].X>r[i + 1].Y || s[i + 1].Y < r[i + 1].X));
	}
	for (ll i = 1; i < n; i++) {
		if (p[i - 1].X <= l[i - 1].X)
			p[i].X = max(0ll, l[i - 1].X - b[i]);
		else
			p[i].X = max(0ll, max(p[i - 1].X, l[i - 1].X));
		p[i].Y = min(p[i - 1].Y, l[i - 1].Y);
		bad[i] = max(bad[i], bad[i - 1]);
		bad[i] = max(bool(bad[i]), bool(p[i - 1].X>l[i - 1].Y || p[i - 1].Y < l[i - 1].X));
	}
	for (ll i = 0; i < n; i++) {
		if (!i) {
			if (s[i].X <= s[i].Y && !bad[i] && !bad2[i])
				cout << s[i].X<<'\n';
			else cout << -1 << '\n';
		}
		else if (i == n - 1) {
			if (p[i].X <= p[i].Y && !bad[i] && !bad2[i])
				cout << p[i].X << '\n';
			else cout << -1 << '\n';
		}
		else {
			pair<ll, ll> pr = s[i];
			pr.X = max(pr.X, p[i].X);
			pr.Y = min(pr.Y, p[i].Y);
			if (pr.X <= pr.Y && !bad[i] && !bad2[i])
				cout << pr.X << '\n';
			else cout << -1<<'\n';
		}
	}
	return 0;
}