#include <iostream>
#include <string>
#include <vector>
#include <set>

using namespace std;
const int MAXN = 1000000;
const int INF = 10000010;
int prev1[MAXN];
int prev2[MAXN];
int next1[MAXN];
int next2[MAXN];
int n;

inline int get_l(int i) {
    return (prev1[i] == - 1 ? 0 : prev1[i] - prev1[prev1[i]]);
}

inline int get_r(int i) {
    return (next1[i] == n ? 0 : next1[next1[i]] - next1[i]);
}

int main()
{
   // ios_base::sync_with_stdio(false);
  //  cin.tie(0);
  //  cout.tie(0);
    int q;
    cin >> q;
    for (int r = 0; r < q; r++) {
        string s, t;
        cin >> s >> t;
        n = (int) s.length();
        for (int i = 0; i < n; i++) {
            prev1[i] = -1;
            prev2[i] = -1;
            next1[i] = n;
            next2[i] = n;
        }
        for (int i = 1; i < n; i++) {
            prev1[i] = (s[i] == s[i - 1] ? prev1[i - 1] : i - 1);
            prev2[i] = (t[i] == t[i - 1] ? prev2[i - 1] : i - 1);
        }
        for (int i = n - 2; i >= 0; i--) {
            next1[i] = (s[i] == s[i + 1] ? next1[i + 1] : i + 1);
            next2[i] = (t[i] == t[i + 1] ? next2[i + 1] : i + 1);
        }
        while (true) {
            bool done = false;
            for (int j = 0; j < n; j++) {
                if (prev1[j] == j - 1 && next1[j] <= next2[j] && s[j] != t[j] && next1[j] - j < max(get_l(j), get_r(j))) {
                    done = true;
                    for (int i = j; i < next1[j]; i++) {
                        s[i] = t[i];
                    }
                    for (int i = 0; i < n; i++) {
                        prev1[i] = -1;
                        next1[i] = n;
                    }
                    for (int i = 1; i < n; i++) {
                        prev1[i] = (s[i] == s[i - 1] ? prev1[i - 1] : i - 1);
                    }
                    for (int i = n - 2; i >= 0; i--) {
                        next1[i] = (s[i] == s[i + 1] ? next1[i + 1] : i + 1);
                    }
                }
            }
            if (!done) break;
        }
        cout << (s == t ? "Yes\n" : "No\n");
    }
    return 0;
}
