#include <iostream>
#include <cstring>
#include <cmath>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

typedef long long ll;

const int N = 2e6;

ll dist[N], q[N], mark[N];

vector <pair < pair <int, int>, int >  >ar;

int main()
{
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int f, v, t, u;
        cin >> f >> v >> t >> u;
        v--, u--;
        ar.push_back(make_pair(make_pair(v, u), t));
    }
    mark[0] = 1;
    dist[0] = 0;
    q[0] = 0;
    for (int i = 0; i < n - 1; i++)
        for (int j = 0; j < ar.size(); j++)
        {
            ll v = ar[j].first.first;
            ll u = ar[j].first.second;
            ll t = ar[j].second;
            if (mark[v])
                if (!mark[u] || (dist[u] > dist[v] + t) || (dist[u] == dist[v] + t && q[u] < q[v] + t * t))
                    dist[u] = dist[v] + t, q[u] = q[v] + t * t, mark[u] = 1;
        }
    cout << dist[n - 1] << ' ' << q[n - 1] << endl;
    return 0;
}
