// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <map>
#include <bitset>
#include <set>

using namespace std;

bool kostyl = false;

bool solve(bitset<32> &ans, vector<bitset<32>> &bits, int p, int l, int r) {

	if (kostyl)
		return false;

	if (p == -1)
		return true;

	int cols = 0;
	int first = -1;
	for (int i = l + 1; i < r; i++) {
		if (bits[i][p] != bits[i - 1][p]) {
			cols++;
			first = i;
		}
	}

	if (cols > 1 && !kostyl) {
		cout << -1 << endl;
		kostyl = true;
		return false;
	}
	else {
		if (cols == 1) {
			if (bits[l][p])
				ans[p] = 1;
			return solve(ans, bits, p - 1, first, r) && solve(ans, bits, p - 1, l, first);
		}
		else {
			return solve(ans, bits, p - 1, l, r);
		}
	}
	return false;
}


signed main()
{

	int n;
	cin >> n;
	vector<int> mas(n);

	vector<bitset<32>> bits(n);

	for (int i = 0; i < n; i++) {
		cin >> mas[i];
		bits[i] = mas[i];
	}

	bitset<32> fans;
	kostyl = false;
	solve(fans, bits, 31, 0, n);
		if (!kostyl) {
			auto res = fans.to_ullong();
			cout << fans.to_ullong() << endl;
		}

	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int ind, val;
		cin >> ind >> val;

		ind--;

		bits[ind] = val;
		bitset<32> fans;
		kostyl = false;
		solve(fans, bits, 31, 0, n);
		if (!kostyl) {
			auto res = fans.to_ullong();
			cout << fans.to_ullong() << endl;
		}

	}

	return 0;
}

