// ConsoleApplication1.cpp : Defines the entry point for the console application.
//

#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <map>
#include <bitset>
#include <set>

using namespace std;

int max2pow(int n) {
	int k = 0;
	while (n) {
		k++;
		n >>= 1;
	}
	return k;
}

bool solve(bitset<32> &ans, vector<bitset<32>> &bits, int p, int l, int r) {
	if (p == -1)
		return true;

	int cols = 0;
	int first = -1;
	for (int i = l + 1; i < r; i++) {
		if (bits[i][p] != bits[i - 1][p]) {
			cols++;
			if (cols == 1) {
				first = i;
			}
		}
	}

	if (cols > 1) {
		cout << -1 << endl;
		return false;
	}
	else {
		if (cols == 1) {
			if (bits[l][p])
				ans[p] = 1;
			return solve(ans, bits, p - 1, first, r) && solve(ans, bits, p - 1, l, first);
		}
		else {
			return solve(ans, bits, p - 1, l, r);
		}
	}
	return false;
}


signed main()
{

	int n;
	cin >> n;
	vector<int> mas(n);

	vector<bitset<32>> bits(n);

	for (int i = 0; i < n; i++) {
		cin >> mas[i];
		bits[i] = mas[i];
	}

	bitset<32> fans;
	if (solve(fans, bits, 31, 0, n))
		cout << fans.to_ulong() << endl;

	int q;
	cin >> q;
	for (int i = 0; i < q; i++) {
		int ind, val;
		cin >> ind >> val;

		ind--;

		bits[ind] = val;
		bitset<32> fans;
		if (solve(fans, bits, 31, 0, n))
			cout << fans.to_ullong() << endl;

	}

	return 0;
}

