#include <bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::abs;
using std::min;
using std::max;
using std::pair;
using std::swap;
using std::vector;
using std::set;
using std::map;
using std::string;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define ff first
#define ss second
#define pb emplace_back
#ifdef LOCAL
#define dbg(as...) {\
	std::stringstream _ss(#as);\
	vector<string> _v;\
	string _cur, _loc;\
	while (getline(_ss, _cur, ',')) {\
		while (count(_cur.begin(), _cur.end(), '(') != count(_cur.begin(), _cur.end(), ')')) {\
			getline(_ss, _loc, ',');\
			_cur += "," + _loc;\
		}\
		_v.pb(_cur);\
	}\
	err(_v.begin(), as);\
}
#else 
#define dbg(as...) {}
#endif

template<typename T> 
void err(vector<string>::iterator it, T a) {
	cerr << *it << " = " << a << '\n';
}

template<typename T, typename...Ts>
void err(vector<string>::iterator it, T a, Ts...as) {
	cerr << *it << " = " << a << ',';
	err(++it, as...);
}

struct init{
	init() {
		std::iostream::sync_with_stdio(0);
		cin.tie(0);
		cout << std::fixed << std::setprecision(10);
		cerr << std::fixed << std::setprecision(3);
		srand(300);
	}
} init;

const int MAXN = 1e6 + 1, MAXB = 30;
int a[MAXN];
bool ch[MAXN];
int32_t main() {

	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) cin >> a[i];
	{
		int ans = 0;
		for (int bit = MAXB - 1; bit >= 0; --bit) {
			bool in = true;
			bool de = true;
			for (int i = 2; i <= n; ++i)
				if (!ch[i]) {
					if ((a[i] >> bit & 1) > (a[i - 1] >> bit & 1)) {
						de = false;
						ch[i] = true;
					}
					if ((a[i] >> bit & 1) < (a[i - 1] >> bit & 1)) {
						in = false;
						ch[i] = true;
					}
				}
			if (!in && !de) {
				ans = -1;
				break;
			} else if (de && !in) ans |= (1 << bit);
		}

		cout << ans << '\n';
	}
	int q;
	cin >> q;
	while (q--) {
		for (int i = 1; i <= n; ++i) ch[i] = 0;
		int p, v;
		cin >> p >> v;
		a[p] = v;	
		int ans = 0;
		for (int bit = MAXB - 1; bit >= 0; --bit) {
			bool in = true;
			bool de = true;
			for (int i = 2; i <= n; ++i)
				if (!ch[i]) {
					if ((a[i] >> bit & 1) > (a[i - 1] >> bit & 1)) {
						de = false;
						ch[i] = true;
					}
					if ((a[i] >> bit & 1) < (a[i - 1] >> bit & 1)) {
						in = false;
						ch[i] = true;
					}
				}
			if (!in && !de) {
				ans = -1;
				break;
			} else if (de && !in) ans |= (1 << bit);
		}

		cout << ans << '\n';
	}

	return 0;
}
