#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <string>
using namespace std;

string a, b;

vector < int > l, r;
bool nl = false, nr = false;

void parse(string &s, vector < int > &v, bool &n) {
	int pos = 0;
	if (s[0] == '-') {
		n = true;
		pos = 1;
	}
	for (int i = s.length() - 1; i >= pos; i--)
		v.push_back(s[i] - '0');
}

void norm(vector < int > &ans) {
	int f = 0;
	for (int i = 0; i < ans.size(); i++) {
		ans[i] += f;
		f = ans[i] / 10;
		ans[i] %= 10;
	}
	while (f > 0)
		ans.push_back(f % 10), f /= 10;
}

bool lower(vector < int > &l, vector < int > &r) {
	if (l.size() < r.size())
		return true;
	if (l.size() > r.size())
		return false;
	for (int i = l.size() - 1; i >= 0; i--) {
		if (l[i] < r[i])
			return true;
		if (l[i] > r[i])
			return false;
	}
	return true;
}

int main() {
	freopen("sum.in", "r", stdin);
	freopen("sum.out", "w", stdout);
	cin >> a >> b;
	parse(a, l, nl);
	parse(b, r, nr);
	if (!nl && !nr || nl && nr) {
		vector < int > ans;
		if (l > r)
			swap(l, r);
		for (int i = 0; i < r.size(); i++) {
			ans.push_back(r[i]);
			if (i < l.size())
				ans[i] += l[i];
		}
		norm(ans);
		if (nl)
			cout << '-';
		int pos = ans.size() - 1;
		while (pos >= 1 && ans[pos] == 0)
			pos--;
		for (int i = pos; i >= 0; i--)
			cout << ans[i];
	}
	else {
		if (nl) {
			swap(l, r);
			swap(nl, nr);
		}
		if (lower(r, l)) {
			if (l.size() > 1) {
				l[l.size() - 1] -= 1;
				for (int i = (int)l.size() - 2; i >= 1; i--) {
					l[i] += 9;
				}
				l[0] += 10;
			}
			for (int i = 0; i < l.size(); i++)
				l[i] -= i < r.size() ? r[i] : 0;
			norm(l);
			int pos = l.size() - 1;
			while (pos >= 1 && l[pos] == 0)
				pos--;
			for (int i = pos; i >= 0; i--)
				cout << l[i];
		}
		else {
			if (r.size() > 1) {
				r[r.size() - 1] -= 1;
				for (int i = (int)r.size() - 2; i >= 1; i--) {
					r[i] += 9;
				}
				r[0] += 10;
			}
			for (int i = 0; i < r.size(); i++)
				r[i] -= i < l.size() ? l[i] : 0;
			norm(r);
			int pos = r.size() - 1;
			while (pos >= 1 && r[pos] == 0)
				pos--;
			cout << '-';
			for (int i = pos; i >= 0; i--)
				cout << r[i];
		}
	}
}