#include <bits/stdc++.h>

using namespace std;
const long double EPS = 1e-11;

struct vct
{
    long double x;
    long double y;
};

long double square(pair<long double, long double> a, pair<long double, long double> b, pair<long double, long double> c)
{
    vct ab;
    ab.x = b.first - a.first;
    ab.y = b.second - a.second;
    vct ac;
    ac.x = a.first - c.first;
    ac.y = a.second - c.second;
    return fabs(0.5 * (ac.x * ab.y - ac.y * ab.x));

}


bool no_inside(int j1, int j2, int j3, vector<pair<long double, long double> > &a)
{

    for (int i = 0; i < a.size(); i++)
    {
        if (i == j1 || i == j2 || i == j3)
            continue;
        long double s1 = square(a[j1], a[j2], a[i]);
        long double s2 = square(a[j1], a[j3], a[i]);
        long double s3 = square(a[j3], a[j2], a[i]);
        long double s4 = square(a[j1], a[j2], a[j3]);
        if (fabs(s4 - s1 - s2 - s3) < EPS)
            return false;
    }
    return true;
}

int main()
{
    ///ios_base::sync_with_stdio(false);
    ///cin.tie(0);

    int n;
    cin >> n;
    vector<pair<long double, long double> > a(n);
    for (int i = 0; i < n; i++)
    {
        cin >> a[i].first >> a[i].second;
    }
    int q;
    cin >> q;
    fflush(stdout);
    for (int i = 0; i < q; i++)
    {
        bool done = 0;
        for (int j1 = 0; j1 < n && !done; j1++)
        {
            for (int j2 = j1 + 1; j2 < n && !done; j2++)
            {
                for (int j3 = j2 + 1; j3 < n && !done; j3++)
                {
                    if (!no_inside(j1, j2, j3, a))
                        continue;
                    fflush(stdout);
                    cout << "? 3 " << j1 + 1 << " " << j2 + 1 << " " << j3 + 1 << endl;
                    fflush(stdout);
                    string ans;
                    cin >> ans;
                    fflush(stdout);
                    if (ans == "Yes")
                    {
                        cout << "! 3 " << j1 + 1 << " " << j2 + 1 << " " << j3 + 1 << endl;
                        fflush(stdout);
                        done = 1;
                        if (i == q - 1)
                            return 0;
                    }
                }
            }
        }
    }
    return 0;
}
