#include <bits/stdc++.h>

#define mp make_pair

const int N = 10000;
typedef std::pair<int, int> pii;

int par[N], deep[N], ler[N], rr[N];
long long int sz[N];

int get_p(int a)
{
    if (par[a] == a)
        return a;
    int res = get_p(par[a]);
    par[a] = res;
    return res;
}

int un(int a, int b)
{
    int v1 = get_p(a), v2 = get_p(b);
    int new_ler = ler[v1], new_rr = rr[v2];
    if (deep[v1] < deep[v2])
        std::swap(v1, v2);
    par[v2] = v1;
    if (deep[v1] == deep[v2])
        ++deep[v1];
    sz[v1] += sz[v2];        
    ler[v1] = new_ler;
    rr[v1] = new_rr;
    return v1;
}

std::pair<pii, long long int> open_one(int k, int n, int* us, int* y)
{
    us[k] = 1;
    sz[k] = y[k];    
    deep[k] = 0;
    ler[k] = rr[k] = k;
    par[k] = k;
    int memk = k;
    if (k > 0 && us[k - 1])
        k = un(k - 1, k);
    if (memk + 1 < n && us[memk + 1])
        k = un(k, memk + 1);
    return std::mp(std::mp(ler[k], rr[k]), sz[k]);
}


void get_ans(int n, int m)
{
    int a[n], b[m], backb[n + m], backa[n + m], x[n], y[m];
    for (int i = 0; i < n + m; ++i)
        backa[i] = backb[i] = -1;    
    for (int i = 0; i < n; ++i)
    {
        scanf("%d", &a[i]);
        --a[i];
        backa[a[i]] = i;
    }
    long long int sum_a = 0;
    for (int i = 0; i < n; ++i)
    {
        scanf("%d", &x[i]);
        sum_a += x[i];
    }
    for (int i = 0; i < m; ++i)
    {
        scanf("%d", &b[i]);
        --b[i];
        backb[b[i]] = i;
    }
    for (int i = 0; i < m; ++i)
        scanf("%d", &y[i]);
    long long int cur_ans = 0;
    int r1, r2, le1, le2;        
    for (int le = 0; le < n; ++le)
    {
        long long int ma = 0;
        long long int cur_sum = sum_a;
        int loc_r2 = -1, loc_le2 = 0;
        int us[m];
        for (int j = 0; j < m; ++j)
            us[j] = 0;
        for (int j = 0; j < m; ++j)
            if (backa[b[j]] == -1)
            {
                auto res = open_one(j, m, us, y);
                if (res.second > ma)
                {       
                    loc_r2 = res.first.second;
                    loc_le2 = res.first.first;
                    ma = res.second; 
                }
                if (ma + cur_sum > cur_ans)
                {
                    cur_ans = ma + cur_sum;
                    r2 = loc_r2;
                    le2 = loc_le2;
                    le1 = 0;
                    r1 = n - 1;
                }
            }
        for (int j = 0; j < le; ++j)
        {
            cur_sum -= x[j];
            if (backb[a[j]] != -1)
            {
                auto res = open_one(backb[a[j]], m, us, y);
                if (res.second > ma)
                {       
                    loc_r2 = res.first.second;
                    loc_le2 = res.first.first;
                    ma = res.second; 
                }
                if (ma + cur_sum > cur_ans)
                {
                    cur_ans = ma + cur_sum;
                    r2 = loc_r2;
                    le2 = loc_le2;
                    le1 = j + 1;
                    r1 = n - 1;
                }
            }
        }
        for (int j = n - 1; j >= le; --j)
        {
            cur_sum -= x[j];
            if (backb[a[j]] != -1)
            {
                auto res = open_one(backb[a[j]], m, us, y);
                if (res.second > ma)
                {       
                    loc_r2 = res.first.second;
                    loc_le2 = res.first.first;
                    ma = res.second; 
                }
                if (ma + cur_sum > cur_ans)
                {
                    cur_ans = ma + cur_sum;
                    r2 = loc_r2;
                    le2 = loc_le2;
                    le1 = le;
                    r1 = j - 1;
                }
            }    
        }
    }
    std::cout << cur_ans << "\n";
    if (le1 > r1)
        printf("0 0\n");
    else    
        std::cout << (le1 + 1) << " " << (r1 + 1) << "\n";
    if (le2 > r2)
        printf("0 0\n");
    else    
        std::cout << (le2 + 1) << " " << (r2 + 1) << "\n";
}

int main()
{
    freopen("internship.in", "r", stdin);
 //   freopen("internshop.out", "w", stdout);
    int n, m;
    while (scanf("%d %d", &n, &m) == 2)
        get_ans(n, m);
    return 0;
}