#pragma GCC optimize "-O3" 
#include <bits/stdc++.h>


using namespace std;


template<typename T1, typename T2>inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2>inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
const int MAXN = 5001;
const long long INF = 10000000000LL;


struct point
{
	long long x, y;
	point(){}
	point(long long _x, long long _y) {
		x = _x;
		y = _y;
	}
};


long long operator ^(const point &a, const point &b) {
	return a.x * b.y - a.y * b.x;
}

long long operator *(const point &a, const point &b) {
	return (b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y);
}


point operator -(const point &a, const point &b) {
	return point(a.x - b.x, a.y - b.y);
}


point operator +(const point &a, const point &b) {
	return point(a.x + b.x, a.y + b.y);
}


int n;
point p[MAXN];
bool good[MAXN];
point t;




bool comp(const pair<point, int> &a, const pair<point, int> &b) {
	long long f = (a.first - t) ^ (b.first - t);
	if (f == 0LL) {
		return (t * a.first) < (t * b.first);
	} else {
		return f < 0;
	}
}


inline vector<int> getob(vector<pair<point, int> > g) {
	for (int i = 0; i < sz(g); i++) {
		g[i].second = i;
	}
	if (sz(g) != n) {
		t = point(INF, INF);
		for (auto b: g) {
			point a = b.first;
			if (a.y < t.y || (a.y == t.y && a.x < t.x)) {
				t = a;
			}
		}
		sort(all(g), comp);
	}
	g.push_back(g[0]);
	vector<int> st;
	for (int i = 0; i < sz(g); i++) {;
		if (sz(st) < 2) {
			if (i != sz(g) - 1) st.push_back(i);
		} else {
			while (sz(st) >= 2 && ((g[i].first - g[st[sz(st) - 2]].first) ^ (g[st.back()].first - g[st[sz(st) - 2]].first)) < 0) {
				st.pop_back();
			}
			if (i != sz(g) - 1) st.push_back(i);
		}
	}
	for (auto &x: st) {
		x = g[x].second;
	}
	return st;
}


vector<pair<point, int> > ng;


int main() {
	ios_base::sync_with_stdio(false);
	vector<pair<point, int> > g;
	cin >> n;
	g.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> p[i].x >> p[i].y;
		g[i] = make_pair(p[i], i + 1);
	}
	t = point(INF, INF);
	for (auto b: g) {
		point a = b.first;
		if (a.y < t.y || (a.y == t.y && a.x < t.x)) {
			t = a;
		}
	}
	sort(all(g), comp);
	vector<pair<point, int> > g1 = g;
	int q;
	cin >> q;
	for (int it = 0; it < q; it++) {
		memset(good, 0, sizeof(good));
		while (true) {
			vector<int> s = getob(g);
			if (sz(s) == sz(g)) {
				cout << "! " << sz(s);
				for (auto x: s) {
					cout << ' ' << g[x].second;
		 		}
		 		cout << endl;
				break;
			}
			if (sz(s) > 3) {
				int pos = rand() % sz(s);
				int npos = (pos + sz(s) / 2) % sz(s);
				if (pos > npos) {
					swap(pos, npos);
				}
				if (npos - pos + 1 <= 2) {
					if (npos < sz(s) - 1) {
						npos++;
					} else {
						pos--;
					}
				}
				cout << "? " << npos - pos + 1;
				for (int i = pos; i <= npos; i++) {
					cout << ' ' << g[s[i]].second;
				}
				cout << endl;
				string ans;
				cin >> ans;
				ng.clear();
				if (ans == "Yes") {
					for (int i = 0; i < sz(g); i++) {
						if (((g[i].first - g[s[pos]].first) ^ (g[s[npos]].first - g[s[pos]].first)) <= 0LL) {
							ng.push_back(g[i]);
						}
					}
					swap(g, ng);
				} else {
					for (int i = 0; i < sz(g); i++) {
						if (((g[i].first - g[s[pos]].first) ^ (g[s[npos]].first - g[s[pos]].first)) >= 0LL) {
							ng.push_back(g[i]);
						}
					}
					swap(g, ng);
				}
				continue;
			}
			for (int i = 0; i < sz(s); i++) {
				if (!good[g[s[i]].second]) {
					ng.clear();
					for (auto x: g) {
						if (x.second != g[s[i]].second) {
							ng.push_back(x);
						}
					}
					vector<int> s1 = getob(ng);
					cout << "?" << ' ' << sz(s1);
					for (auto i1: s1) {
						cout << ' ' << ng[i1].second;
					}
					cout << endl;
					string ans;
					cin >> ans;
					if (ans == "Yes") {
						swap(g, ng);
						break;
					}
					good[g[s[i]].second] = 1;
				}
			}
		}
		if (it != q - 1) {
			g = g1;
		}
	}
	return 0;
}

