#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i];
    cout << endl;
}

int main()
{
    int n;
    cin >> n;
    vector<int> stack;
    vector<char> answer(n, '(');
    string s;
    for (int i = 0; i < n; i++){
        if (stack.size() == 0){
            stack.push_back(i);
        }
        else{
            cout << "? " << stack.back() + 1 << " " << i + 1 << "\n";
            cout.flush();
            cin >> s;
            if (s == "Yes"){
                answer[i] = ')';
                stack.pop_back();
            }
            else{
                stack.push_back(i);
            }
        }
    }
    cout << "! ";
    print(answer);
    return 0;
}
