/*
File name: rg_n2log_rinf.cpp
Tag: REJECTED
Author: pkunyavskiy
Change time: Thu Mar 30 02:24:13 MSK 2017

*/
#include <iostream>
#include <cstdio>
#include <algorithm>
#include <cmath>
#include <cstdlib>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <queue>
#include <ctime>
#include <string>
#include <cstring>
#include <random>
#define mp make_pair
#define pb push_back
#define NAME ""
#define y1 y1_423
#define list lista

using namespace std;

typedef long long ll;
typedef long double ld;

const int nmax = 1000 * 1000;
const int inf = 1000 * 1000 * 1000;
const ll infl = 1000ll * 1000ll * 1000ll * 1000ll * 1000ll * 1000ll;
const int mod = 1000 * 1000 * 1000 + 7;
const ld pi = acos(-1.0);

struct seg {
	int can, l, r;
};

struct edge {
	int l, r;
};

edge a[nmax];
int t[nmax], n;

bool check(int v, int tt) {
	int t1 = tt;
	for (int i = v - 1; i >= 0; i--) {
		if (a[i].l > t1 + t[i + 1]) {
			return false;
		}
		t1 = max(t1, a[i].l);
	}
	t1 = tt;
	for (int i = v; i < n - 1; i++) {
		if (a[i].l > t1 + t[i]) {
			return false;
		}
		t1 = max(t1, a[i].l);
	}
	return true;
}

int main() {
    freopen("servers.in", "r", stdin);
    freopen("servers.out", "w", stdout);
	scanf("%d", &n);
	for (int i = 0; i < n; i++) {
		scanf("%d", t + i);
	}
	for (int i = 0; i < n - 1; i++) {
		scanf("%d%d", &a[i].l, &a[i].r);
	}
	for (int i = 0; i < n; i++) {
		int l = -1, r = inf;
		while (r - l > 1) {
			int m = l + (r - l) / 2;
			if (check(i, m)) {
				r = m;
			} else {
				l = m;
			}
		}
		printf("%d\n", r);
	}
}


