#include <bits/stdc++.h>

using namespace std;

#define endl "\n"

string s;
unordered_map<int, int> used;
int answer;

int is_used(int l, int r) {
    int key = (l << 17) + r;
    return used.count(key) ? used.at(key) : -1;
}

void ask(int l, int r) {
    answer = is_used(l, r);
    if (answer == -1) {
        cout << "? " << l + 1 << " " << r << endl;
        cout.flush();
        int key = (l << 17) + r;
        string response;
        cin >> response;
        answer = response == "Yes";
        used[key] = answer;
    }
}


void guess(int l, int r) {
    if (l == r) {
        return;
    }
    if (l + 2 == r) {
        s[l] = '(';
        s[r - 1] = ')';
        return;
    }

    ask(l + 1, r - 1);
    if (answer == 1) {
        s[l] = '(', s[r - 1] = ')';
        guess(l + 1, r - 1);
        return;
    }
    for (int b = l + 2; b < r; b += 2) {
        ask(l, b);
        if (answer == 1) {
            guess(l, b);
            guess(b, r);
            return;
        }
    }
}

void solve() {
    int n;
    cin >> n;
    s.resize(n, ' ');
    guess(0, n);
    cout << "! " << s << endl;
    cout.flush();
}


int main() {
#ifdef MINE
//    freopen("../input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}