#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()

typedef long long ll;
typedef double dbl;

const int INF = 2e9;
const dbl EPS = 1e-9;
const dbl PI = acos(-1);
const int LOG = 4;

vector<int> cnt[2], a;
unordered_map<ll, int> mem, ans, ms;
int last = -1, was = -1;

inline bool check(vector<int> a, int b) {
	for (int i = 0; i < (int)a.size(); i++) {
		a[i] ^= b;

		if (i && a[i - 1] > a[i]) return 0;
	}

	return 1;
}

inline ll pack(int d, int l, int r) {
	return ((ll)d << 32) + ((ll)l << 21) + r;
}

void recalc(int d, int l, int r) {
	if (d < 0 || r - l < 2) return;

	ll key = pack(d, l, r);
	bool hasKey = mem.count(key);
	// bool there = (l <= last && last < r);

	if (hasKey) {
		int val = mem[key];
		mem.erase(key);
		ans.erase(key);

		if (val == 0 || val == 1) {
			cnt[val][d]--;
		}

		if (ms.count(key)) {
			int m = ms[key];
			ms.erase(key);

			recalc(d - 1, l, m);
			recalc(d - 1, m, r);
		} else {
			recalc(d - 1, l, r);
		}
	}
}

int mote(int d, int l, int r) {
	if (d < 0 || r - l < 2) return 0;

	ll key = pack(d, l, r);
	bool hasKey = mem.count(key);
	bool there = (l <= last && last < r);

	if (hasKey && !there) return ans[key];

	vector<int> tmp(r - l);

	for (int i = l; i < r; i++) {
		tmp[i - l] = (a[i] >> d) & 1;
	}

	tmp.resize(unique(all(tmp)) - tmp.begin());

	if ((int)tmp.size() > 2) return (mem[key] = ans[key] = -1);
	if ((int)tmp.size() == 1) {
		int res = mote(d - 1, l, r);
		mem[key] = 2;
		return (ans[key] = res);
	}

	int m = l;

	while (m < r && ((a[m] >> d) & 1) == tmp[0]) m++;

	ms[key] = m;

	int m1 = mote(d - 1, l, m), m2 = mote(d - 1, m, r);

	if (m1 == -1 || m2 == -1) return (mem[key] = ans[key] = -1);

	if (tmp[0] == 0) {
		cnt[0][d]++;
		mem[key] = 0;
		return (ans[key] = m1 | m2);
	} else {
		cnt[1][d]++;
		mem[key] = 1;
		return (ans[key] = m1 | m2 | (1 << d));
	}
}

inline int getAns() {
	// if (check(a, 0)) return 0;

	// fill(all(cnt[0]), 0);
	// fill(all(cnt[1]), 0);
	if (last != -1) {
		int nw = a[last];
		a[last] = was;
		recalc(LOG - 1, 0, (int)a.size());
		a[last] = nw;
	}

	int ans = mote(LOG - 1, 0, (int)a.size());

	for (int i = 0; i < LOG; i++) {
		if (cnt[0][i] && cnt[1][i]) return -1;
	}

	// if (check(a, ans)) return ans;
	return ans;
}

int main() {
	ios::sync_with_stdio(0);
	cin.tie(nullptr);
	cout.tie(nullptr);

// #ifdef GA_ROI
// 	freopen("/home/roi/prjs/file.in", "r", stdin);
// 	freopen("/home/roi/prjs/file.out", "w", stdout);
// #else
	freopen("order.in", "r", stdin);
	freopen("order.out", "w", stdout);
// #endif

	int n;
	cin >> n;

	a.resize(n);
	cnt[0].resize(LOG);
	cnt[1].resize(LOG);

	for (int i = 0; i < n; i++) {
		cin >> a[i];
	}

	cout << getAns() << "\n";

	int q;
	cin >> q;

	while (q--) {
		int p, v;
		cin >> p >> v;
		p--;

		was = a[p];
		a[p] = v;
		last = p;

		cout << getAns() << "\n";
	}

	return 0;
}
