#include <iostream>

using namespace std;

#define f first
#define s second

const int INF = 1e9;

int n;
int arr[1000000];
pair<int, int> tunnel[1000000];
pair<int, int> res_left[1000000];
pair<int, int> res_right[1000000];

int my_left, my_right;

void act1()
{
    res_left[0] = {0, INF};
    for(int i = 1; i < n; i++){
        my_left = max(res_left[i-1].f, tunnel[i-1].f);
        my_right = min(res_left[i-1].s, tunnel[i-1].s);
        if(my_left > my_right)
            res_left[i] = {-1, -1};
        else if(res_left[i-1].f == -1 and res_left[i-1].s == -1)
            res_left[i] = {-1, -1};
        else{
            if(my_left == tunnel[i-1].f)
                res_left[i] = {max(0, my_left - arr[i]), my_right};
            else
                res_left[i] = {my_left, my_right};
        }
    }
}

void act2()
{
    res_right[n-1] = {0, INF};
    for(int i = n-2; i >= 0; i--){
        my_left = max(res_right[i+1].f, tunnel[i].f);
        my_right = min(res_right[i+1].s, tunnel[i].s);
        if(my_left > my_right){
            res_right[i] = {-1, -1};
        }
        else if(res_right[i+1].f == -1 and res_right[i+1].s == -1)
            res_right[i] = {-1, -1};
        else{
            if(my_left == tunnel[i].f)
                res_right[i] = {max(0, my_left - arr[i]), my_right};
            else
                res_right[i] = {my_left, my_right};
        }
    }
}

int main()
{

    cin >> n;
    for(int i = 0; i < n; i++){
        cin >> arr[i];
    }
    for(int i = 0; i < n-1; i++)
        cin >> tunnel[i].f >> tunnel[i].s;
    act1();
    act2();
    for(int i = 0; i < n; i++){
        my_left = max(res_left[i].f, res_right[i].f);
        my_right = min(res_left[i].s, res_right[i].s);
        if(my_left > my_right)
            cout << -1 << endl;
        else if((res_left[i].f == -1 and res_left[i].s == -1) or (res_right[i].f == -1 and res_right[i].s == -1))
            cout << -1 << endl;
        else
            cout << my_left << endl;
    }
    return 0;
}
