# include <iostream>
# include <string>
# include <vector>

using namespace std;

vector<pair<int, int> > get(const string &s)
{
    vector<pair<int, int> > ans;
    if (s[0] == '+') ans.push_back({1, 1});
    else ans.push_back({1, 0});
    for (int i = 1; i < (int)s.size(); i++)
    {
        if (s[i] == s[i - 1]) ++(*ans.rbegin()).first;
        else
        {
            if (s[i] == '+') ans.push_back({1, 1});
        else ans.push_back({1, 0});
        }
    }
    return ans;
}

void solve()
{
    string s, t;
    cin >> s >> t;
    vector<pair<int, int> > s1 = get(s), t1 = get(t);
    int n = s1.size(), m = t1.size();
    int i = 0;
    for (int j = 0; j < m; j++)
    {
        int curr = 0;
        while (i < n && curr < t1[j].first)
        {
            if (s1[i].second == t1[j].second) curr += s1[i++].first;
            else
            {
                if (curr > s1[i].first || (i < n - 1 && s1[i + 1].second != s1[i].second && s1[i + 1].first > s1[i].first))
                {
                    curr += s1[i].first;
                    i++;
                    if (i != n)
                    {
                        curr += s1[i++].first;
                    }
                }
                else
                {
                    cout << "No\n";
                    return;
                }
            }
        }
        if (curr != t1[j].first)
        {
            cout << "No\n";
            return;
        }
    }
    cout << "Yes\n";
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int q;
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        solve();
    }
}
