#define _CRT_SECURE_NO_DEPRECATE

#include<string>
#include<cstring>
#include<vector>
#include<algorithm>
#include<cmath>
#include<iostream>
#include<cstdlib>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

void solve();

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}


string s, t;

bool uni(vector<int>& v, bool f) {
	for (int i = !f; i < v.size(); i += 2) {
		int a = i - 1;
		int b = i + 1;
		int c = v[i];
		while (a >= 0 || b < v.size()) {
			bool rt = true;
			while (a >= 0 && v[a] < c) {
				rt = false;
				c += v[a];
				--a;
				if (a >= 0)
					c += v[a];
				--a;
			}

			while (b < v.size() && v[b] < c) {
				rt = false;
				c += v[b];
				++b;
				if (b < v.size())
					c += v[b];
				++b;
			}
			if (rt)break;
		}
		if (a < 0 && b >= v.size())return true;
	}
}

void sol() {
	cin >> s >> t;
	bool ok = true;
	int b = 0;
	vector<int> h;
	while (b < t.size()) {
		h.clear();
		int e = b;
		while (e < t.size() && t[e] == t[b])++e;
		if (e < t.size())
			ok &= t[e] != s[e - 1];
		if (b > 0)
			ok &= t[b] != s[b - 1];
		int u = b;
		while (u < e) {
			int v = u;
			while (v < s.size() && s[v] == s[u])++v;
			h.push_back(v - u);
			u = v;
		}
		ok &= uni(h, s[b] == t[b]);

		b = e;
	}
	if (ok)cout << "Yes" << endl;
	else cout << "No" << endl;
}

void solve() {
	int t;
	cin >> t;
	while (t--)
		sol();
}

