#define _CRT_SECURE_NO_DEPRECATE

#include<string>
#include<cstring>
#include<vector>
#include<algorithm>
#include<cmath>
#include<iostream>
#include<cstdlib>
#include<set>
#include<map>

using namespace std;

typedef long long ll;

void solve();
#define mp(x, y) make_pair(x, y)
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	solve();
}



int a, n;

//int dp[1001][1001][2];
const int inf = (1ll << 31ll) - 1ll;
/*void solveC40() {
	for (int i = 0; i < 1001; ++i)
		for (int j = 0; j < 1001; ++j)
			dp[i][j][0] = dp[i][j][1] = inf;
	dp[0][0][0] = 0;
	while (n--) {
		int x, y, z;
		cin >> x >> y >> z;
		for (int i = 0; i <= a; ++i)
			for (int j = 0; j <= a; ++j)
				if (dp[i][j][0] != inf) {
					if (i + x <= a && j + y <= a && dp[i][j][0] + z < dp[i + x][j + y][0])
						dp[i + x][j + y][0] = dp[i][j][0] + z;
					else if (y + x <= a && dp[i][j][0] + z < dp[i + x][j + x][1])
						dp[i + x][j + x][1] = dp[i][j][0] + z;
				}
	}
	ll ans = 0;
	for (int i = 0; i <= a; ++i)
		for (int j = 0; j <= a; ++j) {
			if (dp[i][j][0] != inf)
				ans = max(ans, 1ll * i * (1000000000ll) - dp[i][j][0]);
			if (dp[i][j][1] != inf)
				ans = max(ans, 1ll * i * (1000000000ll) - dp[i][j][1]);
		}
	cout << ans << endl;
}*/
void solve1() {
	ll x, y, z;
	cin >> x >> y >> z;
	ll L = 0;
	ll R = 0;
	ll k = 0;
	ll c = 0;
	ll ans = 0;
	while (true) {
		++k;
		L += x;
		R += y;
		c += z;
		if (R > a) {
			ans = max((L - abs(R - a)) * 1000000000ll - c, ans);
			if (R - 1 == a)
				ans = max((R - y) * 1000000000ll - c, ans);
			else {
				ans = max((R - y - abs(R-a) + 1) * 1000000000ll - (c + z), ans);

			}
			break;
		}
		else
			ans = max(L * 1000000000ll - c, ans);
	}
	cout << ans << endl;
	exit(0);
}

int dp[1001];
void solve2() {
	fill(dp, dp + 1001, inf);
	dp[0] = 0;
	while (n--) {
		int x, y, z;
		cin >> x >> y >> z;
		for (int i = 0; i <= a; ++i)
			if(dp[i] != inf && i + x <= a)dp[i + x] = min(dp[i] + z, dp[i + y]);
	}
	ll ans = 0;
	for (int i = 0; i <= a; ++i) {
		if(dp[i] != inf)ans = max(1000000000ll * i - dp[i], ans);
	}
	cout << ans << endl;
}

void solve() {
	cin >> n >> a;
	//solveC40();
	if(n == 1)solve1();
	if (n > 1)solve2();
}


