#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>
#define SZ(v) (int)v.size()
#define X first
#define Y second
#define p(x,y) pair<x,y>
using namespace std;
typedef long long ll;
void solve();
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	solve();
}
const int N = 200005;
const long long INF = (1LL << 61);
const long long inf = 1e9;
int n, l[N], r[N], t[N];
p(ll, ll) otr1[N];
p(ll, ll) otr2[N];

void solve() {
	cin >> n;
	for (int i = 1; i <= n; i++)
		cin >> t[i];
	for (int i = 1; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	otr1[n] = { 0,INF };
	otr2[1] = { 0,INF };
	for (int i = n - 1; i >= 1; i--) {
		if (otr1[i + 1].X <= l[i] && l[i] <= otr1[i + 1].Y) {
			otr1[i].X = max(0, l[i] - t[i]);
			otr1[i].Y = min(r[i] * 1LL, otr1[i + 1].Y);
		}
		else {
			otr1[i] = { l[i],r[i] };
			otr1[i].X = max(otr1[i].X, otr1[i + 1].X);
			otr1[i].Y = min(otr1[i].Y, otr1[i + 1].Y);
		}
	}
	for (int i = 2; i <= n; i++) {
		if (otr2[i - 1].X <= l[i - 1] && l[i - 1] <= otr2[i - 1].Y) {
			otr2[i].X = max(0,l[i - 1] - t[i]);
			otr2[i].Y = min(1LL * r[i - 1], otr2[i - 1].Y);
		}
		else {
			otr2[i] = { l[i - 1],r[i - 1] };
			otr2[i].X = max(otr2[i].X, otr2[i - 1].X);
			otr2[i].Y = min(otr2[i].Y, otr2[i - 1].Y);
		}
	}
	for (int i = 1; i <= n; i++) {
		int ans = -1;
		ll left = max(otr1[i].X, otr2[i].X);
		ll right = min(otr1[i].Y, otr2[i].Y);
		if (left <= right)cout << left << endl;
		else cout << -1 << endl;
	}	
}