#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <string>
#include <cstring>
#include <queue>

using namespace std;
typedef long long ll;

int solve();

int main() {
#ifdef ROII
	freopen("input.txt", "r", stdin), freopen("output.txt", "w", stdout);
#endif
	solve();
}

const int dd = (int)2e6 + 1;
int l[dd], r[dd], c[dd];
ll dp[dd];
ll ans;

void upd(ll &a, ll b) { if (a < b) a = b; }

int solve() {
	int n, a;
	scanf("%d %d", &n, &a);

	int cmin = (int)1e9;

	for (int i = 0; i < n; i++) {
		scanf("%d %d %d", &l[i], &r[i], &c[i]);
		cmin = min(cmin, r[i]);
	}

	fill(dp, dp + dd, -1);

	dp[0] = 0;

	for (int w = 1; w <= a; w++) {
		for (int i = 0; i < n; i++) {
			int L = w - r[i];
			int R = w - l[i];

			if (R < 0) continue;
			if (L < 0) L = 0;

			ll cur = (ll)1e18;
			int ok = 0;

			for (int j = L; j <= R; j++) {
				if (dp[j] != -1) {
					ok = 1;
					cur = min(cur, dp[j] + (w - j) * (ll)1e9 - c[i]);
				}
			}
			if (ok)
				dp[w] = max(dp[w], cur);
		}
	}

	ll ans = (ll)1e18;
	for (int w = 1; w <= a; w++) {
		if (w + cmin > a) ans = min(ans, dp[w]);
	}

	printf("%lld\n", ans);
	return 0;
}