#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <string>
#include <vector>
#include <set>

using namespace std;

#define TASK "order"
#define inb push_back

const int M = 1e3 + 5;
int n, q;
int a[M], b[M];

int check()
{
	for (int j = 0; j < n; ++j) b[j] = 0;
	set<int> s;
	int ans = 0;
	for (int i = 29; i >= 0; --i)
	{
		int f = 0;
		for (int j = 0; j < n; ++j)
			s.erase(b[j]);
		for (int j = 0; j < n; ++j)
		{
			if (a[j] & (1 << i))
				b[j] += (1 << i);
			auto it = s.upper_bound(b[j]);
			if (it != s.end())
				f = 1;
			s.insert(b[j]);
		}
		if (!f)
			continue;
		for (int j = 0; j < n; ++j)
		{
			s.erase(b[j]); 
			if (a[j] & (1 << i))
				b[j] -= (1 << i);
		}
		for (int j = 0; j < n; ++j)
		{
			if (!(a[j] & (1 << i)))
				b[j] += (1 << i);
			auto it = s.upper_bound(b[j]);
			if (it != s.end())
				f = 2;
			s.insert(b[j]);
		}
		if (f == 2)
			return -1;
		ans += (1 << i);
	}
	return ans;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	freopen(TASK".in", "r", stdin);
	freopen(TASK".out", "w", stdout);
#endif
	scanf("%d", &n);
	for (int i = 0; i < n; ++i)
		scanf("%d", &a[i]);
	cout << check() << '\n';
	scanf("%d", &q);
	int p, u;
	for (; q > 0; --q)
	{
		scanf("%d%d", &p, &u);
		a[p - 1] = u;
		cout << check() << '\n';
	}
}