#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stdio.h>
#include <math.h>
#include <cmath>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>


using namespace std;

#define ll long long

struct point {
    int x, y;
};

int x[100], y[100];


point operator-(point&a, point&b) {
    point ans = a;
    ans.x -= b.x;
    ans.y -= b.y;
    return ans;
}


int vect(point a, point b) {
    return a.x * b.y - a.y * b.x;
}

int sign(int a) {
    if (a >= 0) {
        return 1;
    }
    return 2;
}


bool into(int a1, int b1, int c1, int p1) {
    point a, b, c, p;
    a.x = x[a1];
    a.y = y[a1];
    b.x = x[b1];
    b.y = y[b1];
    c.x = x[c1];
    c.y = y[c1];
    p.x = x[p1];
    p.y = y[p1];
    int v1 = vect(b - a, p - a);
    int v2 = vect(a - c, b - c);
    int v3 = vect(c - b, p - b);
    if (sign(v1) == sign(v2) && sign(v2) == sign(v3)) {
        return true;
    }
    return false;
}


int main() {
    int n;
    cin >> n;
    for (int i = 1; i <= n; ++i) {
        cin >> x[i] >> y[i];
    }
    int q;
    cin >> q;
    for (int kissmetiger = 0; kissmetiger < q; ++kissmetiger) {
        bool good = false;
        for (int f = 1; f <= n; ++f) {
            for (int s = f + 1; s <= n; ++s) {
                for (int t = s + 1; t <= n; ++t) {
                    bool joke = true;
                    for (int p = 1; p <= n; ++p) {
                        if (p != f && p != s && p != t) {
                            if (into(f, s, t, p)) {
                                joke = false;
                                break;
                            }
                        }
                    }
                    if (joke) {
                        cout << "? " << f << " " << s << " " << t << endl;
                        string st;
                        cin >> st;
                        if (st == "Yes") {
                            cout << "! " << f << " " << s << " " << t << endl;
                            good = true;
                            break;
                        }
                    }
                }
                if (good) {
                    break;
                }
            }
            if (good) {
                break;
            }
        }
    }
    return 0;
}
