#include <bits/stdc++.h>
#define int long long

using namespace std;

int inf = 9e18;

struct state {
    int v, dist, sq_dist;

    bool operator <(const state& arg) const {
        if (dist != arg.dist) return dist < arg.dist;
        return sq_dist > arg.sq_dist;
    }
};

main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<int> dist(n, inf);
    vector<int> sq_dist(n, 0);
    vector<vector<pair<int, int>>> g(n, vector<pair<int, int>>());
    int prev = 0;
    int next = 0;
    int len = 0;
    for (int i = 0; i < m; i++) {
        int s;
        cin >> s;
        cin >> prev;
        vector<pair<int, int>> route;
        prev--;
        route.push_back({prev, -1});
        for (int j = 0; j < s; j++) {
            cin >> len >> next;
            next--;
            route.push_back({next, len});
            prev = next;
        }
        for (int j = 0; j < route.size(); j++) {
            int sum = 0;
            for (int k = j + 1; k < route.size(); k++) {
                sum += route[k].second;
                g[route[j].first].push_back({route[k].first, sum});
            }
        }
    }
    set<state> st;
    st.insert(state{0, 0, 0});
    dist[0] = 0;
    while (st.size() > 0) {
        state pa = *st.begin();
        int v = pa.v;
        st.erase(st.begin());
        for (pair<int, int> pa1 : g[v]) {
            int to = pa1.first;
            int len = pa1.second;
            if (dist[to] > dist[v] + len) {
                st.erase(state{to, dist[to], sq_dist[to]});
                dist[to] = dist[v] + len;
                sq_dist[to] = sq_dist[v] + len * len;
                st.insert(state{to, dist[to], sq_dist[to]});
            } else if (dist[to] == dist[v] + len && sq_dist[to] < sq_dist[v] + len* len) {
                st.erase(state{to, dist[to], sq_dist[to]});
                sq_dist[to] = sq_dist[v] + len * len;
                st.insert(state{to, dist[to], sq_dist[to]});
            }
        }
    }
    cout << dist[n - 1] << ' ' << sq_dist[n - 1];
}
