#include <iostream>
#include <vector>
#include <cmath>

#define ll long long

using namespace std;
ll n;
vector<pair<ll, ll>> polls;

double s(pair<ll, ll> a, pair<ll, ll> b, pair<ll, ll> c) {
    double pl = 0;
    pl += (a.second + b.second) / 2 * (b.first - a.first);
    pl += (b.second + c.second) / 2 * (c.first - b.first);
    pl += (c.second + a.second) / 2 * (a.first - c.first);
    return abs(pl);
}

int main() {
    cin >> n;
    string ans;
    for (ll i = 0; i < n; i++) {
        ll a, b;
        cin >> a >> b;
        polls.push_back(make_pair(a, b));
    }
    ll q;
    cin >> q;
    for (ll t = 0; t < q; t++) {
        bool find = false;
        ll i, j, k;
        for (i = 1; i <= n - 2 && !find; i++) {
            for (j = i + 1; j <= n - 1 && !find; j++) {
                for (k = j + 1; k <= n && !find; k++) {
                    cout << "? " << "3 " << i << " " << j << " " << k << endl;
                    cin >> ans;
                    if (ans[0] == 'Y') {
                        find = true;
                    }
                    if (find) {
                        double s1 = s(polls[i - 1], polls[j - 1], polls[k - 1]);
                        for (ll z = 0; z < n; z++) {
                            if (z != i - 1 && z != j - 1 && z != k - 1) {
                                double pl = (s(polls[z], polls[j - 1], polls[k - 1]) +
                                             s(polls[i - 1], polls[z], polls[k - 1]) +
                                             s(polls[i - 1], polls[j - 1], polls[z]));

                                if (pl == s1) {
                                    find = false;
                                    break;
                                }
                            }
                        }
                    }

                }
            }
        }
        cout << "! " << "3 " << i - 1 << " " << j - 1 << " " << k - 1 << endl;
    }
    return 0;
}