#include <bits/stdc++.h>
using namespace std;

#define int long long

const int maxn = 5000;

typedef bitset<maxn> bs;

struct r{
    int x, y;
    r(){};
    r(int _x, int _y){ x = _x, y = _y; }
};

r operator-(r a, r b){
    return r(a.x-b.x, a.y-b.y);
}

int operator^(r a, r b){ return abs(a.x*b.y - a.y*b.x); }

int n;
r p[maxn];
vector<int> s[maxn];

bool in(r t, r a, r b, r c){ // overflow?
    return ((a-t)^(b-t)) + ((a-t)^(c-t)) + ((b-t)^(c-t)) == ((b-a)^(c-a));
}

void solve(bs t){
    cerr << t << endl;
    vector<int> a;
    for(int i = 0; i < n; i++)
        if(t[i])
            a.push_back(i);
    /*
    cout << "solve " << k;
    for(int w : a) cout << " " << w;
    cout << endl;
    */
    int m = (int) a.size();
    if(m == 3){
        cout << "! 3";
        for(int w : a) cout << " " << w+1;
        cout << endl;
    }
    else{
        int x = rand()%m, y = x, z = x;
        while(y == x) y = rand()%m;
        while(z == x || z == y) z = rand()%m;
        cout << "? 3 " << x+1 << " " << y+1 << " " << z+1 << endl;
        string ans;
        cin >> ans;
        if(ans[0] == 'N')
            for(int i = 0; i < n; i++)
                t[i] = 0; //bydlokod
        t[x] = t[y] = t[z] = 1;
        for(int i = 0; i < m; i++){
            if(in(p[i], p[x], p[y], p[z])){
                if(ans[0] == 'Y') t[i] = 1;
                else t[i] = 0;
            }
        }
        solve(t);
    }
}

bool ask(vector<int> a){
    cout << "? " << a.size() << " ";
    for(int x : a) cout << x+1 << " ";
    cout << endl;
    string ans;
    cin >> ans;
    return (ans[0] == 'Y');
}

main(){
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;

    /*
    if(n == 6){
        cout << "? 3 1 2 3" << endl;
        cout << "! 3 1 2 3" << endl;

        cout << "? 3 1 2 3" << endl;
        cout << "? 4 1 2 3 4" << endl;
        cout << "! 3 4 3 1" << endl;

        cout << "? 5 2 3 5 4 1" << endl;
        cout << "? 3 4 5 6" << endl;
        cout << "! 3 1 4 6" << endl;

        cout << "? 4 1 3 5 6" << endl;
        cout << "? 4 4 3 5 6" << endl;
        cout << "! 4 4 3 5 6" << endl;
        return 0;
    }
    */

    for(int i = 0; i < n; i++)
        cin >> p[i].x >> p[i].y;

    /*
    for(int i = 0; i < n; i++){
        vector<long double> angle(n);
        for(int j = 0; j < n; j++){
            if(j != i){
                s[i].push_back(j);
                r v = p[j]-p[i];
                angle[j] = atan2(v.y, v.x);
            }
        }
        sort(s[i].begin(), s[i].end(), [&](int a, int b){
            return angle[a] < angle[b];
        });
        for(int j = 0; j < n-1; j++)
            cout << s[i][j] << " ";
        cout << endl;
    }
    */

    int q;
    cin >> q;

    while(q--){
        bs t;
        t.set();
        solve(t);
    }

    return 0;
}
