#include <cmath>
#include <cstdlib>
#include <vector>
#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <string>
#include <cstring>

#pragma warning( disable : 4996)
#define all(x) x.begin(),x.end()
#define forn(i_, s_, f_) for(int i_ = s_; i_  < f_; i_++)
#define ff first
#define ss second

#define MINUS 0
#define PLUS 1

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

struct Segm
{
	int l;
	int r;
	char tp;

	Segm(int l, int r, char tp) :l(l), r(r), tp(tp) {}
};

bool operator< (const Segm &s1, const Segm &s2) {
	return s1.l < s2.l;
}


string s;
string t;


inline bool check_minus(int l, int r) {
	int st = l;
	set<Segm> m;
	set<Segm> p;
	//p.clear();
	//m.clear();
	forn(i, l + 1, r) {
		if (s[i] != s[i - 1]) {
			//se.insert(Segm(st, i, s[i - 1]));
			if (s[i - 1] == '-') {
				p.insert(Segm(st, i, s[i - 1]));
			}
			else {
				m.insert(Segm(st, i, s[i - 1]));
			}
			st = i;
		}
	}
	//  se.insert(Segm(st, r, s[r - 1]));
	if (s[r - 1] == '-') {
		p.insert(Segm(st, r, s[r - 1]));
	}
	else {
		m.insert(Segm(st, r, s[r - 1]));
	}

	/*for (Segm s : m) {
	cout << s.l << s.r << "; ";
	}
	cout << "\n";
	for (Segm s : p) {
	cout << s.l << s.r << "; ";
	}
	cout << "\n";*/


	int cnt = 0;
	int mx_c = p.size() + m.size() + 1;

	if (p.empty()) {
		return false;
	}

	Segm cur = *p.begin();
	bool b = false;
	while (cnt < mx_c && !m.empty()) {
		//cout << cur.l << " " << cur.r << "\n";
		b = false;
		// r
		auto mitr = m.upper_bound(cur);
		auto pitr = p.upper_bound(cur);

		if (mitr != m.end()) {

			if (pitr != p.end()) {
				Segm m1 = *mitr;
				Segm p1 = *pitr;
				if ((m1.r - m1.l) < (cur.r - cur.l)) {
					b = true;
					m.erase(mitr);
					p.erase(pitr);
					p.erase(cur);
					cur = Segm(cur.l, p1.r, '-');
					p.insert(cur);
				}
			}
			else {
				Segm m1 = *mitr;
				//Segm p1 = *pitr;

				if ((m1.r - m1.l) < (cur.r - cur.l)) {
					b = true;
					m.erase(mitr);
					//p.erase(pitr);
					p.erase(cur);
					cur = Segm(cur.l, m1.r, '-');
					p.insert(cur);
				}
			}
		}

		if (b) {
			cnt++;
			continue;
		}

		mitr = m.lower_bound(cur);
		pitr = p.lower_bound(cur);
		// l
		if (mitr != m.begin()) {
			mitr--;
		}
		if (pitr != p.begin()) {
			pitr--;
		}

		if (mitr != m.end() && (*mitr < cur)) {
			//b = true;
			if (pitr != p.end() && (*pitr < cur)) {
				Segm m1 = *mitr;
				Segm p1 = *pitr;

				if ((m1.r - m1.l) < (cur.r - cur.l)) {
					b = true;
					m.erase(mitr);
					p.erase(pitr);
					p.erase(cur);
					cur = Segm(p1.l, cur.r, '-');
					p.insert(cur);
				}
			}
			else {
				Segm m1 = *mitr;
				//Segm p1 = *pitr;

				if ((m1.r - m1.l) < (cur.r - cur.l)) {
					b = true;
					m.erase(mitr);
					//p.erase(pitr);
					p.erase(cur);
					cur = Segm(m1.l, cur.r, '-');
					p.insert(cur);
				}
			}
		}
		//cout << b << endl;
		if (!b) {

			auto tmp = p.upper_bound(cur);
			if (tmp == p.end()) {
				tmp = p.begin();
			}
			cur = *tmp;
		}


		cnt++;
	}

	if (m.empty()) {
		return true;
	}
	return false;
}


inline bool check_plus(int l, int r) {
	int st = l;
	set<Segm> m;
	set<Segm> p;
	//p.clear();
	//m.clear();
	forn(i, l + 1, r) {
		if (s[i] != s[i - 1]) {
			//se.insert(Segm(st, i, s[i - 1]));
			if (s[i - 1] == '+') {
				p.insert(Segm(st, i, s[i - 1]));
			}
			else {
				m.insert(Segm(st, i, s[i - 1]));
			}
			st = i;
		}
	}
	//  se.insert(Segm(st, r, s[r - 1]));
	if (s[r - 1] == '+') {
		p.insert(Segm(st, r, s[r - 1]));
	}
	else {
		m.insert(Segm(st, r, s[r - 1]));
	}

	/*for (Segm s : m) {
	cout << s.l << s.r << "; ";
	}
	cout << "\n";
	for (Segm s : p) {
	cout << s.l << s.r << "; ";
	}
	cout << "\n";*/


	int cnt = 0;
	int mx_c = p.size() + m.size() + 1;

	if (p.empty()) {
		return false;
	}

	Segm cur = *p.begin();
	bool b = false;
	while (cnt < mx_c && !m.empty()) {
		//cout << cur.l << " " << cur.r << "\n";
		b = false;
		// r
		auto mitr = m.upper_bound(cur);
		auto pitr = p.upper_bound(cur);

		if (mitr != m.end()) {

			if (pitr != p.end()) {
				Segm m1 = *mitr;
				Segm p1 = *pitr;
				if ((m1.r - m1.l) < (cur.r - cur.l)) {
					b = true;
					m.erase(mitr);
					p.erase(pitr);
					p.erase(cur);
					cur = Segm(cur.l, p1.r, '+');
					p.insert(cur);
				}
			}
			else {
				Segm m1 = *mitr;
				//Segm p1 = *pitr;

				if ((m1.r - m1.l) < (cur.r - cur.l)) {
					b = true;
					m.erase(mitr);
					//p.erase(pitr);
					p.erase(cur);
					cur = Segm(cur.l, m1.r, '+');
					p.insert(cur);
				}
			}
		}

		if (b) {
			cnt++;
			continue;
		}

		mitr = m.lower_bound(cur);
		pitr = p.lower_bound(cur);
		// l
		if (mitr != m.begin()) {
			mitr--;
		}
		if (pitr != p.begin()) {
			pitr--;
		}

		if (mitr != m.end() && (*mitr < cur)) {
			//b = true;
			if (pitr != p.end() && (*pitr < cur)) {
				Segm m1 = *mitr;
				Segm p1 = *pitr;

				if ((m1.r - m1.l) < (cur.r - cur.l)) {
					b = true;
					m.erase(mitr);
					p.erase(pitr);
					p.erase(cur);
					cur = Segm(p1.l, cur.r, '+');
					p.insert(cur);
				}
			}
			else {
				Segm m1 = *mitr;
				//Segm p1 = *pitr;

				if ((m1.r - m1.l) < (cur.r - cur.l)) {
					b = true;
					m.erase(mitr);
					//p.erase(pitr);
					p.erase(cur);
					cur = Segm(m1.l, cur.r, '+');
					p.insert(cur);
				}
			}
		}
		//cout << b << endl;
		if (!b) {

			auto tmp = p.upper_bound(cur);
			if (tmp == p.end()) {
				tmp = p.begin();
			}
			cur = *tmp;
		}


		cnt++;
	}

	if (m.empty()) {
		return true;
	}
	return false;
}

inline void solve() {
	int n = s.size();
	bool can = true;

	int st = 0;
	forn(i, 1, n) {
		if (t[i] != t[i - 1]) {
			//se.insert(Segm(st, i, s[i - 1]));
			if (st != 0 && (s[st] != t[st] || s[st] == s[st - 1])) {
				printf("No\n");
				return;
			}
			if ((s[i - 1] != t[i - 1] || s[i - 1] == s[i])) {
				printf("No\n");
				return;
			}

			if (t[i - 1] == '+') {
				int l = st;
				int r = i;
				

				if (!check_plus(l, r)) {
					printf("No\n");
					return;
				}
				//p.insert(Segm(st, i, s[i - 1]));
			}
			else {
				int l = st;
				int r = i;
				
				if (!check_minus(l, r)) {
					printf("No\n");
					return;
				}

				//m.insert(Segm(st, i, s[i - 1]));
			}
			st = i;
		}
	}

if (st != 0 && (s[st] != t[st] || s[st] == s[st - 1])) {
		printf("No\n");
		return;
	}

	if (t[n - 1] == '+') {
		int l = st;
		int r = n;

		if (!check_plus(l, r)) {
			printf("No\n");
			return;
		}
		//p.insert(Segm(st, i, s[i - 1]));
	}
	else {
		int l = st;
		int r = n;

		if (!check_minus(l, r)) {
			printf("No\n");
			return;
		}
		//m.insert(Segm(st, i, s[i - 1]));
	}

	if (can)
	{
		printf("Yes\n");
	}
	else {
		printf("No\n");
	}
}

int main() {
	freopen("storage.in", "r", stdin);
	freopen("storage.out", "w", stdout);

	int q = 0;
	cin >> q;
	forn(i, 0, q) {
		//se.clear();
		//s.clear();
		//t.clear();
		cin >> s >> t;
		solve();
	}

	fclose(stdin);
	fclose(stdout);
	return 0;
}