#include <iostream>
#include <vector>
#include <string>
#include <fstream>

using namespace std;

typedef long long ll;

struct triangle
{
	int a, b, c;
};

const int N = 5001;
ll x[N], y[N];
vector<triangle> b;

ll area(int a, int b, int c)
{
	return abs((x[a] * y[b]) - (x[b] * y[a]) + (x[b] * y[c]) - (x[c] * y[b]) + (x[c] * y[a]) - (x[a] * y[c]));
}

int main()
{
	int n, q;
	cin >> n;
	for (int i = 0; i < n; i++)
		cin >> x[i] >> y[i];
	cin >> q;
	for (int i = 0; i < n - 2; i++)
		for (int j = i + 1; j < n - 1; j++)
			for (int k = 0; k < n; k++)
			{
				if (k == i || k == j)
					continue;
				bool f = true;
				for (int l = 0; l < n; l++)
				{
					if (l == i || l == j || l == k)
						continue;
					if (area(i, j, k) == area(i, j, l) + area(i, k, l) + area(j, k, l))
					{
						f = false;
						break;
					}
				}
				if (f)
				{
					triangle t;
					t.a = i;
					t.b = j;
					t.c = k;
					b.push_back(t);
					break;
				}
			}
	while (q--)
	{
		for (int i = 0; i < b.size(); i++)
		{
			cout << "? 3 " << b[i].a + 1 << ' ' << b[i].b + 1 << ' ' << b[i].c + 1 << endl;
			string m;
			cin >> m;
			if (m == "Yes")
			{
				cout << "! 3 " << b[i].a + 1 << ' ' << b[i].b + 1 << ' ' << b[i].c + 1 << endl;
				break;
			}
		}
	}
	return 0;
}