#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define size(a) (int(a.size()))

using namespace std;

typedef long long llong;
const llong inf = (llong) 1e9 + 7ll;
const llong linf = (llong) 1e18 + 7ll;

static char buff[(int) 1e6 + 17];
const int maxn = (int) 1e6 + 17;

mt19937 rnd(time(nullptr));
const int MAXBIT = 30;
int n, k, q;
int a[maxn];

bool read()
{
    if (scanf("%d", &n) != 1)
        return false;

    forn (i, n)
        scanf("%d", a + i);

    return true;
}

void go(int l, int r, int bit)
{
    //cout << l << ' ' << r << ' ' << bit << endl;
    int cnt = 0, m;

    for (int i = l + 1; i <= r; ++i)
        if (((a[i - 1] >> bit) & 1) != ((a[i] >> bit) & 1))
        {
            if (((a[i - 1] >> bit) & 1) != 0)
                k |= (1 << bit);

            ++cnt, m = i;
            //cerr << i + 1 << ' ' << bit << endl;
        }

    if (bit == 0)
        return ;

    if (cnt == 0)
        go(l, r, bit - 1);
    else
    {
        go(l, m - 1, bit - 1);
        go(m, r, bit - 1);
    }
}

bool ggwp()
{
    for (int i = 1; i < n; ++i)
        if ((a[i - 1] ^ k) > (a[i] ^ k))
            return false;

    return true;
}

void solve()
{
    k = 0;
    go(0, n - 1, MAXBIT);

    if (ggwp())
        printf("%d\n", k);
    else
        printf("%d\n", -1);

    scanf("%d", &q);

    for (int j = 0; j < q; ++j)
    {
        int p, x;
        scanf("%d %d", &p, &x);
        a[p - 1] = x;
        k = 0;
        go(0, n - 1, MAXBIT);

        if (!ggwp())
            k = -1;

        printf("%d\n", k);
    }
}

void check()
{
    for (int b = 0; b < 100; ++b)
    {
        bool good = true;

        for (int i = 1; i < n; ++i)
            if ((a[i - 1] ^ b) > (a[i] ^ b))
                good = false;

        if (good)
        {
            for (int i = 0; i < n; ++i)
                cout << a[i] << ' ';

            cout << endl << b << endl;
            exit(0);
        }
    }
}

void gen()
{
    n = 1 + rnd() % 6;

    for (int i = 0; i < n; ++i)
        a[i] = rnd() % 16;
}

int main()
{
#ifdef SEREZHKA
    freopen("file.in", "r", stdin);
#endif // SEREZHKA

    while (read())
        solve();

    /*for (; ;)
    {
        gen();
        check();
    }*/

    return 0;
}
