#include <bits/stdc++.h>

using namespace std;
#define all(x) (x).begin(),(x).end()
typedef int ll;
typedef long double ld;

const ld eps = 1e-12;
const ll inf = numeric_limits<ll>::max() / 2 - 100;
const ll maxn = 1234567;

struct point {
    ll x, y;
    ll num;

    point() {}

    point(ll x, ll y) : x(x), y(y) {}

    friend ll operator*(point a, point b) {
        return a.y * b.x - b.y * a.x;
    }

    friend point operator-(point a, point b) {
        return point(a.x - b.x, a.y - b.y);
    }

    friend bool operator<(point a, point b) {
        return a.x < b.x || a.x == b.x && a.y < b.y;
    }
};

ll n;
vector<point> mas;
vector<point> mas2;

bool cmp(point a, point b) {
    return point(a.x - mas2[0].x, a.y - mas2[0].y) * point(b.x - mas2[0].x, b.y - mas2[0].y) < 0;
}

bool cmpy(point a, point b) {
    return a.y < b.y || a.y == b.y && a.x < b.x;
}

bool qq(ll l, ll r) {
    if (r - l <= 2) return false;
    mas2.clear();
    for (int i = l; i < r; ++i) {
        mas2.push_back(mas[i]);
    }
    sort(mas2.begin() + 1, mas2.end(), cmp);
    vector<ll> curst;
    curst.push_back(0);
    for (int j = 1; j < mas2.size(); ++j) {
        while (curst.size() > 1 && ((mas2[curst[curst.size() - 1]] - mas2[curst[curst.size() - 2]]) *
                                    (mas2[j] - mas2[curst[curst.size() - 2]])) > 0) {
            //point p1 = (mas2[curst[curst.size() - 1]] - mas2[curst[curst.size() - 2]]);
            //point p2 = (mas2[j] - mas2[curst[curst.size() - 2]]);
            //cerr << p1 * p2;
            curst.pop_back();
        }
        curst.push_back(j);
    }
    cout << "? " << curst.size() << " ";
    for (int i = 0; i < curst.size(); ++i) {
        cout << mas2[curst[i]].num << " ";
    }
    cout << endl;
    string ans;
    cin >> ans;
    return ans == "Yes";
}

vector<point> getans(ll l, ll r) {

    mas2.clear();
    for (int i = l; i < r; ++i) {
        mas2.push_back(mas[i]);
    }
    sort(mas2.begin() + 1, mas2.end(), cmp);
    vector<ll> curst;
    curst.push_back(0);
    for (int j = 1; j < mas2.size(); ++j) {
        while (curst.size() > 1 && ((mas2[curst[curst.size() - 1]] - mas2[curst[curst.size() - 2]]) *
                                    (mas2[j] - mas2[curst[curst.size() - 2]])) > 0) {
            //point p1 = (mas2[curst[curst.size() - 1]] - mas2[curst[curst.size() - 2]]);
            //point p2 = (mas2[j] - mas2[curst[curst.size() - 2]]);
            //cerr << p1 * p2;
            curst.pop_back();
        }
        curst.push_back(j);
    }
    vector<point> ans;
    for (int i = 0; i < curst.size(); ++i) {
        ans.push_back(mas2[curst[i]]);
    }
    return ans;
}

int run() {
    cin >> n;
    mas.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> mas[i].x >> mas[i].y;
        mas[i].num = i + 1;
    }
    sort(all(mas));
    ll q;
    cin >> q;
    while (q--) {
        vector<point> ctmpmas = mas;
        while (mas.size() > 3) {
            ll l = 0;
            ll r = n;
            while (l + 1 != r) {
                ll m = (l + r) >> 1;
                if (qq(0, m)) {
                    r = m;
                } else {
                    l = m;
                }
            }
            ll myr = r;
            l = 0;
            r = myr;
            while (l + 1 != r) {
                ll m = (l + r) >> 1;
                if (qq(m, myr)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            vector<point> tmpmas = mas;
            mas.clear();
            for (int i = l; i < myr; ++i) {
                mas.push_back(tmpmas[i]);
            }
/////////////////////////////////////////
            l = 0;
            r = mas.size();
            sort(all(mas), cmpy);
            while (l + 1 != r) {
                ll m = (l + r) >> 1;
                if (qq(0, m)) {
                    r = m;
                } else {
                    l = m;
                }
            }
            myr = r;
            l = 0;
            r = myr;
            while (l + 1 != r) {
                ll m = (l + r) >> 1;
                if (qq(m, myr)) {
                    l = m;
                } else {
                    r = m;
                }
            }
        }
        vector<point> ans = mas;
        if (ans.size() != 3) {
            exit(1);
        }
        cout << "! " << ans.size() << " ";
        for (auto i : ans) {
            cout << i.num << " ";
        }
        cout << endl;
        mas = ctmpmas;
    }
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}