#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

/*
const ll MAX_MEM = 1e8;
 
char mem[MAX_MEM];
int mpos = 0;
 
void *operator new(size_t n) {
    if (mpos + n >= MAX_MEM) {
        mpos = MAX_MEM / 2;
    }
    void *ans = mem + mpos;
    mpos += n;
    return ans;
}
 
void operator delete(void *) {}*/

struct node {
    ll val;
    node *l, *r;

    node() {
        val = 0;
        l = nullptr;
        r = nullptr;
    }
};

const ll maxn = 200101;
const ll inf = numeric_limits<ll>::max() / 2 - 100;
const ll nn = 1e9;
ll n, a;

struct exper {
    ll l, r, c;

    exper() {}
};

vector<exper> vec;

node *root = nullptr;

inline ll gett(node *v) {
    if (v == nullptr) return 0;
    return v->val;
}

ll addpos, addval;

void add(node *&v, int vl, int vr) {
    if (v == nullptr) v = new node();
    if (vl + 1 == vr) {
        v->val = addval;
        return;
    }
    int mid = (vl + vr) >> 1;
    if (mid > addpos) add(v->l, vl, mid);
    else add(v->r, mid, vr);
    v->val = min(gett(v->l), gett(v->r) + nn * (mid - vl));
}

ll getl, getr;

ll getmin(node *v, int vl, int vr) {
    if (vl >= getl && vr <= getr)
        return gett(v);
    if (vl >= getr || vr <= getl)
        return inf;
    if (v == nullptr) v = new node();
    int mid = (vl + vr) >> 1;
    ll m1 = getmin(v->l, vl, mid);
    ll m2 = getmin(v->r, mid, vr);
    return min(m1, m2 + nn * (mid - vl));
}

int run() {
    cin >> n >> a;
    a++;
    vec.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].l >> vec[i].r >> vec[i].c;
    }
    for (int v = a - 1; v >= 0; v--) {
        ll ans = 0;
        for (int i = 0; i < n; ++i) {
            if (v + vec[i].r < a) {
                ll newans = 0;
                ll myadd = -v * nn;
                getl = v + vec[i].l;
                getr = v + vec[i].r + 1;
                newans = getmin(root, 0, a) + myadd;
                newans -= vec[i].c;
                ans = max(ans, newans);
            }
        }
        addpos = v;
        addval = ans;
        add(root, 0, a);
        if (v == 0) {
            cout << ans;
        }
    }
    return 0;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    run();
    return 0;
}