#include <iostream>
#include <vector>

using namespace std;
#define long long long

/*
3
++- +++
++-- ++++
++-+--+- ++++++++

3
++-+-- ++----
++-+-- +++---
-++- -++-

1
-+- +++
 */

int main() {
    int q;
    cin >> q;
    for (int test = 0; test < q; ++test) {
        string s, t;
        cin >> s >> t;
        int n = s.length();

        vector<pair<int, int>> seg;
        int prev = 0;
        for (int i = 1; i < n; ++i) {
            if (t[i] != t[i - 1]) {
                seg.push_back({prev, i - 1});

                prev = i;
            }
        }
        seg.push_back({prev, n - 1});

        // ---
        char need = t[0];
        char cur = s[0];
        int cur_len = 1;
        int len_ok = cur == need;
        for (int i = 1; i <= n; ++i) {
            if (i != n && s[i] == s[i - 1]) {
                cur_len++;
                if (cur == need) len_ok++;
            } else {
                if (cur != need) {
                    if (len_ok > cur_len) {
                        for (int k = i - cur_len; k <= i - 1; ++k) {
                            s[k] = need;
                        }
                        len_ok += cur_len;
                        cur_len = len_ok;
                    }
                }
                if (i < n) cur = s[i];
                cur_len = 1;
            }
        }
        need = t[n - 1];
        cur = s[n - 1];
        cur_len = 1;
        len_ok = cur == need;
        for (int i = n - 2; i >= -1; --i) {
            if (i != -1 && s[i] == s[i + 1]) {
                cur_len++;
                if (cur == need) len_ok++;
            } else {
                if (cur != need) {
                    if (len_ok > cur_len) {
                        for (int k = i + cur_len; k >= i + 1; --k) {
                            s[k] = need;
                        }
                        len_ok += cur_len;
                        cur_len = len_ok;
                    }
                }
                if (i > -1) cur = s[i];
                cur_len = 1;
            }
        }

        cout << (s == t ? "Yes" : "No") << '\n';
    }

    return 0;
}