#include <iostream>
#include <cstdio>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <cstring>
#include <cmath>

using namespace std;

struct point {
    double x, y;
    point() {}
    point (double _x, double _y) {
        x = _x;
        y = _y;
    }
    point (pair <int, int> par){
        x = par.first;
        y = par.second;
    }
    const point operator - (const point &p) const {
        return point(x - p.x, y - p.y);
    }
    const double operator * (const point &p) const {
        return x * p.y - y * p.x;
    }
};

pair <pair <int, int>, int > tch[(int)1e4];
pair <int, int> izn[(int)4e6];
pair<double, int> tg[(int)1e4];
vector <pair<int, pair<int, int> > > tocheck;
int leftx;


set <pair <int, int> > used;
//set <pair < pair <int, int>, int > >  line;
vector <int > svyaz[(int)1e4];
//int minxn = 0;



bool isgood(pair <int, int> ug0, pair <int, int> ug1, pair <int, int> ug2 ) {
    point a = point(ug0);
    point b = point(ug1);
    point c = point(ug2);
    return (a - b) * (c - b) > 0;
}

void chk (int xxx) {
    if (svyaz[xxx].size() == 2) {
        int sv[] = {svyaz[xxx][0],svyaz[xxx][1]};
        /*double tgs[2];
        for (int i = 0; i < 2; i++) {
            tgs[i] = (izn[sv[i]].second - inz[leftx].second) / (izn[sv[i]].first - izn[leftx].first);
        }
        if (tgs[0] > tgs[1]) {
            swap(sv[0], sv[1]);
        }*/
        if (isgood(izn[sv[0]], izn[xxx], izn[sv[1]])) {
            svyaz[xxx].pop_back();
            svyaz[xxx].pop_back();
            tocheck.push_back(make_pair(xxx, make_pair(sv[0], sv[1])));
            svyaz[sv[0]].pop_back();
            svyaz[sv[0]].push_back(sv[1]);
            svyaz[sv[1]][0] = sv[0];
            chk(sv[1]);
            chk(sv[2]);
        }
    }
}

int main()
{
    /*
    6
    3 0
    0 2
    2 4
    4 2
    5 5
    6 1
    4
    */
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        tch[i].second = i + 1;
        scanf("%d%d", &tch[i].first.first, &tch[i].first.second);
        izn[i + 1] = make_pair(tch[i].first.first, tch[i].first.second);
    }
    sort(tch, tch + n);
    for (int k = 1; k < n; k++) {//cout<<"j";
        tg[k] = make_pair((double)(tch[k].first.second - tch[0].first.second) / (tch[k].first.first - tch[0].first.first), tch[k].second);
    }
    leftx = tch[0].second;
    sort(tg + 1, tg + n);
    for (int k = 1; k < n - 1; k++) {
        tocheck.push_back(make_pair(tch[0].second, make_pair(tg[k].second, tg[k + 1].second)));
        svyaz[tg[k].second].push_back(tg[k + 1].second);
        svyaz[tg[k + 1].second].push_back(tg[k].second);
    }
    for (int i = 1; i <= n; i++) {
        chk(i);
    }


    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        for (int j = 0; j <= tocheck.size(); j++) {
            printf("? 3 %d %d %d\n", tocheck[j].first, tocheck[j].second.first, tocheck[j].second.second);
            string ss;
            cin >> ss;
            if (ss[0] == 'Y') {
                printf("! 3 %d %d %d\n", tocheck[j].first, tocheck[j].second.first, tocheck[j].second.second);
                break;
            }
        }
    }

    return 0;
}
