#include <iostream>
#include <stack>
#include <string>
#include <cstdlib>
#include <vector>
#include <set>

using namespace std;

typedef long long ll;


const ll max_s = 3;
ll n, q;
vector < ll > numbs;
vector < pair < ll, ll > > zapr;
vector < vector < ll > > bin;

ll get_answ() {
  ll res[max_s];
  set < ll > gr;
  gr.insert(0);
  gr.insert(n);
  for (ll j = max_s - 1; j >= 0; j--) {
    int new_s = -1;
    int a = 0, b = 0;

    vector < ll > to_gr;

    for (auto it : gr) {
      if (it != 0) {
        a = b;
        b = it;
        if (bin[a][j] != bin[b - 1][j]) {
          if (bin[a][j] == 0) {
            if (new_s != 1) {
              new_s = 0;

              ll l = a, r = b;
              while (r - l > 1) {
                ll m = (l + r) / 2;
                if (bin[m][j] == 0) {
                  l = m;                  // binpoisk
                }
                else {
                  r = m;
                }
              }
              to_gr.push_back(l + 1);

            }
            else {
              return -1;
            }
          }
          else {
            if (new_s != 0) {
              new_s = 1;


              ll l = a, r = b;
              while (r - l > 1) {
                ll m = (l + r) / 2;
                if (bin[m][j] == 1) {
                  l = m;                  // binpoisk
                }
                else {
                  r = m;
                }
              }
              to_gr.push_back(l + 1);


            }
            else {
              return -1;
            }
          }
        }
      }
    }
    if (new_s == -1) new_s = 0;
    res[j] = new_s;
    for (auto i : to_gr) {
      gr.insert(i);
    }
  }
  ll res1 = 0;
  ll st_dv = 1;
  for (int i = 0; i < max_s; i++) {
    res1 += res[i] * st_dv;
    st_dv *= 2;
  }
  ll c = numbs[0] ^ res1;
  ll d = numbs[0] ^ res1;
  for (ll i = 1; i < n; i++) {
    c = d;
    d = numbs[i] ^ res1;
    if (c > d)
      return -1;
  }
  return res1;
}

int main() {
  cin >> n;
  vector < ll > gov(max_s, 0);
  bin.resize(n, gov);
  for (ll i = 0; i < n; i++) {
    ll count;
    cin >> count;
    numbs.push_back(count);
    for (ll j = 0; j < max_s; j++) {
      bin[i][j] = count % 2;
      count >>= 1;
    }
  }
  zapr.push_back(make_pair(0, numbs[0]));
  cin >> q;
  for (ll i = 0; i < q; i++) {
    pair < ll, ll > count;
    cin >> count.first >> count.second;
    count.first--;
    zapr.push_back(count);
  }
  q++;
  for (ll i = 0; i < q; i++) {
    ll res;
    numbs[zapr[i].first] = zapr[i].second;
    ll count = zapr[i].second;
    for (ll j = 0; j < max_s; j++) {
      bin[zapr[i].first][j] = count % 2;
      count >>= 1;
    }
    res = get_answ();
    cout << res << endl;
  }
  system("pause");
	return 0;
}
