#include <bits/stdc++.h>

#define fs first
#define sc second
#define int unsigned long long

using namespace std;

const int max_n = 1088;
const int inf = 1e12 + 228;
bool add[max_n];

int g[max_n][max_n];

vector <pair <int, int> > G[max_n];

bool operator <(pair <int, int> a, pair <int, int> b) {
    return (a.fs < b.fs) || ((a.fs == b.fs) && (a.sc > b.sc));
}

pair <int, int> mn(pair <int, int> a, pair <int, int> b) {
    if (a < b) return a;
    return b;
}

signed main() {
    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            g[i][j] = inf;
        }
    }

    for (int i = 0; i < m; i++) {
        int k;
        cin >> k;
        int t[k + 1];
        int v[k + 1];
        cin >> v[0];
        for (int j = 1; j <= k; j++) {
            cin >> t[j] >> v[j];
        }

        for (int j = 0; j <= k; j++) {
            int sum = 0;
            for (int c = j + 1; c <= k; c++) {
                sum += t[c];
                g[v[j]][v[c]] = min(g[v[j]][v[c]], sum);
            }
        }
    }
    pair <int, int> d[n + 1];
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= n; j++) {
            if (g[i][j] < inf) {
                G[i].push_back({j, g[i][j]});
            }
        }
        d[i] = {inf, 0};
    }
    d[1] = {0, 0};
    pair <int, int> nw;
    for (int i = 1; i <= n; i++) {
        int ind = 1;
        for (int j = 1; j <= n; j++) {
            if (d[j] < d[ind]) ind = j;
        }
        if (ind == n) {
            cout << d[ind].fs << ' ' << d[ind].sc;
            return 0;
        }
        for (pair <int, int> u : G[ind]) {
            nw = {d[ind].fs + u.sc, d[ind].sc + u.sc * u.sc};
            if (nw < d[u.fs]) {
                d[u.fs] = nw;
            }
        }
        d[ind] = {inf, 0};
    }
    return 0;
}
