#define make_pair mp
#define push_back pb
#define pop_back pob
#define first X
#define second Y
#define _p(x, y) pair<x, y>

#include <iostream>
#include <vector>
#include <string>
#include <stdio.h>
#include <set>
#include <map>
#include <algorithm>
#include <cmath>
#include <iterator>
#include <queue>
#include <climits>

using namespace std;

typedef long long i64;
const int INF = 1000000007;
const i64 LINF = 1000000000000000007;
#define endl '\n'

void tpush(deque < _p(int, int) > &rig, int l, int r) {
	_p(int, int) np = mp(l, r);
	int nl;
	if (rig.size() && rig.back().Y == np.X - 1) {
		nl = rig.back().X;
		rig.pob();
		rig.pb(mp(nl, r));
	}
	else {
		rig.pb(np);
	}
}

void tchange(deque < _p(int, int) > &rig, int l, int r) {
	_p(int, int) cp = mp(l, r);
	if (rig.size() && rig.front().X == cp.Y + 1) {
		cp = mp(cp.X, rig.front().Y);
		rig.pop_front();
	}

	if (rig.size() && rig.back().Y + 1 == cp.X) {
		cp = mp(rig.back().X, cp.Y);
		rig.pob();
	}

	rig.pb(cp);
}

void quest(int l, int r) {
	cout << "? " << l + 1 << " " << r + 1 << endl;
	fflush(stdout);
}

int main() {
	
#ifdef _DEBUG
	//freopen("A.txt", "r", stdin);
#endif

	int n;
	cin >> n;

	vector < char > seq(n, '#');
	int left = n;
	int l, r;
	string buff;
	deque < _p(int, int) >  rights;
	for (int i = 0; i < n - 1; i++) {
		l = i;
		r = i + 1;
		quest(l, r);
		cin >> buff;
		if (buff == "YES") {
			left -= 2;
			seq[l] = '(';
			seq[r] = ')';
			tpush(rights, l, r);
		}
	}

	_p(int, int) cp;
	while (left > 0 && rights.size()) {
		cp = rights.front();
		rights.pop_front();

		l = cp.X - 1;
		r = cp.Y + 1;

		if (l < 0 || r >= n) {
			tchange(rights, cp.X, cp.Y);
			continue;
		}

		quest(l, r);
		cin >> buff;
		if (buff == "Yes") {
			seq[l] = '(';
			seq[r] = ')';
			left -= 2;
			tchange(rights, l, r);
		}
		else {
			tchange(rights, cp.X, cp.Y);
		}
	}

	cout << "! ";
	for (int i = 0; i < n; i++) {
		cout << seq[i];
	}
	cout << endl;
	return 0;
}