#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <stack>
#include <set>

using namespace std;

typedef long long ll;

vector<ll> a;
ll n;

ll get_ans()
{
	vector<ll> bit(n);
	vector < ll > mag;
	vector<ll> wal;
	wal.push_back(n - 1);

	for (int poss = 3; poss >= 0; --poss)
	{
		for (int i = n - 1; i >= 0; --i)
		{
			bit[i] = (a[i] >> poss) & 1;
		}

		ll up = -1, dn = 0;
		vector<ll> res;
		ll sz = wal.size();
		for (int ch = 0; ch < sz; ++ch)
		{
			dn = up + 1;
			up = wal[ch];

			ll cnt_0 = 0, cnt_1 = 0;

			for (int i = dn; i <= up; ++i)
			{
				cnt_0 += (bit[i] == 0);
				cnt_1 += (bit[i] == 1);
			}


			if (cnt_0 == up - dn + 1 || cnt_1 == up - dn + 1)
			{
				res.push_back(-1);
				continue;
			}

			int f = 0, pos;
			bool f1 = 1;
			for (int i = up; i >= dn; --i)
			{
				if (bit[i] == 0)
				{
					f = 1;
				}
				if (bit[i] == 1 && f)
				{
					f1 = 0;
				}
				if (bit[i] == 1)
				{
					pos = i;
				}
			}

			if (f1 == 1)
			{
				res.push_back(0);//////////////////////////////////////////////////////////////////////////////
				wal.push_back(pos - 1);
				continue;
			}

			f = 0;
			bool f0 = 1;
			for (int i = up; i >= dn; --i)
			{
				if (bit[i] == 1)
				{
					f = 1;
				}
				if (bit[i] == 0 && f)
				{
					f0 = 0;
				}
				if (bit[i] == 0)
				{
					pos = i;
				}
			}

			if (f0 == 1)
			{
				res.push_back(1);//////////////////////////////////////////////////////////////////////////////
				wal.push_back(pos - 1);
				continue;
			}

			res.push_back(1e18);
		}

		ll cn_0 = 0, cn_1 = 0, pofik = 0, baa = 0;
		for (int i = 0; i < res.size(); ++i)
		{
			if (res[i] == 1e18)
			{
				baa = 1;
				break;
			}
			pofik = (res[i] == -1);
			cn_1 = (res[i] == 1);
			cn_0 = (res[i] == 0);
		}

		if (baa >= 1 || (cn_1 > 0 && cn_0 > 0))
		{
			mag.push_back(-1);
		}
		else if (cn_1 > 0)
		{
			mag.push_back(1);
		}
		else
		{
			mag.push_back(0);
		}
		sort(wal.begin(), wal.end());
	}

	ll D = 1e18;
	for (int i = 0; i < mag.size(); ++i)
	{
		if (mag[i] == -1)
		{
			D = -1;
			break;
		}
	}
	if (D == -1)
	{
		return D;
	}
	else
	{
		ll answer = 0, ch = 1;
		for (int i = mag.size() - 1; i >= 0; --i)
		{
			answer += mag[i] * ch;
			ch *= 2;
		}
		return answer;
	}
}


int main()
{
	
	cin >> n;
	a.resize(n);

	for (int i = 0; i < n; ++i)
	{
		cin >> a[i];
	}
	
	cout << get_ans() << endl;

	ll q;
	cin >> q;

	for (int i = 0; i < n; ++i)
	{
		ll pos, val;
		cin >> pos >> val;
		--pos;

		a[pos] = val;

		cout << get_ans() << endl;
	}
	
	return 0;
}

/*
6
7
8
12
13
16
15

4
6
3
3
0

3
0 1 4
3
2 7
3 3
1 4

*/