#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000000;

int n, m;
vector<pair<int, int> > dist[15000];
pair<int, int> d[15000];

pair<int, int> operator + (pair<int, int> p1, pair<int, int> p2)
{
    return make_pair(p1.first + p2.first, p1.second + p2.second);
}

void dji()
{
    set<pair<pair<int, int>, int> > opts;
    opts.clear();
    for (int i = 2; i <= n; i++)
    {
        d[i] = make_pair(INF, INF);
    }
    d[1] = make_pair(0, 0);
    for (int i = 1; i <= n; i++)
    {
        opts.insert(make_pair(d[i], i));
    }
    while (!opts.empty())
    {
        pair<pair<int, int>, int> cur = *opts.begin();
        opts.erase(cur);
        int v = cur.second;
        //cout << v << endl;
        for (int i = 0; i < dist[v].size(); i++)
        {
            int u = dist[v][i].first, dst = dist[v][i].second;
            if (d[v] + make_pair(dst, dst * dst) < d[u])
            {
                opts.erase(make_pair(d[u], u));
                d[u] = d[v] + make_pair(dst, dst * dst);
                opts.insert(make_pair(d[u], u));
                //cout << u << ' ' << d[u].first << ' ' << d[u].second << endl;
            }
        }
    }
}

int main()
{
    cin >> n >> m;
    for (int i = 0; i < m; i++)
    {
        int t, st;
        cin >> t >> st;
        for (int j = 0; j < t; j++)
        {
            int d, fn;
            cin >> d >> fn;
            dist[st].push_back(make_pair(fn, d));
            st = fn;
        }
    }
    dji();
    cout << d[n].first << ' ' << d[n].second;
}
