#include <bits/stdc++.h>

using namespace std;

#define int int64_t
//#define endl '\n'
#define fi first
#define se second
#define mp make_pair

template <typename T>
istream & operator >> (istream & in, vector <T> & arr)
{
    for (auto & i : arr)
        in >> i;
    return in;
}

template <typename T>
ostream & operator << (ostream & out, vector <T> & arr)
{
    for (auto i : arr)
        out << i << " ";
    return out;
}

template <typename T1, typename T2>
istream & operator >> (istream & in, pair <T1, T2> & p)
{
    in >> p.fi >> p.se;
    return in;
}

pair <int, int> operator - (pair <int, int> & a, pair <int, int> & b)
{
    return mp(a.fi - b.fi, a.se - b.se);
}

int operator * (pair <int, int> a, pair <int, int> b)
{
    return a.fi * b.fi + a.se * b.se;
}

int operator ^ (pair <int, int> a, pair <int, int> b)
{
    return a.fi * b.se - a.se * b.fi;
}

bool is_in_tr(pair <int, int> & a, pair <int, int> & b, pair <int, int> & c, pair <int, int> & d)
{
    bool flag1 = ((b - a) ^ (d - a)) * ((c - a) ^ (d - a)) <= 0ll;
    bool flag2 = ((b - c) ^ (d - c)) * ((a - c) ^ (d - c)) <= 0ll;
    bool flag3 = ((c - b) ^ (d - b)) * ((a - b) ^ (d - b)) <= 0ll;
    return flag1 && flag2 && flag3;
}

signed main()
{
    int n;
    cin >> n;
    vector <pair <int, int> > arr2(n);
    cin >> arr2;
    int q;
    cin >> q;
    vector <pair <int, pair <pair <int, int>, int> > > arr;
    for (int i = 0; i < n; ++i)
    {
        for (int j = i + 1; j < n; ++j)
        {
            for (int k = j + 1; k < n; ++k)
            {
                bool flag = true;
                for (int kk = 0; kk < n; ++kk)
                {
                    if (kk == i || kk == j || kk == k)
                        continue;
                    if (is_in_tr(arr[i], arr[j], arr[k], arr[kk]))
                    {
                        flag = false;
                        break;
                    }
                }
                if (flag)
                    arr.push_back(mp(abs((arr2[j] - arr2[i]) ^ (arr2[k] - arr2[i])), mp(mp(i + 1, j + 1), k + 1)));
            }
        }
    }
    sort(arr.begin(), arr.end());
    for (int itt = 0; itt < q; ++itt)
    {
        int j = 0;
        while (j < arr.size())
        {
            cout << "? 3 " << arr[j].se.fi.fi << " " << arr[j].se.fi.se << " " << arr[j].se.se << endl;
            string ans;
            cin >> ans;
            if (ans == "Yes")
            {
                cout << "! 3 " << arr[j].se.fi.fi << " " << arr[j].se.fi.se << " " << arr[j].se.se << endl;
                break;
            }
            ++j;
        }
    }
    return 0;
}
