#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<cassert>
#include<algorithm>
#include<ctime>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<cstring>
#include<queue>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define X first
#define Y second
#define psh push_back
#define all(a) a.begin(), a.end()
#define forn(i, n) for(int i = 0; i < (n); ++i)
#define for1(i, n) for(int i = 1; i <= (n); ++i)

const int INF = (int)1e9 + 7;
const int MAXN = (int)1e3 + 7;
const ll LINF = (ll)1e18 + 7;

void file() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin); freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(0);
	cin.tie(0);
}

ll a[MAXN], b[MAXN];
ll c[MAXN], d[MAXN];
ll p[MAXN];
int good = 1;
int used[MAXN];

ll get(int l, int r) {
	if (l > r || l < 0)
		return 0;
	return p[r] - (l > 0 ? p[l - 1] : 0);
}

int main() {
	file();
	int n, m;
	cin >> n >> m;
	forn(i, n)
		cin >> a[i];
	ll sum = 0;
	forn(i, n) {
		cin >> b[i];
		sum += b[i];
	}
	ll ans = sum;
	int la = 0, ra = n - 1, lc = -1, rc = -1;
	sum = 0;
	forn(i, m)
		cin >> c[i];
	forn(i, m) {
		cin >> d[i];
		sum += d[i];
		p[i] = sum;
	}
	if (sum > ans) {
		ans = max(ans, sum);
		la = -1, ra = -1, lc = 0, rc = m - 1;
	}
	
	for (int l1 = 0; l1 < n; ++l1) {
		for (int r1 = l1; r1 < n; ++r1) {
			set<int> s;
			ll cur = 0;
			for (int i = l1; i <= r1; ++i) {
				used[a[i]] = good;
				cur += b[i];
			}
			ll mx = 0;
			int last = 0;
			int L, R;
			forn(i, m) {
				if (used[c[i]] != good) {
					if (mx < get(last, i - 1)) {
						L = last;
						R = i - 1;
						mx = get(last, i - 1);
					}
					last = i + 1;
				}
			}
			if (mx < get(last, m - 1)) {
				L = last;
				R = m - 1;
				mx = get(last, m - 1);
			}
			if (cur + mx > ans) {
				la = l1;
				ra = r1;
				lc = L;
				rc = R;
				ans = cur + mx;
			}
		}
	}
	cout << ans << "\n";
	cout << la + 1 << " " << ra + 1 << "\n" << lc + 1 << " " << rc + 1;

	return 0;
}