
import java.util.Scanner;
import java.util.Stack;

public class ACopter {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int n = in.nextInt();
        stack stack = new stack();
        stack.push(0);
        int[] result = new int[n];
        result[0] = 1;
        boolean answer;
        for (int i = 1; i < n; i++) {
            if (stack.size() != 0) {
                System.out.println("? " + (stack.peek() + 1) + " " + (i + 1));
                answer = in.next().equals("Yes");
                if (answer) {
                    stack.pop();
                    result[i] = -1;
                } else {
                    result[i] = 1;
                    stack.push(i);
                }
            } else {
                result[i] = 1;
                stack.push(i);
            }
        }
        String s = "! ";
        for (int i = 0; i < n; i++) {
            if (result[i] == -1) {
                s += ")";
            } else {
                s += "(";
            }
        }
        System.out.println(s);
    }

    static class stack {
        int a[] = new int[50000];
        int cur = 0;

        void push(int x) {
            a[cur] = x;
            cur++;
        }

        int peek() {
            return a[cur];
        }

        int pop() {
            cur--;
            return a[cur + 1];
        }

        int size() {
            return cur;
        }
    }
}
