#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

const int INF = (int) 1e9 + 123;
const ll LINF = (ll) 1e18 + 123;

void run();

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	run();
	return 0;
}

const int A = (int) 1 << 18;
const ll C = (ll) 1e9;
const int N = 101;

int n, a;
int l[N], r[N], c[N];
ll t[2 * A];

ll get_min(int i, int tl, int tr, int l, int r) {
	if (l >= tr || r <= tl) {
		return LINF;
	}
	
	if (l <= tl && tr <= r) {
		return t[i];
	}
	
	int tm = (tl + tr) >> 1;
	return min(get_min((i << 1), tl, tm, l, r), get_min((i << 1) + 1, tm, tr, l, r));
}

void upd(int ind, ll val) {
	int i = A + ind;
	t[i] = val;
	i >>= 1;
	while (i) {
		t[i] = min(t[(i << 1)], t[(i << 1) + 1]);
		i >>= 1;
	}
}

void run() {
	cin >> n >> a;
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i] >> c[i];
	}
	
	ll prv = 0;
	
	for (int i = 1; i <= a; i++) {
		ll res = prv;
		
		for (int j = 0; j < n; j++) {
			if (r[j] <= i) {
				res = max(res, get_min(1, 0, A, i - r[j], i - l[j] + 1) + C * i - c[j]);
			}
		}
		
		upd(i, res - (C * i));
		prv = res;
	}
	
	cout << prv << "\n";
}
