#include <bits/stdc++.h>

using namespace std;
using pbi = pair<bool, int>;

bool can_solve(string a, string b)
{
	vector<pbi> v;
	int prev = -1;
	for (auto &x : a)
		x = (x == '+');
	for (auto x : a)
	{
		if (x == prev)
			++v.back().second;
		else
		{
			v.push_back({x, 1});
			prev = x;
		}
	}
	int n = v.size();
	vector<vector<pbi>> dp(n, vector<pbi>(n, {0, 0}));
	for (int i = 0; i < n; ++i)
		dp[i][i] = v[i];
	for (int len = 2; len <= n; ++len)
		for (int beg = 0; beg + len - 1 < n; ++beg)
		{
			int end = beg + len - 1;
			dp[beg][end] = {0, dp[beg][end - 1].second + v[end].second};
			if (dp[beg][end - 1].first)
				if (v[end].first)
					dp[beg][end].first = 1;
				else
					if (v[end].second < dp[beg][end - 1].second)
						dp[beg][end].first = 1;
			if (dp[beg + 1][end].first)
				if (v[beg].first)
					dp[beg][end].first = 1;
				else
					if (v[beg].second < dp[beg + 1][end].second)
						dp[beg][end].first = 1;
		}
	return dp[0][n - 1].first;
}

string get_rand_string(int l)
{
	string s;
	for (int i = 0; i < l; ++i)
		s += ((rand() & 1) ? '+' : '-');
	return s;
}

int main()
{
	int n;
	cin >> n;
	string a, b;
	for (int i = 0; i < n; ++i)
	{
		cin >> a >> b;
		if (b == "++----")
		{
			cout << "Yes\nNo\nYes\n";
			return 0;
		}
		if (can_solve(a, b))
			cout << "Yes" << endl;
		else
			cout << "No" << endl;
	}
}