import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

/**
 * Created by roi on 3/28/2017.
 */
public class Main {
    public void solve() throws IOException {
        int n = nextInt();
        boolean[][] a = new boolean[n][30];
        for (int i = 0; i < n; i++) {
            long z = nextLong();
            int j = 29;
            while (j >= 0) {
                if (z % 2 == 1) {
                    a[i][j] = true;
                }
                z /= 2;
                j--;
            }
        }
        int[] sim = new int[30];
        boolean[] ans = new boolean[30];
        int[] used = new int[30];
        for (int i = 0; i < 30; i++) {
            used[i] = -1;
        }
        boolean t = true;
        int[] r = new int[n - 1];
        for (int i = 0; i < n - 1; i++) {
            r[i] = -1;
        }
        for (int i = 0; i < n - 1; i++) {
            for (int j = 0; j < 30; j++) {
                if (!a[i][j] && a[i + 1][j]) {
                    if (used[j] != 1) {
                        used[j] = 0;
                        r[i] = j;
                        sim[j]++;
                    } else {
                        t = false;
                    }
                    break;
                }
                if (a[i][j] && !a[i + 1][j]) {
                    if (used[j] != 0) {
                        r[i] = j;
                        sim[j]++;
                        used[j] = 1;
                        ans[j] = true;
                        break;
                    } else {
                        t = false;
                        break;
                    }
                }
            }
        }
        if (t) {
            long s = 0;
            for (int t1 = 0; t1 < 30; t1++) {
                s *= 2;
                if (ans[t1]) {
                    s++;
                }
            }
            out.println(s);
        } else {
            out.println(-1);
        }
        int m = nextInt();
        for (int y = 0; y < m; y++) {
            int k = nextInt() - 1;
            long z = nextLong();
            int j = 29;
            while (j >= 0) {
                if (z % 2 == 1) {
                    a[k][j] = true;
                } else {
                    a[k][j] = false;
                }
                z /= 2;
                j--;
            }
            if (!t) {
                sim = new int[30];
                if (k != n - 1 && r[k] != -1) {
                    ans[r[k]] = false;
                    r[k] = -1;
                }
                if (k != 0 && r[k - 1] != -1) {
                    ans[r[k - 1]] = false;
                    r[k - 1] = -1;
                }
                t = true;
                ans = new boolean[30];
                for (int i = 0; i < 30; i++) {
                    used[i] = -1;
                }
                for (int i = 0; i < n - 1; i++) {
                    for (j = 0; j < 30; j++) {
                        if (!a[i][j] && a[i + 1][j]) {
                            if (used[j] != 1) {
                                used[j] = 0;
                                sim[j]++;
                                r[i] = j;
                            } else {
                                t = false;
                            }
                            break;
                        }
                        if (a[i][j] && !a[i + 1][j]) {
                            if (used[j] != 0) {
                                r[i] = j;
                                used[j] = 1;
                                sim[j]++;
                                ans[j] = true;
                                break;
                            } else {
                                t = false;
                                break;
                            }
                        }
                    }
                }
                if (t) {
                    long s = 0;
                    for (int t1 = 0; t1 < 30; t1++) {
                        s *= 2;
                        if (ans[t1]) {
                            s++;
                        }
                    }
                    out.println(s);
                } else {
                    out.println(-1);
                }
            } else {
                if (k != n - 1 && r[k] != -1) {
                    ans[r[k]] = false;
                    sim[r[k]]--;
                    if (sim[r[k]] == 0) {
                        used[r[k]] = -1;
                    }
                    r[k] = -1;
                }
                if (k != 0 && r[k - 1] != -1) {
                    ans[r[k - 1]] = false;
                    sim[r[k - 1]]--;
                    if (sim[r[k - 1]] == 0) {
                        used[r[k - 1]] = -1;
                    }
                    r[k - 1] = -1;
                }
                t = true;
                for (int i = Math.max(0, k - 1); i <= Math.min(n - 2, k); i++) {
                    for (j = 0; j < 30; j++) {
                        if (!a[i][j] && a[i + 1][j]) {
                            if (used[j] != 1) {
                                sim[j]++;
                                used[j] = 0;
                                r[i] = j;
                            } else {
                                t = false;
                            }
                            break;
                        }
                        if (a[i][j] && !a[i + 1][j]) {
                            if (used[j] != 0) {
                                sim[j]++;
                                r[i] = j;
                                used[j] = 1;
                                ans[j] = true;
                                break;
                            } else {
                                t = false;
                                break;
                            }
                        }
                    }
                }
                if (t) {
                    long s = 0;
                    for (int t1 = 0; t1 < 30; t1++) {
                        s *= 2;
                        if (ans[t1]) {
                            s++;
                        }
                    }
                    out.println(s);
                } else {
                    out.println(-1);
                }
            }
        }
    }

    BufferedReader br;
    StringTokenizer sc;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (sc == null || !sc.hasMoreTokens()) {
            try {
                sc = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                return null;
            }
        }
        return sc.nextToken();
    }

    public Integer nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public Long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new Main().run();
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
            solve();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
