#define _CRT_SECURE_NO_DEPRECATE
#include <iostream>
#include <string>
#include <cstring>
#include <vector>
#include <algorithm>


using namespace std;
typedef long long ll;
const ll INFll = 2e18;
//12:45


vector<pair<ll, pair<int, int> > > E;
pair<ll, ll> dist[10005];


bool cmp(pair<ll, ll> a, pair<ll, ll> b) {
	return a.first == b.first ? a.second > b.second : a.first < b.first;
}


pair<ll, ll> operator + (pair<ll, ll> a, pair<ll, ll> b) {
	return{ a.first + b.first, a.second + b.second };
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);freopen("output.txt", "w", stdout);
#endif // _DEBUG
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int s;
		cin >> s;
		int f, w, t;
		cin >> f >> w >> t;
		E.push_back({ w, {f, t} });
	}

	for (int i = 1; i <= n; i++) {
		dist[i] = { INFll, -INFll };
	}
	dist[1] = { 0, 0 };
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < m; j++) {
			int u = E[j].second.second;
			int v = E[j].second.first;
			dist[u] = min(
				dist[u],
				dist[v] + make_pair(E[j].first, E[j].first*E[j].first),
				cmp);
		}
	}
	cout << dist[n].first << ' ' << dist[n].second;
}