#include <bits/stdc++.h>

using namespace std;

const long long MAX_N = 1000000, MAX_M = 1000000, INDEX = 1;
const long long MAX_T = 1000, INF = MAX_N * MAX_T + 1;

struct Edge {
    long long v, t;

    Edge() {
        ;
    }

    Edge(long long v, long long t) {
        this->v = v;
        this->t = t;
    }
};

long long n, m;

bool isUsed[MAX_N + INDEX];

list<Edge> edges[MAX_N + INDEX];

pair<long long, long long> ans[MAX_N + INDEX];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    freopen("trains.in", "rt", stdin);
    freopen("trains.out", "wt", stdout);

    cin >> n >> m;

    long long _1;
    for (long long i = 1; i <= m; i++) {
        cin >> _1;

        long long s, t, f;

        cin >> s >> t >> f;

        edges[s].push_back(Edge(f, t));
        edges[f].push_back(Edge(s, t));
    }

    for (long long i = 1; i <= n; i++) {
        ans[i].first = INF, ans[i].second = 0;
    }

    ans[1].first = 0, ans[1].second = 0;

    for (long long i = 1; i <= 1000 * n; i++) {
        long long s = 0;
//        for (long long j = 1; j <= n; j++) {
//            if (!isUsed[j]) {
//                if (s == 0 || ans[j].first < ans[s].first || ans[j].first == ans[s].first && ans[j].second > ans[s].second) {
//                    s = j;
//                }
//            }
//        }

//        cerr << s << '\n';

//        isUsed[s] = true;

        for (long long j = 1; j <= n; j++) {
//            if (ans[j].first == INF) {
//                continue;
//            }

            s = j;
            for (auto e: edges[s]) {
                if (ans[e.v].first > ans[s].first + e.t || ans[e.v].first == ans[s].first + e.t && ans[e.v].second < ans[s].second + e.t * e.t) {
                    ans[e.v].first = ans[s].first + e.t, ans[e.v].second = ans[s].second + e.t * e.t;
                }
            }
        }
    }

    cout << ans[n].first << ' ' << ans[n].second << endl;

    return 0;
}
