#include <bits/stdc++.h>

using namespace std;

const int MAX_N = 100, MAX_A = 1000, MAX_C = 100, INDEX = 1;
const long long COST = 1000000000, INF = MAX_A * COST + 1;

int n, a, l[MAX_N + INDEX], r[MAX_N + INDEX], c[MAX_N + INDEX];

void solve1() {
    int dp[MAX_A + INDEX];

    dp[0] = 0;

    for (int i = 1; i <= a; i++) {
        dp[i] = -1;
    }

    for (int i = 0; i <= a; i++) {
        if (dp[i] >= 0) {
            for (int j = l[1]; j <= r[1]; j++) {
                dp[i + j] = max(dp[i + j], dp[i] + 1);
            }
        }
    }

    long long t = 0;
    for (int i = 0; i <= a; i++) {
        if (dp[i] >= 0 && i + r[1] > a) {
            t = i;

            break;
        }
    }

    cout << COST * t - c[1] * dp[t] << endl;
}

void solve2() {
    long long dp[MAX_A + INDEX];

    dp[0] = 0;

    for (int i = 1; i <= a; i++) {
        dp[i] = INF;
    }

    for (int i = 0; i <= a; i++) {
        for (int j = 1; j <= n; j++) {
            if (i + (l[j] + r[j]) / 2 <= a) {
                dp[i + (l[j] + r[j]) / 2] = min(dp[i + (l[j] + r[j]) / 2], dp[i] + c[j]);
            }
        }
    }

    long long ans = 0;
    for (int i = 0; i <= a; i++) {
        ans = max(ans, i * COST - dp[i]);
    }

    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();

    freopen("anti.in", "rt", stdin);
    freopen("anti.out", "wt", stdout);

    cin >> n >> a;

    for (int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i] >> c[i];
    }

    if (n == 1) {
        solve1();
    } else {
        solve2();
    }

    return 0;
}
