#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

const int sz = 31;
vector<int> num(sz);

int can(vector<vector<int> >& a, int l, int r, int pos, int num) {
	vector<int> b;
	for (int i = l; i < r; i++) {
		b.push_back(a[i][pos]);
	}
	int pos2 = find(b.begin(), b.end(), 1 - num) - b.begin();
	bool f = false;
	for (int i = 0; i < pos2; i++) {
		if (b[i] != num) f = true;
	}
	for (int i = pos2; i < (int)b.size(); i++) {
		if (b[i] != 1 - num) f = true;
	}
	if (!f) return l + pos2;
	return -1;
}

vector<int> check(vector<vector<int> >& a) {
	int n = (int)a.size();
	vector<int> ans;
	set<int> s;
	s.insert(0);
	s.insert(n);
	for (int i = 0; i < sz; i++) {
		int ans_num = -1;
		for (int num = 0; num < 2; num++) {
			bool f = false;
			for (auto it = ++s.begin(); it != s.end(); it++) {
				auto it2 = it;
				it2--;
				if (can(a, *it2, *it, i, num) == -1) {
					f = true;
					break;
				}
			}
			if (!f) {
				vector<int> n_pos;
				for (auto it = ++s.begin(); it != s.end(); it++) {
					auto it2 = it;
					it2--;
					n_pos.push_back(can(a, *it2, *it, i, num));
				}
				for (int j = 0; j < (int)n_pos.size(); j++) {
					s.insert(n_pos[j]);
				}
				ans_num = num;
				break;
			}
		}
		if (ans_num != -1) {
			ans.push_back(ans_num);
		}
		else {
			return{};
		}
	}
	return ans;
}

vector<int> get_s(int x) {
	long long pw = 1 << (sz - 1);
	vector<int> ans;
	for (int i = 0; i < sz; i++) {
		if (x >= pw) {
			x -= pw;
			ans.push_back(1);
		}
		else {
			ans.push_back(0);
		}
		pw /= 2;
	}
	return ans;
}

int get_num(vector<int> x) {
	if (x.empty()) return -1;
	long long pw = 1 << (sz - 1);
	int ans = 0;
	for (int i = 0; i < sz; i++) {
		ans += x[i] * pw;
		pw /= 2;
	}
	return ans;
}

int main()
{
	int n;
	cin >> n;
	vector<vector<int> > a(n);
	for (int i = 0; i < n; i++) {
		int x;
		cin >> x;
		a[i] = get_s(x);
	}
	int q;
	cin >> q;
	cout << get_num(check(a)) << endl;
	for (int i = 0; i < q; i++) {
		int ind, v;
		cin >> ind >> v;
		a[ind - 1] = get_s(v);
		cout << get_num(check(a)) << endl;
	}
    return 0;
}

