#include <algorithm>
#include <iostream>
#include <iterator>
#include <cstdio>
#include <vector>
#include <set>
using namespace std;
#define int long long
const int INF = 1e10;

struct tree {
	int n;
	vector <int> pref;
	tree(vector <int> & arr) {
		n = arr.size();
		pref.resize(n + 1, 0);
		for (int i = 0; i < n; i++) {
			pref[i + 1] = pref[i] + arr[i];
		}
	}
	int get(int l, int r) {
		return pref[r + 1] - pref[l];
	}
};



signed main() {

	int n, m;
	cin >> n >> m;
	vector <int> A(n + 1, 0);
	vector <int> A_pr(n + 1,0);
	vector <int> B(m + 1, 0);
	vector <int> B_pr(m + 1,0);
	for (int i = 0; i < n; i++) {
		cin >> A[i + 1];
	}
	for (int i = 0; i < n; i++) {
		cin >> A_pr[i + 1];
	}

	for (int i = 0; i < m; i++) {
		cin >> B[i + 1];
	}
	for (int i = 0; i < m; i++) {
		cin >> B_pr[i + 1];
	}

	tree A_tree = tree(A_pr);
	tree B_tree = tree(B_pr);

	int ans = 0;
	pair <int, int> xx = {0, 0};
	pair <int, int> yy = {0, 0};
	for (int i =  0; i <= n; i++) {
		for (int j = i; j <= n; j++) {
			for (int t = 0; t <= m; t++) {
				for (int l = t; l <= m; l++) {
					vector <int> cnt(n + m + 2, 0);
					int prest = 0;
					for (int x = i; x <= j; x++) {
						cnt[A[x]] += 1;
					}
					for (int x = t; x <= l; x++) {
						cnt[B[x]] += 1;
					}
					if (((count(cnt.begin(), cnt.end(), 1) + count(cnt.begin(), cnt.end(), 0)) == (int)cnt.size()) 
						&& (A_tree.get(i, j) + B_tree.get(l, t)) >= ans) {
						ans = (A_tree.get(i, j) + B_tree.get(l, t));
						xx = {i, j};
						yy = {t, l};
					}
				}
			}
		}
	}

	cout << ans << endl;
	cout << xx.first << " " << xx.second << endl;
	cout << yy.first << " " << yy.second << endl;

	return 0;
}