#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

bool is_sorted(vector<long long> a)
{
	int i;
	for (i = 0; i < a.size() - 1; i++)
	{
		if (a[i] > a[i + 1])
			return false;
	}

	return true;
}

vector<long long> ax(vector<long long> a, int xors)
{
	int i;
	vector<long long> res;
	for (i = 0; i < a.size(); i++)
	{
		res.push_back(a[i] ^ xors);
	}

	return res;
}

int main()
{
	long long n, a, i, mx, k, x, q, j;
	vector<long long> arr;

	cin >> n;
	mx = -1;

	for (i = 0; i < n; i++)
	{
		cin >> a;
		arr.push_back(a);
		if (a > mx)
			mx = a;
	}

	bool found = false;

	for (k = 0; k <= mx * 2 + 1; k++)
	{
		found = is_sorted(ax(arr, k));
		if (found)
		{
			cout << k << endl;
			break;
		}
	}

	if (!found)
		cout << "-1" << endl;

	cin >> q;

	for (j = 0; j < q; j++)
	{
		cin >> i >> x;
		i -= 1;
		arr[i] = x;
		if (mx < x)
			mx = x;
		bool found = false;

		for (k = 0; k <= mx * 2 + 1; k++)
		{
			found = is_sorted(ax(arr, k));
			if (found)
			{
				cout << k << endl;
				break;
			}
		}

		if (!found)
			cout << "-1" << endl;
	}


    return 0;
}

