#include <bits/stdc++.h>

using namespace std;

#define forn(i, n) for (int i = 0; i < n; i++)
#define pb push_back
#define mp make_pair
#define sz(a) int(a.size())
#define all(a) a.begin(), a.end()
#define x first
#define y second

typedef long long ll;
typedef pair < int, int > pii;
typedef pair < ll, ll > pll;

const int INF = 2e9;
const ll INF64 = 1e18;
const int N = 200100;

pll operator - (pll a, pll b) {
    return mp(a.x - b.x, a.y - b.y);
}

ll operator % (pll a, pll b) {
    return a.x * b.y - a.y * b.x;
}

ll operator * (pll a, pll b) {
    return a.x * b.x + a.y * b.y;
}

int n, m, ind[N];
pll a[N];
vector < int > b, xx, yy;
set < int > xm, ym;
map < int, vector < int > > xxx, yyy;

bool comp1(int i, int j) {
    return a[i] < a[j];
}

bool comp2(int i, int j) {
    return ind[i] < ind[j];
}

inline void go(vector < int > &b) {
    vector < int > ans;
    ans.pb(b[0]);
    for (int i = 1; i < sz(b); i++) {
        while (sz(ans) > 1) {
            pll aa = a[ans[sz(ans) - 1]], bb = a[ans[sz(ans) - 2]], cc = a[b[i]];
            if ((bb - aa) % (cc - aa) < 0)
                ans.pop_back();
            else
                break;
        }
        ans.pb(b[i]);
    }
    b = ans;
}

inline void build(vector < int > &b) {
    if (sz(b) < 3)
        return;
    /*
    forn(i, sz(b))
        cout << b[i] << ' ';
    cout << endl;
    */
    vector < int > s1, s2;
    s1.pb(b[0]);
    s2.pb(b[0]);
    pll aa = a[b[0]], bb = a[b.back()];
    for (int i = 1; i < sz(b) - 1; i++) {
        pll cc = a[b[i]];
        if ((bb - aa) % (cc - aa) > 0)
            s1.pb(b[i]);
        if ((bb - aa) % (cc - aa) < 0)
            s2.pb(b[i]);
    }
    s1.pb(b.back());
    s2.pb(b.back());
    reverse(all(s2));
    go(s1);
    go(s2);
    b.clear();
    for (int i = 0; i < sz(s1); i++)
        b.pb(s1[i]);
    for (int i = 1; i < sz(s2) - 1; i++)
        b.pb(s2[i]);
    /*
    forn(i, sz(b))
        cout << b[i] << ' ';
    cout << endl;
    */
}

inline bool get(vector < int > &b) {
    cout << "? " << sz(b) << ' ';
    forn(i, sz(b))
        cout << b[i] << ' ';
    cout << endl;
    string ans;
    cin >> ans;
    if (ans == "Yes")
        return 1;
    return 0;
}

inline bool check(int lx, int rx, int ly, int ry) {
    lx = xx[lx]; rx = xx[rx]; ly = yy[ly]; ry = yy[ry];
    vector < int > bb;
    forn(i, n) {
        pll p = a[b[i]];
        if (p.x >= lx && p.x <= rx && p.y >= ly && p.y <= ry)
            bb.pb(b[i]);
    }
    if (sz(bb) < 3)
        return 0;
    build(bb);
    return get(bb);
}

inline void solve() {
    int lx = 0, rx = sz(xx) - 1,
        ly = 0, ry = sz(yy) - 1;
    int l, r;
    // ================ lx
    l = lx, r = rx;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(m, rx, ly, ry))
            l = m;
        else
            r = m;
    }
    lx = l;
    // ================ rx
    l = lx, r = rx;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(lx, m, ly, ry))
            r = m;
        else
            l = m;
    }
    rx = r;
    // ================ ly
    l = ly, r = ry;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(lx, rx, m, ry))
            l = m;
        else
            r = m;
    }
    ly = l;
    // ================ ry
    l = ly, r = ry;
    while (r - l > 1) {
        int m = (l + r) / 2;
        if (check(lx, rx, ly, m))
            r = m;
        else
            l = m;
    }
    ry = r;
    // ===================
    vector < int > w;
    lx = xx[lx]; rx = xx[rx]; ly = yy[ly]; ry = yy[ry];
    for (int v : xxx[lx])
        w.pb(v);
    for (int v : xxx[rx])
        w.pb(v);
    for (int v : yyy[ly])
        w.pb(v);
    for (int v : yyy[ry])
        w.pb(v);
    sort(all(w));
    w.erase(unique(all(w)), w.end());
    //cout << "------   " << xx[lx] << ' ' << xx[rx] << "   ==   " << yy[ly] << ' ' << yy[ry] << endl;
    sort(all(w), comp2);

    cout << "! " << sz(w) << ' ';
    for (int v : w)
        cout << v << ' ';
    cout << endl;
}

int main() {
    cin >> n;
    for (int i = 1; i <= n; i++) {
        cin >> a[i].x >> a[i].y;
        xxx[a[i].x].pb(i);
        yyy[a[i].y].pb(i);
        if (!xm.count(a[i].x)) {
            xm.insert(a[i].x);
            xx.pb(a[i].x);
        }
        if (!ym.count(a[i].y)) {
            ym.insert(a[i].y);
            yy.pb(a[i].y);
        }
        b.pb(i);
    }
    sort(all(xx)); sort(all(yy));
    // ========================
    sort(all(b), comp1);
    forn(i, sz(b))
        ind[b[i]] = i;
    cin >> m;
    forn(u, m) {
        solve();
    }
    return 0;
}



/*

6
3 0
0 2
2 4
4 2
5 5
6 1
4


*/
