#include <iostream>
#include <string>
#include <vector>
#include <bitset>
#include <algorithm>
#include <set>

using namespace std;

const long long INF = 1000000000113;

struct edge {
	int a, b, cost;
};

vector <edge> e;

long long d[100113], ans[100113];

int main() {
	long long n, m;

	cin >> n >> m;

	for (long long i = 0; i < m; i++) {
		long long p, u, w, v;

		cin >> p >> u >> w >> v;

		edge ed;

		ed.a = u;
		ed.b = v;
		ed.cost = w;

		e.push_back(ed);
	}

	for (int i = 1; i <= n; i++)
		d[i] = INF;

	d[1] = 0;

	for (int i = 0; i < n - 1; i++)
		for (int j = 0; j < m; j++) 
			if (d[e[j].b] >= d[e[j].a] + e[j].cost && ans[e[j].b] < ans[e[j].a] + e[j].cost * e[j].cost) {
				d[e[j].b] = d[e[j].a] + e[j].cost;
				ans[e[j].b] = ans[e[j].a] + e[j].cost * e[j].cost;
			}

	cout << d[n] << ' ' << ans[n];
	return 0; 
}