#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <string>
#define X first
#define Y second
typedef long long ll;

using namespace std;
const ll MAXA = 100000;
const ll INF = 1e18;
const ll MAXN = 100;
ll dp[MAXA];
bool good[MAXA], good2[MAXA];
const ll sto = 1e9;
ll n, a;

struct ST {
	vector<ll> v;
	vector<ll> vv;
	ll n;
	ll step;
	void init(ll n,ll stp) {
		v.resize(4 * n);
		vv.resize(4 * n);
		step = stp;
		this->n = n;
	}

	void set(ll pos, ll val, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (tr - tl == 1 && tl == pos) {
			vv[ver] = val;
			return void(v[ver] = val + step*tl);
		}
		ll tm = (tl + tr) / 2;
		if (pos < tm)
			set(pos, val, ver * 2 + 1, tl, tm);
		else set(pos, val, ver * 2 + 2, tm, tr);
		v[ver] = min(v[ver * 2 + 1], (tr-tm)*sto + v[ver * 2 + 2]);
	}

	ll get(ll l, ll r, ll ver = 0, ll tl = 0, ll tr = -1) {
		if (tr == -1)
			tr = n;
		if (l >= tr || r <= l)
			return INF;
		if (tl == l && tr == r)
			return v[ver];
		ll tm = (tl + tr) / 2;
		ll ret = get(l, min(r, tm), ver * 2 + 1, tl, tm);
		ll ret2 = get(max(l, tm), r, ver * 2 + 2, tm, tr);
		return min(ret, ret2);
	}
	ll get2(ll pos, ll ver = 0, ll tl=0, ll tr=-1) {
		if (tr == -1)
			tr = n;
		if (tr - tl == 1)
			return vv[ver];
		ll tm = (tl + tr) / 2;
		if (pos < tm)
			return get2(pos, ver * 2 + 1, tl, tm);
		return get2(pos, ver * 2 + 2, tm, tr);
	}
} tr;


vector < pair<pair<ll, ll>, ll> > v;
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> a;
	v.resize(n);
	for (ll i = 0; i < n; i++)
		cin >> v[i].X.X >> v[i].X.Y >> v[i].Y;
	tr.init(a + 1, 1e9);
	for (ll i = 0; i <= a; i++)
		tr.set(i, 0);
	for (ll i = a; i >= 0; i--) {
		for (ll j = 0; j < n; j++) {
			ll ret = 1e18;
			if (v[j].X.Y + i>a)
				continue;
			ret = tr.get(i+v[j].X.X, i+v[j].X.Y + 1) - v[j].Y-sto*i;
			tr.set(i, max(tr.get2(i), ret));
		}
	}
	cout<<tr.get2(0);
	return 0;
}