#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main()
{
	int n, m;
	cin >> n >> m;
	vector<pair<long long, long long>> a(n), b(m);
	for (int i = 0; i < n; ++i)
		cin >> a[i].first;
	for (int i = 0; i < n; ++i)
		cin >> a[i].second;
	for (int i = 0; i < m; ++i)
		cin >> b[i].first;
	for (int i = 0; i < m; ++i)
		cin >> b[i].second;
	pair<pair<int, int>, pair<int, int>> ans = { {0, 0}, {0, 0 } };
	long long mx = 0;
	for (int i = 0; i < n; ++i)
	{
		set<int> s;
		long long cnt = 0;
		for (int j = i; j < n; ++j)
		{
			cnt += a[j].second;
			s.insert(a[j].first);
			for (int i2 = 0; i2 < m; ++i2)
			{
				long long cnt2 = 0;
				int j2;
				for (j2 = i2; j2 < m && !s.count(b[j2].first); ++j2)
					cnt2 += b[j2].second;
				if (cnt + cnt2 > mx)
				{
					mx = cnt + cnt2;
					ans.first = make_pair(i + 1, j + 1);
					if (j2 == i2)
						ans.second = { 0, 0 };
					else
						ans.second = { i2 + 1, j2 };
				}
			}
		}
	}
	long long cnt = 0;
	for (int i = 0; i < m; ++i)
		cnt += b[i].second;
	if (cnt > mx)
	{
		mx = cnt;
		ans.first = { 0, 0 };
		ans.second = { 1, m };
	}
	cout << mx << endl;
	cout << ans.first.first << ' ' << ans.first.second << endl;
	cout << ans.second.first << ' ' << ans.second.second << endl;
    return 0;
}

