#include <iostream>
#include <algorithm>
#include <string>
#include <vector>

using namespace std;

#define int long long
#define mp make_pair

const int p = 1000000000;
const int inf = p * 2000000 + 100;

struct node
{
	int l, r, c;
	node() {}
};

int d1[2000001];

int solve1(int n, int l, int r, int c)
{
	if (d1[n] != -1)
		return d1[n];
	if (n >= r)
	{
		int ans = inf;
		for (int i = l; i <= r; i++)
			ans = min(ans, solve1(n - i, l, r, c) + i * p - c);
		return d1[n] = ans;
	}
	else
		return d1[n] = 0;
}

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, a;

	cin >> n >> a;

	vector<node> typs(n);

	bool p1 = true;
	for (int i = 0; i <= 2000000; i++)
		d1[i] = -1;
	for (int i = 0; i < n; i++)
	{
		cin >> typs[i].l >> typs[i].r >> typs[i].c;
		if (typs[i].l != typs[i].r)
			p1 = false;
	}

	if (n == 1)
	{
		cout << solve1(a, typs[0].l, typs[0].r, typs[0].c);
		return 0;
	}

	if (p1)
	{
		vector<int> c(n), w(n);
		for (int i = 0; i < n; i++)
		{
			for (int j = 0; j <= a / typs[i].l + 1; j++)
			{
				c.push_back(p * typs[i].l - typs[i].c);
				w.push_back(typs[i].l);
			}
		}

		int m = a;
		n = c.size();

		vector<vector<int>> dp(n + 1, vector<int>(m + 1, 0));
		for (int i = 1; i <= n; i++)
		{
			for (int j = 0; j <= m; j++)
			{
				dp[i][j] = dp[i - 1][j];
				if (j - w[i - 1] >= 0)
					dp[i][j] = max(dp[i][j], dp[i - 1][j - w[i - 1]] + c[i - 1]);
			}
		}
		cout << dp[n][m];
	}


	system("pause");
}