#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <cstring>

using namespace std;

const int INF = 1e+9 + 1000;

bool rec(int s, int t0, vector<int> &l, vector<int> &r, vector<int> & t) {
    int n = l.size() + 1;
    int t_n = t0;
    for (int i = s; i > 0; --i) {
        //cerr << t_n << " " << l[i - 1] << " " << r[i - 1] << endl;
        if (t_n > r[i - 1])
            return false;
        if (t_n + t[i] < l[i - 1])
            return false;
        if (t_n < l[i - 1])
            t_n = l[i - 1];
        else
            t_n = t_n;
    }
    t_n = t0;
    for (int i = s; i < n - 1; ++i) {
        if (t_n > r[i])
            return false;
        if (t_n + t[i] < l[i])
            return false;
        if (t_n < l[i])
            t_n = l[i];
        else
            t_n = t_n;
    }
    return true;
}

int main() {
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    //freopen("errput.txt", "w", stderr);
    int n;
    cin >> n;
    if (n == 1) {
        cout << "0";
        return 0;
    }
    vector<int> t(n);
    for (int i = 0; i < n; ++i)
        cin >> t[i];
    vector<int> l(n - 1);
    vector<int> r(n - 1);
    for (int i = 0; i < n - 1; ++i) {
        cin >> l[i] >> r[i];
    }
    for (int i = 0; i < n; ++i) {
        bool q = true;
        for (int j = 0; j < 1000; ++j) {
            //cerr << i << " " << j << ":::::::::" << endl;
            if (rec(i, j, l, r, t)) {
                cout << j << endl;
                q = false;
                break;
            }
        }
        if (q)
            cout << -1 << endl;
    }
    return 0;
}
