#include <iostream>
#include <vector>

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

vector<char> result;

void parse(int l, int r) {
    if (r < l) {
        return;
    }
    result[l - 1] = '(';
    result[r - 1] = ')';
    if (r == l + 1) {
        return;
    }
    cout << "? " << l + 1 << " " << r - 1 << endl;
    string ans;
    cin >> ans;

    if (ans == "Yes") {
        parse(l + 1, r - 1);
    } else {
        if (r - l > 3) {
            if (rand() % 2 == 0) {
                for (int i = l + 1; i < r; i += 2) {
                    cout << "? " << l << " " << i << endl;
                    cin >> ans;
                    if (ans == "Yes") {
                        result[i - 1] = ')';
                        parse(l + 1, i - 1);
                        parse(i + 1, r);
                        break;
                    }
                }
            } else {
                for (int i = r - 1; i > l; i -= 2) {
                    cout << "? " << i << " " << r << endl;
                    cin >> ans;
                    if (ans == "Yes") {
                        result[i - 1] = '(';
                        parse(l, i - 1);
                        parse(i + 1, r - 1);
                        break;
                    }
                }
            }
        } else {
            result[l] = ')';
            result[l + 1] = '(';
        }
    }
}

int main() {

    int n;
    srand(219637);
    cin >> n;
    result = vector<char>(n);

    parse(1, n);
    cout << "! ";
    for (char c : result) {
        cout << c;
    }
    cout << endl;

    return 0;

}
#pragma clang diagnostic pop