#include <iostream>
#include <vector>
#include <set>

#define long long long

#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wsign-conversion"
using namespace std;

int main() {

    freopen("internship.in", "r", stdin);
    freopen("internship.out", "w", stdout);
    ios::sync_with_stdio(false);
    cout.tie(0);

    int n, m;
    scanf("%d%d", &n, &m);
    vector<int> a(n), x(n), b(m), y(m);
    for (int i = 0; i < n; i++) {
        scanf("%d", &a[i]);
    }
    for (int i = 0; i < n; i++) {
        scanf("%d", &x[i]);
    }
    for (int i = 0; i < m; i++) {
        scanf("%d", &b[i]);
    }
    for (int i = 0; i < m; i++) {
        scanf("%d", &y[i]);
    }

    long res = 0;
    set<int> taken;
    int la = 0, ra = 0, lb = 0, rb = 0;
    for (int l = 0; l < n; l++) {
        taken.clear();
        long sum = 0;
        for (int r = l; r <= n; r++) {
            for (int ll = 0; ll < m; ll++) {
                int rr = ll;
                long sum1 = sum;
                while (rr < m && taken.count(b[rr]) == 0) {
                    sum1 += y[rr];
                    rr++;
                }

                if (sum1 > res) {
                    res = sum1;
                    if (r > l) {
                        la = l + 1;
                        ra = r;
                    } else {
                        la = 0;
                        ra = 0;
                    }
                    if (rr > ll) {
                        lb = ll + 1;
                        rb = rr;
                    } else {
                        lb = 0;
                        rb = 0;
                    }
                }
            }

            if (r < n) {
                taken.insert(a[r]);
                sum += x[r];
            }
        }
    }

    cout << res << '\n' << la << ' ' << ra << '\n' << lb << ' ' << rb << '\n';

    return 0;

}

#pragma clang diagnostic pop