#include <iostream>
#include <vector>
#include <set>

using namespace std;

int main() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n), x(n), b(m), y(m);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < n; i++) cin >> x[i];
    for (int i = 0; i < m; i++) cin >> b[i];
    for (int i = 0; i < m; i++) cin >> y[i];

    long long ans = 0, current = 0, firstSum = 0;
    int topleft = 0, topright = 0, bottomleft = 0, bottomright = 0,
        start = 0, left = -1, right = -1;
    set<int> first;

    for (int i = 0; i <= m; i++) {
        if (i == m || first.find(b[i]) != first.end()) {
            if (start < i) {
                if (current > ans) {
                    ans = current;
                    topleft = left;
                    topright = right;
                    bottomleft = start;
                    bottomright = i - 1;
                }
                current = firstSum;
            }
            start = i + 1;
        } else
            current += y[i];
    }

    for (left = 0; left < n; left++) {
        first.clear();
        firstSum = 0;
        for (right = left; right < n; right++) {
            firstSum += x[right];
            first.insert(a[right]);

            if (firstSum > ans) {
                ans = firstSum;
                topleft = left;
                topright = right;
                bottomleft = -1;
                bottomright = -1;
            }

            current = firstSum;
            start = 0;
            for (int i = 0; i <= m; i++) {
                if (i == m || first.find(b[i]) != first.end()) {
                    if (start < i) {
                        if (current > ans) {
                            ans = current;
                            topleft = left;
                            topright = right;
                            bottomleft = start;
                            bottomright = i - 1;
                        }
                        current = firstSum;
                    }
                    start = i + 1;
                } else
                    current += y[i];
            }

        }
    }

    cout << ans << endl;
    cout << topleft + 1 << ' ' << topright + 1 << endl;
    cout << bottomleft + 1 << ' ' << bottomright + 1 << endl;

    return 0;
}