#pragma comment(linker, "/Stack:512000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <algorithm>
#include <unordered_map>
#include <unordered_set>

using namespace std;

typedef long long LL;

const int MAXB = 5;
const int MAXN = (int)1e6 + 100;

int a[MAXN];
int n;

int must0[MAXB], must1[MAXB];
set<int> changes[MAXB];


inline int BIT(int a, int b) {
  return (a & (1 << b)) >> b;
}

bool findB(int bit, int L, int R) {
  if (bit < 0 || L >= R) return 1;

  int prev = L;
  for (int i = L; i < R; ++i) {
    if (i != L && BIT(a[i], bit) < BIT(a[i - 1], bit)) {
      ++must1[bit];
      findB(bit - 1, prev, i);
      prev = i;
    }
    if (i != L && BIT(a[i], bit) > BIT(a[i - 1], bit)) {
      ++must0[bit];
      findB(bit - 1, prev, i);
      prev = i;
    }
  }

  findB(bit - 1, prev, R);
}

int calcB() {
  for (int i = 0; i < MAXB; ++i) {
    must0[i] = must1[i] = 0;
    changes[i].insert(0);
    changes[i].insert(n);
  }

  findB(MAXB - 1, 0, n);
  int B = 0;
  for (int i = 0; i < MAXB; ++i) {
    if (must0[i] > 0 && must1[i]) return -1;
    if (must1[i]) B |= 1 << i;
  }
  return B;
}

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "order"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  
  scanf("%d", &n);
  for (int i = 0; i < n; ++i) {
    scanf("%d", &a[i]);
  }

  int B = calcB();
  printf("%d\n", B);

  int q;
  scanf("%d", &q);

  for (int i = 0; i < q; ++i) {
    int p, v;
    scanf("%d%d", &p, &v);
    a[p - 1] = v;
    B = calcB();
    printf("%d\n", B);
  }
  return 0;
}