#pragma comment(linker, "/Stack:512000000")
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cstdio>
#include <cmath>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <queue>

using namespace std;

typedef long long LL;

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#elif 1
# define PROB "internship"
  freopen(PROB".in", "r", stdin);
  freopen(PROB".out", "w", stdout);
#endif
  cin.tie(0);
  cin.sync_with_stdio(0);

  int n, m;
  cin >> n >> m;

  vector<int> a(n), b(m);
  vector<int> x(n), y(m);

  for (int i = 0; i < n; ++i) {
    cin >> a[i];
    --a[i];
  }
  for (int i = 0; i < n; ++i)
    cin >> x[i];

  for (int i = 0; i < m; ++i) {
    cin >> b[i];
    --b[i];
  }
  for (int i = 0; i < m; ++i)
    cin >> y[i];

  vector<char> used(n + m);

  LL ans = 0;
  int ansi = -1, ansj = -1, ansilen = 0, ansjlen = 0;

  LL sum = 0;
  for (int i = 0; i < n; ++i)
    sum += x[i];

  if (sum > ans) {
    ans = sum;
    ansi = 0, ansilen = n - 1;
    ansj = -1, ansjlen = -1;
  }

  sum = 0;
  for (int i = 0; i < m; ++i)
    sum += y[i];

  if (sum > ans) {
    ans = sum;
    ansi = -1, ansilen = -1;
    ansj = 0, ansjlen = m - 1;
  }

  sum = 0;

  for (int i = 0; i < n; ++i) {
    for (int j = 0; j < m; ++j) {
      sum = 0;
      used.assign(n + m, 0);
      for (int k = i; k < n; ++k) {
        sum += x[k];
        used[a[k]] = 1;
      }
      int u = j;

      for (int k = n - 1; k > i; --k) {
        sum -= x[k];
        used[a[k]] = 0;
        
        while (u < m && !used[b[u]]) {
          sum += y[u];
          used[b[u]] = 1;
          u++;
        }

        if (sum > ans) {
          ans = sum;
          ansi = i;
          ansilen = k - 1;
          ansj = j;
          ansjlen = u - 1;
        }
      }
    }
  }

  cout << ans << '\n';
  cout << ansi + 1 << ' ' << ansilen + 1 << '\n';
  cout << ansj + 1 << ' ' << ansjlen + 1 << '\n';

  return 0;
}