#pragma GCC optimize "-O3" 
#include <bits/stdc++.h>


using namespace std;


template<typename T1, typename T2>inline void chkmin(T1 &x, T2 y) {if (x > y) x = y;}
template<typename T1, typename T2>inline void chkmax(T1 &x, T2 y) {if (x < y) x = y;}
#define all(c) (c).begin(), (c).end()
#define sz(c) (int)(c).size()
const int MAXN = 5001;
const long long INF = 10000000000LL;


struct point
{
	long long x, y;
	point(){}
	point(long long _x, long long _y) {
		x = _x;
		y = _y;
	}
};


long long operator ^(const point &a, const point &b) {
	return a.x * b.y - a.y * b.x;
}

long long operator *(const point &a, const point &b) {
	return (b.x - a.x) * (b.x - a.x) + (b.y - a.y) * (b.y - a.y);
}


point operator -(const point &a, const point &b) {
	return point(a.x - b.x, a.y - b.y);
}


point operator +(const point &a, const point &b) {
	return point(a.x + b.x, a.y + b.y);
}


int n;
point p[MAXN];
bool good[MAXN];
point t;




bool comp(const int &a, const int &b) {
	long long f = (p[a] - t) ^ (p[b] - t);
	if (f == 0LL) {
		return (t * p[a]) < (t * p[b]);
	} else {
		return f < 0;
	}
}


inline void getob(vector<int> &g, vector<int> &st) {
	if (sz(g) != n) {
		t = point(INF, INF);
		for (auto b: g) {
			if (p[b].y < t.y || (p[b].y == t.y && p[b].x < t.x)) {
				t = p[b];
			}
		}
		sort(all(g), comp);
	}
	g.push_back(g[0]);
	for (int i = 0; i < sz(g); i++) {;
		if (sz(st) < 2) {
			if (i != sz(g) - 1) st.push_back(g[i]);
		} else {
			while (sz(st) >= 2 && ((p[g[i]] - p[st[sz(st) - 2]]) ^ (p[st.back()] - p[st[sz(st) - 2]])) < 0) {
				st.pop_back();
			}
			if (i != sz(g) - 1) st.push_back(g[i]);
		}
	}
	g.pop_back();
}


vector<int> ng;


int main() {
	ios_base::sync_with_stdio(false);
	vector<int> g;
	cin >> n;
	g.resize(n);
	for (int i = 1; i <= n; i++) {
		cin >> p[i].x >> p[i].y;
		g[i - 1] = i;
	}
	t = point(INF, INF);
	for (auto b: g) {
		if (p[b].y < t.y || (p[b].y == t.y && p[b].x < t.x)) {
			t = p[b];
		}
	}
	sort(all(g), comp);
	vector<int> g1 = g;
	int q;
	cin >> q;
	for (int it = 0; it < q; it++) {
		while (true) {
			vector<int> s;
			getob(g, s);
			if (sz(s) == sz(g)) {
				cout << "! " << sz(s);
				for (auto x: s) {
					cout << ' ' << x;
		 		}
		 		cout << endl;
				break;
			}
			if (sz(s) > 6) {
				int pos = rand() % sz(s);
				int npos = (pos + sz(s) / 2) % sz(s);
				if (pos > npos) {
					swap(pos, npos);
				}
				if (npos - pos + 1 <= 2) {
					if (npos < sz(s) - 1) {
						npos++;
					} else {
						pos--;
					}
				}
				cout << "? " << npos - pos + 1;
				for (int i = pos; i <= npos; i++) {
					cout << ' ' << s[i];
				}
				cout << endl;
				string ans;
				cin >> ans;
				ng.clear();
				if (ans == "Yes") {
					for (int i = 0; i < sz(g); i++) {
						if (((p[g[i]] - p[s[pos]]) ^ (p[s[npos]] - p[s[pos]])) <= 0LL) {
							ng.push_back(g[i]);
						}
					}
					swap(g, ng);
				} else {
					for (int i = 0; i < sz(g); i++) {
						if (((p[g[i]] - p[s[pos]]) ^ (p[s[npos]] - p[s[pos]])) >= 0LL) {
							ng.push_back(g[i]);
						}
					}
					swap(g, ng);
				}
				continue;
			}
			vector<int> ttt;
			ttt.push_back(0);
			ttt.push_back(1);
			ttt.push_back(2);
			random_shuffle(all(ttt));
			for (auto i: ttt) {
				if (!good[s[i]]) {
					ng.clear();
					for (auto x: g) {
						if (x != s[i]) {
							ng.push_back(x);
						}
					}
					vector<int> s1; 
					getob(ng, s1);
					cout << "? " << sz(s1);
					for (auto i1: s1) {
						cout << ' ' << i1;
					}
					cout << endl;
					string ans;
					cin >> ans;
					if (ans == "Yes") {
						swap(g, ng);
						break;
					}
					good[s[i]] = 1;
				}
			}
		}
		if (it != q - 1) {
			g = g1;
			memset(good, 0, sizeof(good));
		}
	}
	return 0;
}

