#include <iostream>
#include <stdio.h>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;

template<class T>
void prll(vector<T> s){
    for (ll i = 0; i < s.size(); i++)
        cout << s[i] << " ";
    cout << endl;

}

const ll INF = 2 * 1e9;

vector<ll> pref;
vector<ll> used;
vector<pair<ll, ll> > s1;
vector<pair<ll, ll> > s2;
vector<ll> lst;


ll check(ll l, ll r){
    for (ll i = 0; i < used.size(); i++)
        used[i] = 0;
    if (l > -1){
        for (ll i = l; i < r; i++)
            used[s1[i].first] = 1;
    }
    lst.clear();
    lst.push_back(-1);
    for (ll i = 0; i < s2.size(); i++){
        if (used[s2[i].first] == 1)
            lst.push_back(i);
    }
    lst.push_back(s2.size());
    ll answer = 0;
    for (ll i = 1; i < lst.size(); i++){
        answer = max(answer, pref[lst[i]] - pref[lst[i - 1] + 1]);
    }
    for (ll i = l; i < r; i++)
        answer += s1[i].second;
    return answer;
}


pair<ll, ll> check2(ll l, ll r){
    for (ll i = 0; i < used.size(); i++)
        used[i] = 0;
    if (l > -1){
        for (ll i = l; i < r; i++)
            used[s1[i].first] = 1;
    }
    lst.clear();
    lst.push_back(-1);
    for (ll i = 0; i < s2.size(); i++){
        if (used[s2[i].first] == 1)
            lst.push_back(i);
    }
    lst.push_back(s2.size());
    ll answer = 0;
    ll ll = -1, rr = -1;
    for (int i = 1; i < lst.size(); i++){
        if (pref[lst[i]] - pref[lst[i - 1] + 1] > answer){
            answer = max(answer, pref[lst[i]] - pref[lst[i - 1] + 1]);
            ll = lst[i - 1] + 1;
            rr = lst[i] - 1;
        }
    }
    for (int i = l; i < r; i++)
        answer += s1[i].second;
    return make_pair(ll, rr);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef ONLINE_JUDGE
        freopen("test.in", "r", stdin);
    #endif // ONLINE_JUDGE
    ll n, m;
    cin >> n >> m;
    s1.resize(n);
    for (ll i = 0; i < n; i++)
        cin >> s1[i].first;
    for (ll i = 0; i < n; i++)
        cin >> s1[i].second;
    s2.resize(m);
    for (ll i = 0; i < m; i++)
        cin >> s2[i].first;
    for (ll i = 0; i < m; i++)
        cin >> s2[i].second;
    used.resize(n + m + 1);
    vector<ll> lst;
    pref.resize(m + 1);
    for (ll i = 0; i < m; i++)
        pref[i + 1] = pref[i] + s2[i].second;
    ll l = -1, r = -1;
    ll answer = check(-1, -1);
    for (ll i = 0; i < n; i++){
        for (ll j = 0; j <= i; j++){
            ll answer1 = check(j, i + 1);
            if (answer1 > answer){
                answer = answer1;
                l = j;
                r = i;
            }
        }
    }
    cout << answer << endl;
    pair<ll, ll> ans = check2(l, r + 1);
    cout << l + 1 << " " << r + 1 << endl;
    cout << ans.first + 1 << " " << ans.second + 1 << endl;
    return 0;
}
