#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define vec vector
#define pb push_back

const int N = 1001;
const ll INF = 1e18;

int main() {
    freopen("anti.in", "r", stdin);
    freopen("anti.out", "w", stdout);

    ll n, a;
    ll l, r, x;
    cin >> n >> a >> l >> r >> x;

    vec<vec<ll> > dp(a + 1, vec<ll>(a + 1, -INF));
    dp[0][0] = 0;
    int last = 0;
    for (int k = 0; k < a + 1; k++)  {
        for (int i = 0; i < a; i++) {
            if (k + r > a || dp[k][i] == -INF) { continue; }
            for (int j = l; j <= r; j++) {
                dp[k + j][i + 1] = max(dp[k][i] + x, dp[k + j][i + 1]);
                if (dp[k + j][i + 1] != -INF) { last = i + 1; }
            }
        }
    }

    ll ans = INF;
    for (int k = 0; k <= a; k++) {
        for (int i = 0; i <= a; i++) {
            if (dp[k][last] == -INF) { continue; }
            ll d = 1e9 * k - dp[k][i];
            ans = min(ans, d);
        }
    }
    cout << ans << '\n';
    return 0;
}
