#include <iostream>
#include <math.h>
#include <algorithm>
#include <set>

using namespace std;


int matc[3000][3000];
set<int> mat[3000];

struct paintrain{

	_CONST_FUN bool operator()(const pair<int, pair<int, int> >& _Left, const pair<int, pair<int, int> >& _Right) const
	{	// apply operator< to operands
		return ((_Left.second.first < _Right.second.first) || ((_Left.second.first == _Right.second.first) && (_Left.second.second > _Right.second.second))) || (((_Left.second.first == _Right.second.first) && (_Left.second.second == _Right.second.second))&&_Left.first>_Right.first);
	}
};

int done[3000];

int bestmin[3000];
int bestmax[3000];


int main() {
#ifdef _DEBUG
	freopen("test.in", "r", stdin);
#endif
	int n, m;
	scanf("%d%d", &n, &m);
	for (int i = 0; i < m; ++i)
	{
		int si;
		scanf("%d", &si);
		int a,c,b;
		scanf("%d%d%d", &a,&c, &b);
		--a;
		--b;
		mat[a].insert(b);
		if(matc[a][b]==0)
		matc[a][b] = c;
		matc[a][b] = min(c, matc[a][b]);
	}

	set<pair<int, pair<int,int>>, paintrain> que;
	
	que.insert({ 0,{ 0,0 } });

	while (que.size() != 0) {
		auto a = *que.begin();
		que.erase(que.begin());
		done[a.first] = 1;
		for (auto i : mat[a.first]) {
			if (done[i])
				continue;
			if ((bestmin[i] == 0 || bestmin[i] > bestmin[a.first] + matc[a.first][i])||
				((bestmin[i] == bestmin[a.first] + matc[a.first][i])&&bestmax[i]<bestmax[a.first] + matc[a.first][i]*matc[a.first][i]))
			{
				que.erase({ i,{ bestmin[i] ,bestmax[i] } });
				bestmin[i] = bestmin[a.first] + matc[a.first][i];
				bestmax[i] = bestmax[a.first] + matc[a.first][i] * matc[a.first][i];
				que.insert({ i,{ bestmin[i] ,bestmax[i] } });

			}
		}

	}
	cout << bestmin[n - 1] << ' ' << bestmax[n - 1];
	return 0;
}